use strict;
#------------------------------------------------------------------------------
# default parser ʸϥѥ
#						(C)2006-2009 nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::Base::Compiler;
our $VERSION = '1.28';

###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ} = shift;

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ᥤ롼
###############################################################################
#------------------------------------------------------------------------------
# ѥ
#------------------------------------------------------------------------------
# compile( \@source_lines );
#
#
sub compile {
	my ($self, $lines, $debugfile) = @_;
	# 顼¸ΰ
	$self->{errors}    = 0;
	$self->{error_msg} = [];

	# ϥǡå
	if (ref $lines ne 'ARRAY') {
		$self->error(undef, 'To complile array only');
		return (-1);	# ̿Ū顼
	}
	
	# ץץå
	my ($buf, $line_no, $strbuf) = $self->preprocessor($lines);
	if ($debugfile ne '') { $self->debug_save("${debugfile}_01.log", $buf, $line_no, $strbuf); }

	# եݡɵˡѴ
	$self->convert_reversed_poland($buf, $line_no);
	if ($debugfile ne '') { $self->debug_save("${debugfile}_02.log", $buf, $line_no, $strbuf); }

	# eval ¹ԼѴfrom եݡɵˡ, ʸɾ
	my $line_info = $self->poland_to_eval($buf, $line_no, $strbuf);
	if ($debugfile ne '') { $self->debug_save("${debugfile}_03.log", $buf, $line_no, $strbuf); }

	# ǽʸ򸵤ᤷbegin֥å
	my $arybuf = $self->split_begin_block($buf, $strbuf);
	if ($debugfile ne '') { $self->debug_save("${debugfile}_04.log", $buf, undef, $strbuf, $arybuf); }

	# Ŭ
	$arybuf = $self->optimize($arybuf);
	if ($debugfile ne '') { $self->debug_save("${debugfile}_05.log", undef, undef, $strbuf, $arybuf); }

	# ֥å򥵥֥롼Ѵ
	$arybuf = $self->array2sub($arybuf);
	if ($debugfile ne '') { $self->debug_save("${debugfile}_06.log", undef, undef, $strbuf, $arybuf); }

	# ǽʸ򸵤᤹
	$arybuf = $self->recover_string($arybuf, $strbuf);
	if ($debugfile ne '') { $self->debug_save("${debugfile}_07.log", undef, undef, [], $arybuf); }

	return ($self->{errors}, $arybuf);
}
###############################################################################
# 黻ҥǡ
###############################################################################
#------------------------------------------------------------------------------
# ץ饰
#------------------------------------------------------------------------------
my $p_ctab2blank     = 0x0001;	# ޥɼ֤Τߤξ硢
my $p_cspace2blank   = 0x0002;	# ޥɼʸ\sˤΤߤξ
my $p_delcr_aftercmd = 0x0004;	# ޥɹԤ³Ԥ
my $p_nocr           = 0x0010;	# Ԥ
my $p_cmd_only       = 0x0020;	# ޥɰʳ̵

#------------------------------------------------------------------------------
# 黻Ҿ
#------------------------------------------------------------------------------
my %operators;		# ͥ
my %op_formalname;	# 黻̾¸ߤΤΤߡ
# bit 0 - 麸
# bit 1 - ñ黻
# bit 2 - reserved
# bit 3 - reserved
# bit 412 - 黻ͥ
$operators{'('}   =  0x00;
$operators{')'}   =  0x00;
$operators{'%r'}  =  0x00;	# 㳰
$operators{';'}   =  0x00;
$operators{','}   =  0x10;	# 㳰
$operators{'='}   =  0x21;
$operators{'+='}  =  0x21;
$operators{'-='}  =  0x21;
$operators{'*='}  =  0x21;
$operators{'/='}  =  0x21;
$operators{'%='}  =  0x21;
$operators{'&='}  =  0x21;
$operators{'|='}  =  0x21;
$operators{'%.='} =  0x21; $op_formalname{'%.='} = '.=';
$operators{'**='} =  0x21;
$operators{'<<='} =  0x21;
$operators{'>>='} =  0x21;
$operators{'&&='} =  0x21;
$operators{'||='} =  0x21;
$operators{'||'}  =  0x30;
$operators{'&&'}  =  0x40;
$operators{'|'}   =  0x50;
$operators{'^'}   =  0x60;
$operators{'&'}   =  0x70;
$operators{'=='}  =  0x80;
$operators{'!='}  =  0x80;
$operators{'<=>'} =  0x80;
$operators{'%e'}  =  0x80; $op_formalname{'%e'} = 'eq';
$operators{'%n'}  =  0x80; $op_formalname{'%n'} = 'ne';
$operators{'<'}   =  0x90;
$operators{'>'}   =  0x90;
$operators{'<='}  =  0x90;
$operators{'>='}  =  0x90;
$operators{'%d'}  =  0xa2; $op_formalname{'%d'} = 'defined';
$operators{'>>'}  =  0xb0;
$operators{'<<'}  =  0xb0;
$operators{'+'}   =  0xc0;
$operators{'-'}   =  0xc0;
$operators{'%.'}  =  0xc0; $op_formalname{'%.'} = '.';
$operators{'*'}   =  0xd0;
$operators{'/'}   =  0xd0;
$operators{'%'}   =  0xd0;
$operators{'%x'}  =  0xd0; $op_formalname{'%x'} = 'x';
#$operators{'++'} =  0xe2;
#$operators{'--'} =  0xe2;
$operators{'!'}   =  0xf2;	# boolean not
$operators{'~'}   =  0xf2;	# bit invert
$operators{'**'}  = 0x100;
$operators{'#'}   = 0x200;				# 󻲾ȡ㳰
$operators{'%h'}  = 0x200;				# ϥå廲ȡ㳰
#$operators{'@'}  = 0x202;				# ǥե
$operators{'%m'}  = 0x202; $op_formalname{'%m'} = '-';	# ο

#------------------------------------------------------------------------------
# ƤӽФĤ perl  core ؿ
#------------------------------------------------------------------------------
#		  0 : ġʤΤޤޡ
#	bit 0 =   1 : ͤ array
#	bit 1 =   2 : 裱 array
#	bit 2 =   4 : 裲 array
#	bit 3 =   8 : 裳 array
#	bit 8 = 256 : 裱 hash
#	bit 9 = 512 : 裲 hash
#	bit10 =1024 : 裳 hash


my %allow_functions = (undef => 0, length => 0, sprintf => 0, join => 4, split => 1,
index => 0, rindex => 0, shift => 2, unshift => 2, pop => 2, push => 2,
int => 0, undef => 0, substr => 0, chop => 0, chomp => 0, chr => 0, ord => 0,
uc => 0, lc => 0, keys => 0x101, ref => 0, delete => 0, splice => 3);

#------------------------------------------------------------------------------
# breakե饰åʤؿ
#------------------------------------------------------------------------------
my %break_nocheck_functions = ( if=>1, ifmessage=>1, ifset=>1, copy=>1, into=>1,
	undef2nbsp =>1, tag_escape =>1, tag_escape_amp =>1, tag_delete =>1);

#------------------------------------------------------------------------------
# ifϢ inline Ÿ
#------------------------------------------------------------------------------
# ifexec  inline Ÿ
# forexec  inline Ÿ
my $ifexec_inline_on  = 1;
my $forexec_inline_on = 1;
#   ==> ѥ¹ԤʤȡȤ̤ʤʤޤ

# ifjump  ifmessage Ÿ
my %inline_if = (if=>-1,
	ifbreak=>1, ifbreakclear=>1, ifbreaksuper=>1,
	ifjump=>1, ifjumpclear=>1, ifjumpsuper=>1,
	ifcall=>1, ifredirect=>1, ifmessage=>2, ifset=>1);
# 1 : ifxxx(exp, a1, a2, ... )  if(exp) { xxx(a1, a2, ...); }
# 2 : ifxxx(exp, A, B)          if(exp) { xxx(A); } else { xxx(B); }

#------------------------------------------------------------------------------
# Ծե饰
#------------------------------------------------------------------------------
my $l_replace        = 0x0001;	# ִ
my $l_line_number    = 0x0002;	# Ծɬ
my $l_break_check    = 0x0004;	# breakåɬ
my $l_no_change      = 0x0008;	# ѹػߥե饰
my $l_v_load         = 0x0010;	# $v ͤФ
my $l_indent         = 0x0100;	# indent ѤΥ
my $l_indent_bits    = 8;	# ӥåȥեȤ

#------------------------------------------------------------------------------
# ¾
#------------------------------------------------------------------------------
# ñ̾
my %unit2num = (K => 1024, M => 1024*1024, G => 1024*1024*1024, T => 1024*1024*1024*1024);

# localѿѡʥ֥롼ˤĤ̯ʻͤ
my $use_local_vars = 1;
# ѥѿѡ
my %special_vars = (v=>1);

###############################################################################
# ѥ
###############################################################################
#------------------------------------------------------------------------------
# [01] ץץå
#------------------------------------------------------------------------------
# ޥɤϣĤΣǡʣԡˤˤʤ褦ùʥޥоϡʬ
# ʸ˳Ǽ楳ɤ֤
# ʸ󤫤ʸ 00h-03h Ū˻Ѥ뤿
sub preprocessor {
	my ($self, $lines) = @_;

	my @strbuf;
	my @buf;
	my @line_no = ( 0 );
	#------------------------------------------------------------
	# ץץå
	#------------------------------------------------------------
	my $pragma = 0;
	my $line = 0;
	my $prev_cmd_only = 0;
	my %local_vars;
	my $sharp_comment = 0;
	$self->{local_vars} = \%local_vars;
	foreach (@$lines) {
		$line++;	# ԥ
		if (ref $_) {
			$self->error($line, "Source line allowed scalar only (contain reference)" );
			my $ref = ref $_;
			push(@buf, "<!-- compiler : this line is reference '$ref' -->\n");
			push(@line_no, $line);	# ιԤ򵭲
			next;
		}
		# Ƭ # ˤ륳 on / off
		if ($_ =~ /^<\@\#>/)   { $sharp_comment = 1; next; }	# on
		if ($_ =~ /^<\@\-\#>/) { $sharp_comment = 0; next; }	# off
		# Ƭ # ̵뤹
		if ($sharp_comment && $_ =~ /^\s*\#/) { next; }

		# ιԤޥɤΤߤιԤʤС³Ԥ
		if (($pragma & $p_delcr_aftercmd) && $prev_cmd_only && $_ =~ /^\s*\n$/) { next; }
		$prev_cmd_only = 0;
		# $end ǽԤϹԽ
		if ($_ =~ /<[\$\@]end>\n$/) { chop($_); }

		# ץ饰ޤν
		if ($_ =~ /^<\@([+-])?(\d+)>/) {
			my $n = oct("0x$2");
			if    ($1 eq '+') { $pragma |=  $n; }
			elsif ($1 eq '-') { $pragma &= ~$n; }
			else              { $pragma  =  $n; }
			# push(@buf, sprintf("pragma = %x", $pragma));
			# push(@line_no, $line);
			next;
		}
		# ѿ
		if ($_ =~ /^<\@local\((.*)\)>/) {
			my @vars = split(/\s*,\s*/, $1);
			foreach(@vars) {
				if ($special_vars{$_}) { next; }
				if ($_ !~ /^[a-z][a-z0-9]*$/) { next; }
				$local_vars{$_}=1;
			}
			next;
		}
		# ޥɤβϽ
		my $x =  $_;
		if ($x =~ /^(.*?)<\@>/) {	# Ƚ
			$x=$1;
			if ($x =~ /^\s*$/) { next; }
		}
		if ($pragma & $p_nocr) { $x =~ s/\n//g;}
		$x =~ s/[\x00-\x03]//g;		# ʸ 00h-03h 
		$x =~ s/<\/\$>/<\$\$>/g;	# </$>  <$$>
		my $no_cmd_string = 1;		# ޥɰʳʸ󤬤뤫Ƚ̥ե饰
		# ޥɤǧ
		my $commands = 0;
		while ($x =~ /(.*?)<([\$\@\#])(.*)/s) {	# ޥ
			$commands++;
			my $t = $1;		# 
			my $z = '<' . $2;	# Ƭ - 
			my $y = $3;		# ޥɡ
			if ($commands==1) {	# ԤκǽΥޥɤΤ
				if ($pragma & $p_ctab2blank   && $t =~ /^\t+$/) { $t = ''; }
				if ($pragma & $p_cspace2blank && $t =~ /^\s+$/) { $t = ''; }
			}
			if ($t ne '') {		# ޥɤʬ
				$no_cmd_string = 0;
				push(@buf, $t);
				push(@line_no, $line);	# ιԤ򵭲
			}
			while ($y =~ /(.*?)([>\"\'])(.*)/s) {
				if ($2 eq '>') {
					$z .= $1 . '>';
					$x  = $3;	# Ĥ
					# ʬ ( ) бäƤнλ
					my $tmp=$z;
					while($tmp =~ /^(.*?)\([^\(]*?\)(.*)/) { $tmp="$1$2"; }
					if (index($tmp, '(') <0) { last; }
					$y  = $x;	# ³
					next;
				}
				if ($2 ne '"' && $2 ne "'") {
					$z .= $1 . $2;
					$y  = $3;	# Ĥ
					next;
				}
				$z .= $1;		# ޥɤμ
				my $quot = $2;		# " or '
				my $str = $3;
				if ($quot eq "'" && $str !~ /^((?:\\.|[^\\'])*)\'(.*)/s 
				 || $quot eq '"' && $str !~ /^((?:\\.|[^\\"])*)\"(.*)/s) {
					$self->error($line, 'String error');
					$z = "<!-- compiler : string error -->\n";
					$x =''; last;
				}
				$str = $1;	# ʸ
				$y   = $2;	# Ĥ

				if ($quot eq "'" && substr($z,-1) eq '#') {	# 󥰥륯
					chop($z);
					$quot = '"';	# #'string' ɾʸ "string" Ȥư
				}
				if ($quot eq '"') {	# ֥륯ơξ
					$str =~ s/\\([\"\\\$\@])/"\\x" . unpack('H2', $1)/eg;	# \$ ʤɤΥʸ
					$str =~ s/<@([\w\.]+?(\#\d+)?)>/\x01<$1>/g;		# ɾʸѿ
					$str =~ s/"/\\"/g;					# " 򥨥
					$str =~ s/([\$\@])/"\\x" . unpack('H2', $1)/eg;		# $ @ 򥨥
					# ʸɾ
					# $str =~ s/\x01<([^>]+?)\#(\d+)>/&get_object($1) . "->[$2]"/eg;
					# $str =~ s/\x01<([^>]+?)>/       &get_object($1)/eg;
					push(@strbuf, "\"$str\"");	# ʸ¸
					$z .= "\x01[$#strbuf]";
				} else {		# 󥰥륯ơξ
					push(@strbuf, "'$str'");	# ʸ¸
					$z .= "\x01[$#strbuf]";
				}
			}
			if ($y !~ />/) {
				$self->error($line, 'Command not ended (must write in one line)');
				$z = "<!-- compiler : command not ended? -->\n";
				$x = '';
			}
			push(@buf, $z);			# ޥʬ
			push(@line_no, $line);		# ιԤ򵭲
			# ޥɤʤԤʤСԤ
			if ($x eq "\n" && $no_cmd_string) { $prev_cmd_only=1; $x=''; }
		}
		#begin ʤɤνǤʤʤΤǶػ
		if ($x ne '') {		# Ĥ push
			push(@buf, $x);
			push(@line_no, $line);	# ιԤ򵭲
		}
	}
	$self->{pragma} = $pragma;	# ץ饰ޤ¸

	# ѿǽѤ뤫
	if (! $use_local_vars) {
		undef %local_vars;
	}

	return (\@buf, \@line_no, \@strbuf);
}

#------------------------------------------------------------------------------
# [02] եݡɵˡѴ
#------------------------------------------------------------------------------
sub convert_reversed_poland {
	my ($self, $buf, $line_no) = @_;

	my $line = 0;			# ԥ
	my $comment_flag = 0;
	foreach (@$buf) {
		$line++;
		if ($_ eq '<$>')     { $_=''; $comment_flag=1; next; }	# Ȥγ
		if ($_ eq '<$$>')    { $_=''; $comment_flag=0; next; }	# Ȥνλ
		if ($comment_flag) { $_=''; next; }
		#-------------------------------------------------------------
		# ȥȤξ硢
		#-------------------------------------------------------------
		if ($_ =~ /^<\#(.*)>$/) {
			undef $_; next;
		}
		#-------------------------------------------------------------
		# ޥɤǤʤϤΤޤ
		#-------------------------------------------------------------
		if ($_ !~ /^<([\$\@])(.*)>$/) {
			next;
		}
		#-------------------------------------------------------------
		# ޥɤ¸ߤ
		#-------------------------------------------------------------
		my $cmd_flag = $1;	# @ or $
		my $cmd = $2;		# ޥ
		# ѴΤִ
		$cmd =~ s/(\W)\.([^\w=])/$1%.$2/g;	# ʸϢ
		$cmd =~ s/\.=/%.=/g;			# ʸϢ
		$cmd =~ s/(\W)eq(\W)/$1%e$2/g;		# ʸ
		$cmd =~ s/(\W)ne(\W)/$1%n$2/g;		# ʸ
		$cmd =~ s/(\W)defined(\W)/$1%d$2/g;	# 
		# $cmd =~ s/(\W)x(\W)/$1%x$2/g;		# ʸ x n
		# $cmd =~ s/(\W)-[\d.]+(\W)/$1%m$2$3/g;	# ο
		$cmd =~ s/\.\(/%h\(/g;			# x.()  x %h () =ϥå廲
		$cmd =~ s/\s//g;			# 
		$cmd =~ s/\(\)/(undef)/g;		# func() ν

		# ʸ
		# my $z = $cmd; $z =~ s/\e/|/g; print "\n*** $z\n";	# debug
		my @op  = ('(');	# 黻ҥå
		my @opl = ( 0 );	# åα黻ͥ ¸
		my @poland;		# եݡɵˡϿ
		my $x = $cmd . ')';
		my $right_arc = 0;
		while ($x =~ /(.*?)([=,\(\)\+\-<>\^\*\/&|%!;\#\@])(.*)/s) {
			if ($1 ne '') { push(@poland,  $1); }	# 黻Ҥμ
			my $op  = $2;
			if (length($3) >1 && $operators{$op . substr($3, 0, 2)}) {	# 3ʸα黻ҡ
				$op .= substr($3, 0, 2);
				$x   = substr($3, 2);	# Ĥ
			} elsif ($3 ne '' && $operators{$op . substr($3, 0, 1)}) {	# 2ʸα黻ҡ
				$op .= substr($3, 0, 1);
				$x   = substr($3, 1);	# Ĥ
			} else {
				$x = $3;		# Ĥ
			}
			if ($op eq '-' && $1 eq '' && !$right_arc) { $op = '%m'; }	# ͤɽȽ
			# 黻ͥ٤Фbit 0 ϱͥȽ̤ΤȤ˻ѡ
			my $opl = $operators{$op};
			#
			# $op  ɤ߹黻
			# $opl 黻ͥ
			# $1   黻Ҥ
			#
			if ($op eq '(') {
				push(@op, '('); push(@opl, 0);
				if ($1 ne '') {		# xxxxxx() ʤдؿ¹
					push(@op, '%r');
					push(@opl, 0);
				}
			} else {
				my $z = $opl & 1;	# ͥξ $z = 1
				if ($opl[$#opl] & $opl & 2) {	# åȥåפȸ黻ҤƱñ黻
					# ͥ٤˴طʤ黻ҤФʤ
				} else {
					while ($#opl>=0 && $opl[$#opl] >= $opl + $z) {
						my $op0   = pop(@op);
						my $level = pop(@opl);
						if ($op0 eq '(') { last; }	# '(' ξ硢λ
						# 黻Ҥͥ٤㤤黻Ҥ
						push(@poland, $op0);	# եݡɵˡ
					}
				}
				# 黻ҤѤ
				if ($op eq ')') {
					$right_arc = 1;
				} else {
					$right_arc = 0;
					push(@op,  $op);
					push(@opl, $opl);
				}
			}
			# print "poland exp.   : ", join(' ', @poland), "\n";
			# print "op stack dump : ", join(' ', @op), "\n";
		}
		#
		# Ѵλ
		#
		if ($x ne '' || $#op >= 0) {	# Ĥäʸ or 黻ҥåǧ
			# print "!error \$x=$x op=$#op\n";
			$self->error($line_no->[$line], 'Illigal expression');
			$_ = "<!-- compiler : command error -->";		# 顼Ԥִ
			next;
		}
		push(@poland, $cmd_flag);	# ޥɥե饰Ǹɲ
		$_ = \@poland;			# Ѵִ̤
	}
	return ;
}

#------------------------------------------------------------------------------
# [03] եݡɵˡ eval Ѵ
#------------------------------------------------------------------------------
sub poland_to_eval {
	my ($self, $buf, $line_no, $strbuf) = @_;

	my %constant;				# Хåե
	my $local_vars = $self->{local_vars};	# ѿ
	my $line = 0;				# ԥ
	foreach (@$buf) {
		my $line_info = 0;	# Ծ
		$line++;
		if (ref $_ ne 'ARRAY') {	# եݡɼǤʤФΤޤ
			next;
		}
		# ιֹ
		my $line_num = $line_no->[$line] + 1000;
		$line_num    = substr($line_num, -3);		# 3ʸʬΤ
		my $line_num_int = int($line_num);

		# 
		my $cmd_flag = pop(@$_);
		my @types = map { &get_element_type(\%constant, $_) } @$_;
		# print "\npoland expression : ", join(' ', @$_),    "\n";
		# print   "data types        : ", join(' ', @types), "\n";
		if (grep {$_ eq "error"} @types) {
			my $error = 'Illigal expression';
			$self->error($line_num_int, $error);
			$_ = "<!-- compiler : $error -->";	# 顼Ԥִ
			next;
		}

		# ñִ <@t.var> 
		if ($#$_ == 0 && $types[0] eq 'obj') {
			$_ = "\x02" . pop(@$_);
			if ($cmd_flag eq "\$") { undef $_; }
			next;
		# ñִ
		} elsif ($#$_ == 0 && $types[0] eq 'const') {
			$_ = pop(@$_);
			if ($cmd_flag eq "\$") { undef $_; }
			$_ =~ s/^\'(.*)\'$/$1/;
			next;
		}

		# ʣ
		my $i = 0;
		my $error = 0;
		my $last_op;		# Ǹα黻ҡ
		my $arc_last;		# Ǹ夬γ̡
		my @stack;
		my @stack_type;
		my $exists_call = 0;
		my $break_check_flag = 0;
		my $need_line_num    = 0;	# ֹ椬ɬ
		my $special_add;		# ̿ղ
		foreach my $p (@$_) {
			$arc_last = 0;
			## print "  dump stack : ", join(' ', @stack), "\n";
			## print "  type stack : ", join(' ', @stack_type), "\n";
			my $type = $types[$i++];		# 
			if ($i > $#$_) { $last_op = 1; }	# Ǹα黻
			if ($type eq 'op') {			# 黻
				my $op  = $p;
				my $opl = $operators{$p};
				## printf("\top     = $op [%x]\n", $opl);

				#  perl黻̾Ѵ
				if (exists $op_formalname{$op}) { $op = $op_formalname{$p}; }

				my $x  = pop(@stack);
				my $xt = pop(@stack_type);
				if (!defined $x) { last; }	# 顼
				my ($y, $yt);
				if ((~$opl) & 2) {	# 黻
					$y  = pop(@stack);
					$yt = pop(@stack_type);
					if (!defined $y) { last; }	# 顼
				}
				#
				# 黻ι
				#
				# constant
				if ($op eq '%r' && $y eq 'constant') {
					if ($xt ne 'obj') {
						@stack      = ("$x is not object", '*');
						@stack_type = ('error_msg', '*');
						last;	# 顼 exit
					}
					push(@stack,      $x);
					push(@stack_type, 'const_var');
					next;
				}

				if ($xt eq 'obj' || $xt eq 'const_var') { $x = &get_object($x,$local_vars); }	# ֥ɾ
				if ($op eq '%r') {
					# call Υå
					if ($y eq 'call' || $y eq '_call' || $y eq 'ifcall') { $exists_call = 1; }

					# _ ǻϤޤؿϸƤ٤ʤ
					if (0 && substr($y,0,1) eq '_') {
						@stack      = ("Not allow call $y() function (skelton security protect)", '*');
						@stack_type = ('error_msg', '*');
						last;	# 顼 exit
					}
					#--------------------------------------
					# ifexec Ÿ
					#--------------------------------------
					if ($last_op && $ifexec_inline_on && $y eq 'ifexec') {	# Ǹα黻 = ֳ¦Ǥ
						my @ary = split("\x03,", $x);
						if ($#ary == 2 && $ary[2] =~ /^\x01\[(begin.*)\]$/) { $ary[2] = "\x02[$1]"; }
						if ($#ary <= 2 && $ary[1] =~ /^\x01\[(begin.*)\]$/) { $ary[1] = "\x02[$1]"; }
						$x = join(",", @ary);
					}
					#--------------------------------------
					# forexec Ÿ
					#--------------------------------------
					if ($last_op && $forexec_inline_on && $y eq 'forexec') {
						my @ary = split("\x03,", $x);
						if ($#ary == 2 && $ary[2] =~ /^\x01\[(begin.*)\]$/) {
							my $cmd = "my \$X=$ary[1]; if (ref(\$X) ne 'ARRAY') { \$X=[]; \$R->error_from(\"line $line_num_int at \$R->{__src_file}\", '[executor] forexec: data is not array'); }; ";
							my $begin_type = $1;
							if ($ary[0] =~ /^\$[a-z][a-z0-9]*$/) {	# ѿ
								@stack = ($cmd . "foreach my $ary[0] (\@{ \$X }, \x02[$begin_type])");
							} else {	# ̾ѿ
								@stack = ($cmd . "foreach(\@{ \$X }, \x02[$begin_type])\x02{ $ary[0]=\$_;}\x02");
							}
							@stack_type = ('*');
							last;
						}
					}
					if ($last_op && $forexec_inline_on && $y eq 'forexec_hash') {
						my @ary = split("\x03,", $x);
						if ($#ary == 2 && $ary[2] =~ /^\x01\[(begin.*)\]$/) {
							my $cmd = "my \$H=$ary[1]; if (ref(\$H) ne 'HASH') { \$H={}; \$R->error_from(\"line $line_num_int at \$R->{__src_file}\", '[executor] forexec_hash: data is not hash'); };"
							. " my \$Keys=\$H->{_order} || [keys(\%\$H)]; if(!ref($ary[0])) {$ary[0]={}};"
							. " foreach(\@\$Keys, \x02[$1])"
							. "\x02{$ary[0]\->{key}=\$_; $ary[0]\->{val}=\$H->{\$_}; }\x02";
							@stack      = ($cmd);
							@stack_type = ('*');
							last;
						}
					}
					if ($last_op && $forexec_inline_on && $y eq 'forexec_num') {
						my @ary = split("\x03,", $x);
						if ($#ary == 2 && $ary[2] =~ /^\x01\[(begin.*)\]$/) {
							my $begin_type = $1;
							if ($ary[0] =~ /^\$[a-z][a-z0-9]*$/) {	# ѿ
								@stack = ("foreach my $ary[0] (1..int($ary[1]), \x02[$begin_type])");
							} else {
								@stack = ("foreach(1..int($ary[1]), \x02[$begin_type])\x02{ $ary[0]=\$_;}\x02");
							}
							@stack_type = ('*');
							last;
						}
					}

					#--------------------------------------
					# ifxxx  inline Ÿ
					#--------------------------------------
					if ($inline_if{$y}) {
						if (!$break_nocheck_functions{$y}) { $break_check_flag = 1; }
						my @ary = split("\x03,", $x);
						$x = undef;
						if ($y eq 'if' && $last_op && $#ary == 1 && $cmd_flag eq '@') {
							$x = undef;
							$line_info |= $l_no_change;
							$x = "($ary[0] && push(\@\$Out, $ary[1]));";
							$arc_last = 1;

						} elsif ($y eq 'if' && $ary[1] eq '') {
							$x = undef;	# error
						} elsif ($y eq 'if') {
							if ($ary[2] ne '') {
								$x = "($ary[0] ? $ary[1] : $ary[2])";
							} else {
								$x = "($ary[0] && $ary[1])";
							}
							$arc_last = 1;
						} elsif ($y eq 'ifset') {
							if ($#ary > 2) {
								$x = "($ary[1]=$ary[0] ? $ary[2]: $ary[3])";
							} elsif ($#ary == 2) {
								$x = "($ary[0] && ($ary[1]=$ary[2]))";
							} else { $x=undef; }
							$arc_last = 1;
						} elsif (substr($y,0,2) eq 'if') {
							$need_line_num = 1;
							my $func = substr($y, 2);	# iffunc  func
							$x = shift(@ary);
							if ($inline_if{$y} == 2 && $ary[1] ne '') {	# ifxxx(exp, A, B)
								$x = "\$R->$func($x ? $ary[0] : $ary[1])";
							} else {
								$x = "($x && \$R->$func(" . join(',', @ary) . "))";
								$arc_last = 1;
							}
						}
						if (!defined $x) {
							push(@stack,      $x,  $y);
							push(@stack_type, $xt, $yt);
							last;	# 顼 exit
						}
						push(@stack, $x);
						push(@stack_type, '*');
						next;

					} elsif (exists $allow_functions{$y}) {		# perlؿľ call
						$need_line_num = 1;
						# perl core ؿθƤӽФ
						if ($x eq '' || $x eq 'undef') {	# άϵĤʤ
							push(@stack, $y);
							push(@stack_type, $yt);
							last;	# 顼 exit
						}
						# bit 0 =  1 : ͤ array
						# bit 1 =  2 : 裱 array
						# bit 2 =  4 : 裲 array
						# bit 3 =  8 : 裳 array
						my $mode = $allow_functions{$y};
						if ($mode) {
							my @ary = split("\x03,", $x);
							if ($mode &    2 && defined $ary[0]) { $ary[0] = '@{' . $ary[0] . '}'; }
							if ($mode &    4 && defined $ary[1]) { $ary[1] = '@{' . $ary[1] . '}'; }
							if ($mode &    8 && defined $ary[2]) { $ary[2] = '@{' . $ary[2] . '}'; }
							if ($mode &  256 && defined $ary[0]) { $ary[0] = '%{' . $ary[0] . '}'; }
							if ($mode &  512 && defined $ary[1]) { $ary[1] = '%{' . $ary[1] . '}'; }
							if ($mode & 1024 && defined $ary[2]) { $ary[2] = '%{' . $ary[2] . '}'; }
							$x = join(',', @ary);
						}
						$x =~ s/\x03//g;	# , ̻Ҥä
						if ($allow_functions{$y} & 1) {
							push(@stack, "[ $y($x) ]");	# ͤreference
						} else {
							push(@stack, "$y($x)");
						}
						push(@stack_type, '*');
						next;
					}

					$x =~ s/\x03//g;	# , ̻Ҥä
					$need_line_num = 1;
					if ($y eq 'array') {		# array(a, b, c, ...);
						push(@stack, "[ $x ]");		# 
					} elsif ($y eq 'hash') {	# hash(a, b, c, ...);
						$x =~ s/,/=>1,/g;
						push(@stack, "{ $x=>1 }");		# ϥå岽
					} elsif ($yt eq 'obj') {
						if (!$break_nocheck_functions{$y}) { $break_check_flag = 1; }
						my ($class, $func) = &get_object_sep($y,$local_vars);
						push(@stack, "$class\-\>$func($x)");
					} else {	# 顼
						push(@stack, $y);
						push(@stack_type, $yt);
						last;
					}
					push(@stack_type, '*');
					next;
				}
				#--------------------------------------
				# constantν
				#--------------------------------------
				if ($last_op && $op eq '=' && $yt eq 'const_var' && ($xt eq 'const' || $xt eq 'string')) {
					my $err;
					my $const = $x;
					if ($xt eq 'string') {
						$err=1;
						if ($x =~ /^\x01\[(\d+)\]$/) {
							$const = $strbuf->[$1];
							$const =~ s/^[\"\'](.*)[\"\']$/$1/;
							if ($const !~ /[\x00-\x08\x0a-\x1f\"\'\\]/) {
								$err=0; $const="'$const'";
							}
						}
					}
					# 
					if (!$err) {
						$constant{$y} = $const;
						@stack        = ($const);
						@stack_type   = ('const');
						last;
					}
				}

				if ($yt eq 'obj' || $yt eq 'const_var') { $y = &get_object($y,$local_vars); }	# ֥ɾ
				if ($op eq '#')  {	# 󻲾
					push(@stack, "$y\-\>[$x]");
					push(@stack_type, '*');
					$arc_last = 1;
					next;
				}
				if ($op eq '%h')  {	# ϥå廲
					push(@stack, "$y\-\>{$x}");
					push(@stack_type, '*');
					$arc_last = 1;
					next;
				}
				if ($op eq ',')  {
					push(@stack, "$y\x03,$x");
					push(@stack_type, '*');
					next;
				}
				if ($op eq '@')  {
					push(@stack, "\@\{$x\}");
					push(@stack_type, '*');
					last;		# б黻
				}
				# ѿؤ
				if ($last_op && $op eq '=' && $y =~ /^\$[a-z][a-z0-9]*$/ && $y ne '$v') {
					push(@stack,      "my $y = $x");
					push(@stack_type, '*');
					next;
				}
				# ̾Σ黻
				if ((~$opl) & 2) {
					my $a  = "($y $op $x)";
					my $at = '*';
					if ($xt eq 'const' && $yt eq 'const') {
						$a  = eval($a);
						if ($a eq '') { if ($a) { $a=1; } else { $a=0; } }	# true/false
						$at = 'const';
					}
					push(@stack,      $a);
					push(@stack_type, $at);
					$arc_last = 1;
					next;
				}
				# ñ黻
				my $a  = "($op $x)";
				my $at = '*';
				if ($xt eq 'const') {
					$a  = eval($a);
					if ($a eq '') { if ($a) { $a=1; } else { $a=0; } }	# true/false
					$at = 'const';
				}
				push(@stack,      $a);
				push(@stack_type, $at);
				$arc_last = 1;
				next;

			} elsif ($type eq 'error') {	# 顼
				push(@stack,      $p);
				push(@stack_type, $type);
				last;

			} else {	# ֥Ȼ
				push(@stack,      $p);
				push(@stack_type, $type);
			}
		}

		if ($#stack != 0) {
			my $error = 'Illigal expression (%d)';
			if ($stack_type[0] eq 'error_msg') { $error=$stack[0]; }
			$self->error($line_num_int, $error, $#stack );
			&tag_escape(@stack);
			$_ = "<!-- compiler : command error($#stack) $stack[0] $stack[1] $stack[2] $stack[3]-->";	# 顼Ԥִ
			next;
		} else {
			my $exp  = pop(@stack);
			my $type = pop(@stack_type);
			$exp =~ s/\x03//g;		# ","̻Ҥä
			if ($arc_last && $exp =~ /^\((.*)\)(;?)$/) { $exp = "$1$2"; }	# ֳ (  ) 򳰤
			if ($type eq 'obj') { $exp = &get_object($exp,$local_vars); }	# ֥ξ硢ȷ
			if ($type eq 'const') {		# 
				if ($cmd_flag eq "\$") { undef $_; next; }	# ̵
				$_ = $exp;
				next;
			}
		#	print "  eval string : $exp\n";
			$_ = "\x01$line_num" . $exp;		# ִ

			# Ծ¸
			if ($cmd_flag eq '@')  { $line_info |= $l_replace;     }	# ִ̤
			if ($break_check_flag) { $line_info |= $l_break_check; }	# break å
			if ($need_line_num)    { $line_info |= $l_line_number; }	# ؿƤӽФ  Ծ
			if ($exists_call)      { $line_info |= $l_v_load; }		# $v κ
			if ($line_info) {	# Ծ󤬤
				$_ .= "#$line_info";	# Ծղ
			}
		}
	}
	# ʸɾ
	foreach(keys(%constant)) {	# ʸΥȤ
		if ($constant{$_} eq 'undef') { $constant{$_}=''; next; }
		$constant{$_} =~ s/\'(.*)\'/$1/;
	}
	foreach(@$strbuf) {
		$_ =~ s/\x01<([^>]+?)\#(\d+)>/&get_object($1,$local_vars) . "->[$2]"/eg;
		$_ =~ s/\x01<([^>]+?)>/(exists $constant{$1}) ? $constant{$1} : &get_object($1,$local_vars,1)/eg;
	}
	return ;

}
#-----------------------------------------------------------
# ֹ
#-----------------------------------------------------------
sub get_line_no {
	return substr($_[0], 1, 3) +0;
}

#-----------------------------------------------------------
# Ǥμ
#-----------------------------------------------------------
sub get_element_type {
	my $constant = shift;
	my $p = $_[0];
	if (exists $operators{$p}) { return 'op'; }		# 黻
	if ($p =~ /^\x01\[(\d+)\]$/) { return 'string'; }	# ʸʲ⤷ʤ
	if ($p =~ /[^\w\.]/)    { return 'error'; }		# ʸ󡿥顼
	if ($p =~ /^[\d\.]+$/ || $p =~ /^0x[\dA-Fa-f]+$/) { return 'const'; }	# ͡ʲùʤ
	if ($p =~ /^([\d\.]+)([KMGT])B?$/) {	# ñդ
		$p *= $unit2num{$2};
		$_[0] = int($p);
		return 'const';
	}
	if ($p =~ /^(\d+)\.\w+$/) {		# դο  10.is_cache_on ʤ
		$_[0] = $1; return 'const';
	}
	if ($p =~ /^(begin.*)/) {		# array
		$_[0] = "\x01[$1]"; return 'array';
	}
	if ($p =~ /^end(.*)/ || $p =~ /^else(.*)/) {
		$_[0] = "end$1";    return 'block';
	}
	if ($p =~ /^yes$/i || $p =~ /^true$/i) {
		$_[0] = 1; return 'const';
	}
	if ($p =~ /^no$/i || $p =~ /^false$/i) {
		$_[0] = 0; return 'const';
	}
	if ($p =~ /^new(|\..*)$/) {
		if ($1 eq '' || $1 eq '.hash') { $_[0] = '{}'; return 'hash';  }
		if ($1 eq '.array')            { $_[0] = '[]'; return 'array'; }
		$_[0] = ''; return 'error';
	}
	if ($p eq 'undef') { return 'const'; }
	if (exists $constant->{$p}) { $_[0] = $constant->{$p}; return 'const'; }

	return 'obj';
}

#------------------------------------------------------------------------------
# [04] begin - end ֥åμФʸִ
#------------------------------------------------------------------------------
sub split_begin_block {
	my ($self, $buf) = @_;

	# 롼
	my $line = 0;		# ԥ
	my @arybuf = ([]);	# Ƭ dummy Ѥ
	my @newbuf;
	while(@$buf) {
		my $line = shift(@$buf);
		# begin ֥åڤФ
		if (ord($line) == 1 && $line =~ /[\x01\x02]\[begin.*?\]/) {
			unshift(@$buf, $line);
			$self->split_begin(\@newbuf, $buf, \@arybuf);
			next;
		}
		if ($line =~ /^\x01\d\d\dend.?(\w*)/) {
			my $line_no = &get_line_no($line);
			my $end = substr($line, 4);
			$self->error($line_no, "Exists 'end' without 'begin' (%s)", $end );
			$line = "<!-- compiler : block end exists, but crresponded end no exists ($end) -->";
		}
		push(@newbuf, $line);
	}
	# @arybuf  end ĤäƤʤǧʥ顼å
	foreach my $ary (@arybuf) {
		foreach(@$ary) {
			if ($_ =~ /^\x01\d\d\dend.?(\w*)/) {
				my $line_no = &get_line_no($_);
				my $end = substr($_, 4);
				$self->error($line_no, "Exists 'end' without 'begin' (%s)", $end );
				$_ = "<!-- compiler : block end exists, but crresponded end no exists ($end) -->";
			}
		}
	}
	# arybufƬ˼¹ʸΤ
	$arybuf[0] = \@newbuf;

	return \@arybuf;
}
#-----------------------------------------------------------
# begin block ᥤʺƵб
#-----------------------------------------------------------
sub split_begin {
	my ($self, $newbuf, $buf, $arybuf) = @_;

	my @if_blocks;
	my $info = 0;
	my $t = shift(@$buf);
	if ($t =~ /(.*?)\#(\d+)$/s) { $t=$1; $info=$2; }

	while (ord($t) == 1 && $t =~ /(.*?)([\x01\x02])\[(begin.*?)\](.*)/s) {
		my $left  = $1;
		my $flag  = $2;
		my $begin = $3;
		my $right = $4;
		my ($mode, $blockname) = split(/\./, $begin);
		my $ary = $self->splice_block($buf, $blockname, $arybuf);
		if (! defined $ary) {
			my $line_no = &get_line_no($t);
			$self->error($line_no, "Exists 'begin' without crresponded 'end' (%s)", $begin );
			$t = "<!-- compiler : begin block error($begin) -->";	# 顼Ԥִ
			last;
		}

		if ($mode eq 'begin_ary' || $mode eq 'begin_array') {	 # ֥åǡʥꥹȡ
			my @ary2;
			foreach(@$ary) {
				chomp($_);
				$_ =~ s/^\s*(.*?)\s*$/$1/;
				if ($_ eq '') { next; }
				&into_single_quot_string($_);
				push(@ary2, $_);
			}
			$ary = '[' . join(',', @ary2) . ']';
			$ary =~ s/[\x01-\x03]//g;

		} elsif ($mode eq 'begin_str' || $mode eq 'begin_string') {	 # ʸ
			my $str = join('', @$ary);
			&into_single_quot_string($str);
			$ary = $str;

		} elsif ($mode eq 'begin_hash') {	 # ֥åǡʥϥå
			my %hash;
			my @order;
			foreach my $a (@$ary) {
				chomp($_);
				if ($a eq '') { next; }
				if ($a =~ /^\s*(.+?)\s*=\s*(.*?)\s*$/) {
					$hash{$1} = $2;
					push(@order, $1);	# ݻ
				}
			}
			my @ary2;
			my $order;
			foreach(@order) {
				my $k = $_;
				my $v = $hash{$k};
				&into_single_quot_string($k, $v);
				push(@ary2, "$k=>$v");
				$order .= "$k,";
			}
			chop($order);
			$ary = "{_order=>[$order]," . join(',', @ary2) . '}';
			$ary =~ s/[\x01-\x03]//g;

		} elsif ($mode eq 'begin' && $flag eq "\x02") {	# ¹ԹʸΥ֥åŸ
			push(@if_blocks, $ary);
			if ($left =~ /(.*?),\s*$/s) { $left = $1; }	# , 
			$t = $left . $right;
			$ary='';

		} elsif ($mode eq 'begin') {		# ¹Թʸ
			push(@$arybuf, $ary);
			$ary = "\$Ary\->[$#$arybuf]";

		} else {		# ̤Τbegin
			my $line_no = &get_line_no($t);
			$self->error($line_no, "Unknown begin type (%s)", $mode );
			$t = "<!-- compiler : unknown begin type ($mode) -->";	# 顼Ԥִ
			last;
		}
		$t = $left . $ary . $right;
		## print $_, "\n";
	}
	#------------------------------------------------------------
	# ֥åŸ
	#------------------------------------------------------------
	if (@if_blocks) {
		$t =~ s/^(\x01\d\d\d)\$R->ifexec\(/${1}if (/;
		if ($t =~ /\x02\{.*?\}\x02/) {
			$t =~ s/\x02\{(.*?)\}\x02//g;
			push(@$newbuf, "$t {$1#$l_no_change");
		} else {
			push(@$newbuf, "$t {#$l_no_change");
		}
		my $block = shift(@if_blocks);
		&info_rewrite($block, $info & $l_replace);
		push(@$newbuf, @$block);
		# else ?
		if (@if_blocks) {
			push(@$newbuf, "\x01000} else {#$l_no_change");
			$block = shift(@if_blocks);
			&info_rewrite($block, $info & $l_replace);
			push(@$newbuf, @$block);
		}
		push(@$newbuf, "\x01000}#$l_no_change");
		return ;
	}
	$t .= "#$info";
	push(@$newbuf, $t);
}

#-----------------------------------------------------------
# ֥åμФ, split_begin 
#-----------------------------------------------------------
sub splice_block {
	my ($self, $buf, $blockname, $arybuf) = @_;
	my @ary;
	while(@$buf) {
		my $line = shift(@$buf);
		if ($line =~ /^\x01\d\d\dend.?(\w*)/ && $1 eq $blockname) {
			return \@ary;
		}
		if (ord($line) == 1 && $line =~ /[\x01\x02]\[begin.*?\]/) {
			unshift(@$buf, $line);
			$self->split_begin(\@ary, $buf, $arybuf);
			next;
		}
		if ($line ne '') {
			push(@ary, $line);
		}
	}
	return undef;		# ֥åν꤬Ĥʤ
}

#-----------------------------------------------------------
# ֥åιԾ񤭴
#-----------------------------------------------------------
sub info_rewrite {
	my ($block, $replace) = @_;
	foreach(@$block) {
		if (ord($_) != 1) {
			if (!$replace) { $_=''; }
			next;
		}
		my $info;
		if ($_ =~ /(.*?)\#(\d+)$/s) { $_=$1; $info=$2; }
		if (!$replace) { $info &= (0x7fffffff - $l_replace); }
		$info += $l_indent;
		$_ .= "#$info";
	}
}
#------------------------------------------------------------------------------
# [05] פʹԤԤޤȤ
#------------------------------------------------------------------------------
sub optimize {
	my ($self, $arybuf) = @_;

	my $pragma = $self->{pragma};			# ץ饰ޥ
	foreach my $ary (@$arybuf) {
		my @new_ary = ('dummy');		# ԹǡѤǤ
		my $str;
		foreach (@$ary) {
			my $f = ord($_);
			if ($_ eq '' || $f > 3) {	# ̤ʸ
				$str .= $_;
				next;
			}
			#
			# ޥ or ִʸ
			#
			if($str ne '') {
				if (~$pragma & $p_cmd_only) { push(@new_ary, $str); }
				$str = '';
			}
			push(@new_ary, $_);
		}
		shift(@new_ary);	# dummy ɤ߼Τ
		if ($str ne '' && (~$pragma & $p_cmd_only)) { push(@new_ary, $str); }
		$ary = \@new_ary;
	}
	return $arybuf;
}

#------------------------------------------------------------------------------
# [06] array֥å򣱤ĤΥ֥롼֤
#------------------------------------------------------------------------------
sub array2sub {
	my ($self, $arybuf) = @_;
	my $local_vars = $self->{local_vars};

	foreach my $ary (@$arybuf) {
		my @sub_array;
		push(@sub_array, <<'SUB_START');
sub {
	my $Out = shift;
	my $R   = shift;
	my $Ary = shift;
	my $v   = $R->{v};
	$_[1] = \$v;
SUB_START
		if (%$local_vars) {
			my @vars = map { "\$$_" } keys(%$local_vars);
			push(@sub_array, "\tmy (" . join(',', @vars) .");\n");
		}
		my $indent = "\t";
		foreach(@$ary) {
			my $flag = ord($_);
			# Τޤ޽
			if ($flag > 3) {
				&into_single_quot_string($_);
				push(@sub_array, $indent . "push(\@\$Out, $_);\n");
				next;
			}
			# xxx.yy.zz Υǡִ
			if ($flag == 2) {
				my $obj = &get_object( substr($_, 1), $local_vars );
				push(@sub_array, $indent . "push(\@\$Out, $obj);\n");
				next;
			}
			# unknown
			if ($flag == 0 || $flag==3) { next; }

			# ¹Լ
			my $cmd  = substr($_, 4);
			my $line = substr($_, 1, 3) +0;
			# ԾʬΥ
			my $info = 0;
			if ($cmd =~ /(.*?)\#(\d+)$/s) {
				$cmd  = $1;	# ޥ
				$info = $2;	# Ծ
			}
			# indent 
			$indent = "\t" . ("\t" x ($info >> $l_indent_bits));
			# ùػ
			if ($info & $l_no_change) {
				push(@sub_array, "$indent$cmd\n");
				if ($cmd =~ /^if\s*\(.*\)\s*\{/ || $cmd =~ /^}\s*else\s*\{/) { $indent .= "\t"; }
				next;
			}
			# ִ
			if ($info & $l_replace) {	# ִ
				if ($cmd =~ /;,/) { $cmd = "push(\@\$Out, do{ $cmd });"; }
				             else { $cmd = "push(\@\$Out, $cmd);"; }
			} else {
				$cmd .= ';';
			}

			# ֹ椬ɬסʥ顼ʤԤǤס
			if ($info & $l_line_number) { $cmd  = "\$_[0]=$line; " . $cmd; }
			# v ͤ
			if ($info & $l_v_load)      { $cmd .= " \$v=\$R->{v};"; }
			# break flag ǧ
			if ($info & $l_break_check) { $cmd .= " \$R->{Break} && return;"; }
			# ޥɤ
			push(@sub_array, "$indent$cmd\n");
		}
		push(@sub_array, "\treturn;\n}\n");
		$ary = join('', @sub_array);
	}
	return $arybuf;
}


#------------------------------------------------------------------------------
# [07] ʸ
#------------------------------------------------------------------------------
sub recover_string {
	my ($self, $arybuf, $strbuf) = @_;

	foreach my $ary (@$arybuf) {
		if (! ref($ary)) {
			$ary =~ s/\x01\[(\d+?)\]/$strbuf->[$1]/g;
			next;
		}
		foreach(@$ary) {
			$_ =~ s/\x01\[(\d+?)\]/$strbuf->[$1]/g;
		}
	}
	return $arybuf;
}


###############################################################################
# 顼
###############################################################################
sub error {
	my $self  = shift;
	my $line  = shift;
	my $error = shift;
	$self->{errors}++;
	if ($line) { $line="[line $line] "; }
	$error = $line . $self->{ROBJ}->message_translate($error, @_);
	push( @{ $self->{error_msg} }, $error);
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# ̾饪֥Ȥμ
#------------------------------------------------------------------------------
sub get_object {
	my ($name, $local_vars, $in_string) = @_;
	$local_vars ||= {};
	if ($name eq 'v')         { return '$v';      }
	if ($local_vars->{$name}) { return $in_string?"\${$name}":"\$$name"; }
	my ($class, $name) = &get_object_sep(@_);
	return "$class\-\>{$name}";
}

sub get_object_sep {
	my $name       = shift;
	my $local_vars = shift || {};
	$name =~ s/[^\w\.]//g;		# Ⱦѱѿ _ . ʳʸ
	if ($name eq '') { return 'undef'; }	# 顼̤򼨤֥Ȥ֤

	my @ary = split(/\./, $name);
	my $obj  = "\$R";
	my $last = pop(@ary);
	# Ŭǽ
	my $first = $ary[0];
	if ($first eq 'v')              { $obj='$v';       shift(@ary); }
	  elsif ($local_vars->{$first}) { $obj="\$$first"; shift(@ary); }
	# print "$first $obj $local_vars->{$first}\n";
	foreach $name (@ary) {
		$obj .= "->{$name}";
	}
	return ($obj, $last);
}

#------------------------------------------------------------------------------
# '' äʸȤƲù
#------------------------------------------------------------------------------
sub into_single_quot_string {
	foreach(@_) {
		if ($_ =~ /^\d+$/) { next; }
		$_ =~ s/([\\'])/\\$1/g;
		$_ = "'$_'";
	}
}

#------------------------------------------------------------------------------
# 
#------------------------------------------------------------------------------
sub tag_escape {
	foreach(@_) {
		$_ =~ s/"/&quot;/g;
		$_ =~ s/>/&gt;/g;
		$_ =~ s/</&lt;/g;
	}
	return $_[0];
}



###############################################################################
# ǥХå
###############################################################################
sub debug_save {
	my ($self, $filename, $buf, $line_no, $strbuf, $arybuf) = @_;
	my $ROBJ = $self->{ROBJ};
	my @lines;

	#---------------------------------------------------
	# ɽѴ
	#---------------------------------------------------
	if (ref $buf eq 'ARRAY') {
		@lines = @$buf;
		&conv_display_style(\@lines, $line_no);
	}

	#---------------------------------------------------
	# ɽѴ
	#---------------------------------------------------
	if (ref $arybuf) {
		my $no = 0;
		foreach my $ary (@$arybuf) {
			if ($no) { push(@lines, sprintf("\nARRAY:[%02d]", $no) . "--------------------------------------------------------------------\n"); }
			$no++;
			if (! ref($ary)) {	# ǤϤʤ
				push(@lines, $ary);
				next;
			}
			my @ary = @$ary;
			&conv_display_style(\@ary);
			foreach(@ary) {
				push(@lines, $_);
			}
		}
	}
	#---------------------------------------------------
	# ʸ
	#---------------------------------------------------
	foreach(@lines) {
		$_ =~ s/\x01\[(\d+?)\]/$strbuf->[$1]/g;
		$_ =~ s/[\x00-\x03]//g;	# ʸ
	}
	# save
	$ROBJ->fwrite_lines($filename, \@lines);
}

#---------------------------------------------------
# ɽѤβù
#---------------------------------------------------
sub conv_display_style {
	my ($lines, $line_no) = @_;
	if (ref $line_no ne 'ARRAY') { $line_no = []; }

	my $line = 0;	# ԥ
	foreach(@$lines) {
		$line++;
		my $s = '::';
		my $this_line = '---';
		if ($line_no->[$line]) { $this_line = sprintf("%03d", $line_no->[$line]); }
		if (ref $_ eq 'ARRAY') {	# եݡɵˡξ
			my @ary = @$_;
			$s = 'p)' . pop(@ary);
			$_ = join(' ', @ary);
		} elsif (ord($_) == 1) {	# eval - perl 
			$s         = 'e)';
			$this_line = substr($_, 1, 3);	# ֹФ
			$_         = substr($_, 4);
			# Ծ
			my $info = 0;
			if ($_ =~ /\#(\d+)$/ && $1 & $l_replace) { $s = 'r)'; }
		} elsif (ord($_) == 2) {	# replace ñ켰
			$s = 'R)';
			$_ = substr($_, 1);
		}
		$_ =~ s/\n/\\n/g;	# ִ
		$_ =  "$this_line $s $_\n";
	}
}



1;
