#!/usr/local/bin/perl
use strict;
#------------------------------------------------------------------------------
# Split from Satsuki::DB_pg.pm for AUTOLOAD.
#------------------------------------------------------------------------------
use Satsuki::DB_pg ();
use Satsuki::DB_pg_auto ();
package Satsuki::DB_pg;
our $DEBUG;
###############################################################################
# ץʥؿ
###############################################################################
sub get_options {
	return {add_column => 1, drop_column => 1, add_index => 1};
}
###############################################################################
# ץʥؿ
###############################################################################
#------------------------------------------------------------------------------
# ɲ
#------------------------------------------------------------------------------
sub add_column {
	my ($self, $table, $h) = @_;
	my $dbh  = $self->{dbh};
	my $ROBJ = $self->{ROBJ};

	$table =~ s/\W//g;
	if ($table eq '') { return 9; }

	# β
	my $col = $h->{name};
	$col =~ s/\W//g;
	my $sql;
	if    ($h->{type} eq 'int')  { $sql .= "$col INT";     }
	elsif ($h->{type} eq 'flag') { $sql .= "$col BOOLEAN"; }
	else                         { $sql .= "$col TEXT";    }
	if ($h->{unique})   { $sql .= ' UNIQUE';   }		# ˡ
	if ($h->{not_null}) { $sql .= ' NOT NULL'; }		# NOT NULL
	if ($h->{ref_pkey}) {	#  table_name.col_name ʸ 
		my $ref_pkey = $h->{ref_pkey};
		$ref_pkey =~ s/[^\w\.]//g;
		my ($ref_table, $ref_col) = split(/\./, $ref_pkey);
		$sql .= " REFERENCES $ref_table($ref_col)";
	}

	# SQLȯ
	$sql = "ALTER TABLE $table ADD COLUMN $sql";
	my $sth = $dbh->prepare($sql);
	$DEBUG && $self->debug($sql);	# debug
	$sth && $sth->execute();
	if (!$sth || $dbh->err) { $ROBJ->error($sql); $ROBJ->error($dbh->errstr); return 1; }
	# ơ֥򹹿
	$self->update_tableinfo($table);

	# INDEX 
	#	CREATE INDEX table_colname_idx ON table (colname);
	if ($h->{index}) {
		my $sql = "CREATE INDEX ${table}_${col}_idx ON $table($col)";
		$DEBUG && $self->debug($sql);	# debug
		$dbh->do($sql);
		if ($dbh->err) { $ROBJ->error($sql); $ROBJ->error($dbh->errstr); return 2; }
	}
	return 0;
}

#------------------------------------------------------------------------------
# κ
#------------------------------------------------------------------------------
sub drop_column {
	my ($self, $table, $column) = @_;
	my $dbh  = $self->{dbh};
	my $ROBJ = $self->{ROBJ};
	$table  =~ s/\W//g;
	$column =~ s/\W//g;
	if ($table eq '' || $column eq '') { return 9; }

	# SQLȯ
	my $sql = "ALTER TABLE $table DROP COLUMN $column";
	my $sth = $dbh->prepare($sql);
	$DEBUG && $self->debug($sql);	# debug
	$sth && $sth->execute();
	if (!$sth || $dbh->err) { $ROBJ->error($sql); $ROBJ->error($dbh->errstr); return 1; }
	# ơ֥򹹿
	$self->update_tableinfo($table);

	return 0;
}

#------------------------------------------------------------------------------
# indexɲ
#------------------------------------------------------------------------------
sub add_index {
	my ($self, $table, $column) = @_;
	my $dbh  = $self->{dbh};
	my $ROBJ = $self->{ROBJ};
	$table  =~ s/\W//g;
	$column =~ s/\W//g;
	if ($table eq '' || $column eq '') { return 9; }

	# β
	my $sql = "CREATE INDEX ${table}_${column}_idx ON $table($column)";
	my $sth = $dbh->prepare($sql);
	$DEBUG && $self->debug($sql);	# debug
	$sth && $sth->execute();
	if (!$sth || $dbh->err) { $ROBJ->error($sql); $ROBJ->error($dbh->errstr); return 1; }

	return 0;
}


1;	# ޤʤ
