#!/usr/local/bin/perl
require 5.004;
use strict;
#------------------------------------------------------------------------------
# ǡݡ for ϤƤʷ(xml)
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::Diary::ImportHatena;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);		# $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ}  = shift;

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}
###############################################################################
# ǡݡ
###############################################################################
#------------------------------------------------------------------------------
# ϤƤ/adiaryΥǡݡ
#------------------------------------------------------------------------------
sub import {
	my ($self, $diary_obj, $form) = @_;
	my $ROBJ = $self->{ROBJ};
	my $input_coding = 'UTF-8';

	# ǡå
	my $data = $form->{import}->{data};
	delete $form->{import};
	my $check_data = substr($data, 0, 1024);
	if ($check_data !~ /<\?xml .*? encoding="([\w\-]*)".*?\?>.*<diary>/s) {
		$ROBJ->message('Data format error (%s)', 'adiary/hatena');
		return -1;
	}
	if ($1 ne '') {
		$input_coding = $1;
		$input_coding =~ tr/a-z/A-Z/;
	}

	# ʸѴ
	my $system_coding = $ROBJ->{System_coding};
	if ($system_coding ne $input_coding) {
		my $jcode = $ROBJ->loadpm('Jcode');
		$jcode->from_to(\$data, $input_coding, $system_coding);
	}
	# ԥѴ
	$data =~ s/\r\n|\r/\n/g;

	my @days;
	$data =~ s|(<day.*?</day>)|push(@days, $1),''|seg;
	undef $data;

	#---------------------------------------------------------------------
	# βϤ¸
	#---------------------------------------------------------------------
	my %parser_cache;
	my $imports = 0;
	foreach my $log (@days) {
		#-------------------------------------------------------------
		# <day date="2004-02-29" title="xxx"> β
		#-------------------------------------------------------------
		$log =~ /<day (.*?)>/;
		my $day_tag = $1;
		my %diary;
		$day_tag =~ s/\s*(\w+)\s*?=\s*?([\"\'])(.*?)\2/$diary{$1}=$3,''/eg;
		#-------------------------------------------------------------
		# <attributes xxx="yyy" ...> βϡadiaryĥ
		#-------------------------------------------------------------
		if ($log =~ /<attributes (.*?)>/) {
			my $attributes = $1;
			$attributes =~ s/\s*(\w+)\s*?=\s*?([\"\'])(.*?)\2/$diary{$1}=$3,''/eg;
		}

		#-------------------------------------------------------------
		# ʸ
		#-------------------------------------------------------------
		if ($log =~ /<body>(.*?)<\/body>/s) { $diary{text}=$1; }

		#-------------------------------------------------------------
		# XML ǥ
		#-------------------------------------------------------------
		$diary{text} =~ s/&lt;/</g;
		$diary{text} =~ s/&gt;/>/g;
		$diary{text} =~ s/&quot;/"/g;
		$self->tag_dencode_for_xml($diary{title}, $diary{category}, $diary{name}, $diary{agent}, $diary{files}, $diary{text});

		#-------------------------------------------------------------
		# Ȥβ
		#-------------------------------------------------------------
		my $comments='';
		if ($log =~ /<comments>(.*?)<\/comments>/s) { $comments=$1; }
		my @comments;
		if ($comments ne '') {
			my @ary;
			$comments =~ s/<comment>(.*?)<\/comment>/push(@ary, $1),''/seg;
			foreach(@ary) {
				my %h;
				$_ =~ s|<(\w+)>(.*?)</\1>|$h{$1}=$2,''|seg;
				$h{tm}   = $h{timestamp};
				$h{name} = $h{username};
				$h{text} = $h{body};
				delete $h{timestamp};
				delete $h{username};
				delete $h{body};

				# XML
				$self->tag_dencode_for_xml($h{name}, $h{url}, $h{text});
				$h{text} =~ s/&lt;br&gt;/\n/g;	# <br>\n Ѵ
				push(@comments, \%h);
			}
		}

		#-------------------------------------------------------------
		# ȥåХåβ
		#-------------------------------------------------------------
		my $trackbacks='';
		if ($log =~ /<trackbacks>(.*?)<\/trackbacks>/s) { $trackbacks=$1; }
		my @trackbacks;
		if ($trackbacks ne '') {
			my @ary;
			$trackbacks =~ s/<trackback>(.*?)<\/trackback>/push(@ary, $1),''/seg;
			foreach(@ary) {
				my %h;
				$_ =~ s|<(\w+)>(.*?)</\1>|$h{$1}=$2,''|seg;
				$h{tm}      = $h{timestamp};
				$h{excerpt} = $h{excerpt};
				delete $h{timestamp};
				delete $h{body};
				$self->tag_dencode_for_xml($h{title}, $h{excerpt}, $h{blog_name}, $h{author});

				push(@trackbacks, \%h);
			}
		}

		#-------------------------------------------------------------
		# ϤƤʥΥǡadiaryʸεˡѴ
		#-------------------------------------------------------------
		# adiaryǡǤϤʤ  ϤƤʷΥǡ
		if (! $diary{adiary}) { $self->convert_hatena_to_adiary( \%diary, $form ); }

		#-------------------------------------------------------------
		# ղù
		#-------------------------------------------------------------
		my $date = $diary{date};	# 2005-11-22
		$date =~ /(\d+)\-(\d+)\-(\d+)/;
		$diary{year} = $1;
		$diary{mon}  = $2;
		$diary{day}  = $3;
		#-------------------------------------------------------------
		# ǡ¸
		#-------------------------------------------------------------
		$diary{save_pkey} = $form->{adiary_save_pkey};
		if (! $diary_obj->save_diary(\%parser_cache, \%diary, \@comments, \@trackbacks)) {	# ¸
			$imports ++;
		}
	}
	$diary_obj->{exists_diaries} = $#days +1;
	$diary_obj->{import_diaries} = $imports;
	return 0;
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# XML tagǥ
#------------------------------------------------------------------------------
sub tag_dencode_for_xml {
	foreach(@_) {
		$_ =~ s/&amp;/&/g;
		$_ =~ s/&#39;/'/g;
	}
	return $_[0];
}

#------------------------------------------------------------------------------
# ϤƤʷС
#------------------------------------------------------------------------------
sub convert_hatena_to_adiary {
	my ($self, $diary, $option) = @_;

	# ϤƤʸ
	my $style_conv = $option->{Hatena_style_conv};
	my $link_stop  = $option->{Hatena_link_stop};
	my $autolink   = $option->{Hatena_autolink};
	my $p_stop     = $option->{Hatena_p_stop};
	my $pre_end    = $option->{Hatena_pre_end};
	my $f_delete   = $option->{Hatena_f_delete};

	$diary->{parser} = $option->{Hatena_parser} || 'default_p1';	# 1=1
	my @ary = split("\n", $diary->{text});	# ʸ
	my $flag = 1;
	foreach(@ary) {
		if ($p_stop) {	# <p>ߵˡ
			if ($_ =~ /^></) {	# p stop div block
				$_ = ">>>|\n" . substr($_, 1);
			} elsif ($_ =~ /><$/) {	# block end
				chop($_);
				$_ .= "\n|<<<";
			}
		}
		#-------------------------------------
		# ¸Ƥ
		#-------------------------------------
		my @tags;
		$_ =~ s/(<\w([^>"']|[=\s\n]".*?"|[=\s\n]'.*?')*?>)/push(@tags, $1), "<\e$#tags>"/esg;
		#-------------------------------------
		# ˡѴ
		#-------------------------------------
		if ($_ =~ /\w:\w/) {
			# ̿ؤΥ󥯤򥳥ȥ
			if ($f_delete) {
				$_ =~ s/(\[?f:id:[\w:]+\]?)/<!-- $1 -->/g;
			}
			# ϤƤʵˡ֤
			if ($style_conv) {
				# ɽѤĴ
				$_ = " $_";
				$_ =~ s/([^\w:\[])((isbn|asin|jan|ean|question|idea|graph|map):[\w:]+)/$1\[$2\]/ig;
				# x:id:  [hatena:x:id:]
				$_ =~ s/([^\w:\[])(\w:)(id|t|keyword):([\w:]+)/$1\[hatena:$2$3:$4\]/g;
				$_ =~ s/\[(\w:)(id|t|keyword):(.+?)\]/[hatena:$1$2:$3]/g;
				# g:  [hatena:g:]
				$_ =~ s/([^\w:\[])g:([\w:]+)/$1\[hatena:g:$2\]/g;
				$_ =~ s/\[g:(.+?)\]/[hatena:g:$1]/g;
				# id:  [hatena:id:]
				$_ =~ s/([^\w:\[])id:([\w:\#]+)/$1\[hatena:id:$2\]/g;
				$_ =~ s/\[id:(.+?)\]/[hatena:id:$1]/g;
				# [tex:]  [[tex:]]
				$_ =~ s/\[tex:(.*?)\]/[[tex:$1\]\]/g;
				# ᤹
				$_ = substr($_, 1);
			}
			# ư󥯤
			if ($autolink) {
				$_ =~ s|(https?://[\w\.]+/[\w\.\/\%\?\&\~\*\+\-:=]*)|\[$1\]|g;
				$_ =~ s|(mailto:[\w\-\.]+\@[\w\.\-]+)|\[$1\]|g;
			}
		}
		# ưߵˡ
		if ($link_stop) {
			$_ =~ s/\[\](.+?)\[\]/$1/g;
		}
		#  |< ˤ pre ֥åνѴ
		if ($_ ne '|<' && $_ ne '||<' && substr($_, -2) eq '|<') {
			chop($_); chop($_);
			$_ = $_ . "\n|<";
		}
		# ĥѵˡν񤭴
		$_ =~ s|^>(https?://.*?)>|>>[$1]|;
		#  \ Υ
		if (substr($_, -1) eq "\\") { $_ .= " "; }

		#-------------------------------------
		# ǽΥ֥ȥ
		#-------------------------------------
		if ($flag && substr($_, 0, 1) eq '*') {		# ǽsubstitle
			$flag = 0;
			if ($_ =~ /\*(\w*)?\*(?:\[(.*?)\])?(?:\[.*?\])*(.*)/) {
				$diary->{category} = $2;
				$diary->{title}    = $diary->{title} || $3;
				my $tm = int($1);
				if ($tm) { $diary->{tm} = $tm; }
			}
		}
		$_ =~ s/<\e(\d+)>/$tags[$1]/g;
	}
	$diary->{text} = join("\n", @ary);
	return ;
}

1;
