#!/usr/local/bin/perl
require 5.004;
use strict;
#------------------------------------------------------------------------------
# ǡݡ for Movable Type
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
# http://www.sixapart.jp/movabletype/manual/mtimport.html
package Satsuki::Diary::ImportMT;
use Time::Local;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);		# $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ}  = shift;

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}
###############################################################################
# ǡݡ
###############################################################################
#------------------------------------------------------------------------------
# Movable TypeΥǡݡ
#------------------------------------------------------------------------------
sub import {
	my ($self, $diary_obj, $form) = @_;
	my $ROBJ  = $self->{ROBJ};

	# ǡå
	my $data = $form->{import}->{data};
	delete $form->{import};
	my $check_data = substr($data, 0, 1024);
	if ($check_data !~ /DATE:\s+\d\d\/\d\d\/\d\d\d\d\s+\d\d:\d\d:\d\d.*?\n-----\n/s) {
		$ROBJ->message('Data format error (%s)', 'Movable Type');
		return -1;
	}

	# ʸѴ
	if (! $form->{MT_no_jcode}) {
		my $system_coding = $ROBJ->{System_coding};
		my $jcode = $ROBJ->loadpm('Jcode');
		$jcode->from_to(\$data, '', $system_coding);
	}

	my @days = split("\n--------\n", $data);
	undef $data;
	if ($days[$#days] =~ /^[\n\s]*$/s) { pop(@days); }

	# ѹ
	my $change_hour = $form->{MT_change_hour_int};
	my $lf2br       = $form->{MT_lf2br};
	my $lf2br_force = $form->{MT_lf2br_force};
	my $tz          = ($form->{MT_tz} +0) * 3600;
	if ($lf2br eq '') { $lf2br=1; }

	#---------------------------------------------------------------------
	# βϤ¸
	#---------------------------------------------------------------------
	my %parser_cache;
	my $imports = 0;
	foreach my $log (@days) {
		my @ary = split("\n", $log);
		undef $log;
		#-------------------------------------------------------------
		# ɤ߽Ф
		#-------------------------------------------------------------
		my %diary;
		my $convert_breaks = $lf2br;
		my $category;
		while(@ary) {
			my $line = shift(@ary);
			if ($line eq '-----') { last; }	# separetor/block end
			# XXXX: value 
			$line =~ /^([A-Z ]+):\s*(.*)\s*$/;
			my $key = $1;
			my $val = $2;
			if ($key eq '' || $val eq '') { next; }
			# ̽
			if ($key eq 'DATE') {	# եǡ
				$diary{tm} = &date2utc($val, $tz);
				my $h = $ROBJ->time2timehash( $diary{tm}, $change_hour );
				$diary{year} = $h->{year};
				$diary{mon}  = $h->{mon};
				$diary{day}  = $h->{day};
				next;
			}
			# ƥʺͥ襫ƥΤͭ
			if ($key eq 'PRIMARY CATEGORY')               { $category = $val; next; }
			if (!defined $category && $key eq 'CATEGORY') { $category = $val; next; }

			# ¾ե
			if ($key eq 'STATUS' && $val =~ /draft/i)   { $diary{enable} = 0; next; }
			if ($key eq 'STATUS' && $val =~ /publish/i) { $diary{enable} = 1; next; }
			if ($key eq 'AUTHOR') { $diary{name}  = $val; next; }
			if ($key eq 'TITLE')  { $diary{title} = $val; next; }
			# ͥեɽ
			if ($val ne '0' && $val ne '1') { next; }
			if ($key eq 'ALLOW COMMENTS') { $diary{allow_com}=$val; next; }
			if ($key eq 'ALLOW PINGS')    { $diary{allow_tb} =$val; next; }
			if ($key eq 'CONVERT BREAKS') { $convert_breaks  =$val; next; }
			if ($key eq 'NO ENTRY')       { $diary{no_entry} =$val; next; } # not use
		}
		if ($lf2br_force) { $convert_breaks=$lf2br; }	# 
		if (!$diary{tm} || $diary{no_entry}) { next; }	# DATE ʤ or NO ENTRY Υǡ̵
		$diary{category} = $category;

		#-------------------------------------------------------------
		# ʣեɤνʥեɤνиƹޤʤ
		#-------------------------------------------------------------
		my $body;
		my $ex_body;
		my @comments;
		my @trackbacks;
		while(@ary) {
			my $line = shift(@ary);
			if ($line !~ /^([A-Z ]+):\s*$/) { next; }
			my $key = $1;
			# ʸ
			if ($key eq 'BODY')          { $body    = &load_section(\@ary); next; }
			if ($key eq 'EXTENDED BODY') { $ex_body = &load_section(\@ary); next; }
			# 
			if ($key eq 'COMMENT') {
				my %comment;
				while(@ary && $ary[0] =~ /([A-Z ]+):\s*(.+)/) {
					shift(@ary);
					if ($1 eq 'AUTHOR') { $comment{name} = $2; next; }
					if ($1 eq 'EMAIL')  { $comment{email}= $2; next; }
					if ($1 eq 'URL')    { $comment{url}  = $2; next; }
					if ($1 eq 'IP')     { $comment{ip}   = $2; next; }
					if ($1 eq 'DATE')   { $comment{tm}   = &date2utc($2, $tz); next; }
				}
				$comment{text} = join("\n", @{ &load_section(\@ary) });
				if ($comment{name} eq '') { $comment{name}='(no name)'; }
				if ($comment{text} eq '') { next; }	# ʸʤǡ̵
				push(@comments, \%comment);
				next;
			}
			# ȥåХå
			if ($key eq 'PING') {
				my %tb;
				while(@ary && $ary[0] =~ /([A-Z ]+):\s*(.+)/) {
					shift(@ary);
					if ($1 eq 'TITLE')     { $tb{title}     = $2; next; }
					if ($1 eq 'URL')       { $tb{url}       = $2; next; }	# not use
					if ($1 eq 'IP')        { $tb{ip}        = $2; next; }
					if ($1 eq 'BLOG NAME') { $tb{blog_name} = $2; next; }
					if ($1 eq 'DATE')      { $tb{tm}        = &date2utc($2, $tz); next; }
				}
				$tb{excerpt} = join("\n", @{ &load_section(\@ary) });
				if ($tb{url} eq '') { next; }	# URLʤǡ̵
				push(@trackbacks, \%tb);
				next;
			}
			# ɤ뤬 adiary ˳ʤ̤бˤΥե
			if ($key eq 'EXCERPT')  { $diary{execrpt}  = &load_section(\@ary); next; }	# ɤ߼Τ
			if ($key eq 'KEYWORDS') { $diary{keywords} = &load_section(\@ary); next; }	# ɤ߼Τ
			# ¾̤ΤΥեɤɤ߼Τ
			&load_section(\@ary);
		}

		#-------------------------------------------------------------
		# ʸФȥѡ
		#-------------------------------------------------------------
		foreach(@$body)    { $_ =~ s/^====/ ====/; }
		foreach(@$ex_body) { $_ =~ s/^====/ ====/; }
		while(@$body    &&    $body->[    $#$body ] eq '') { pop(@$body);    }
		while(@$ex_body && $ex_body->[ $#$ex_body ] eq '') { pop(@$ex_body); }
		$body    = join("\n", @$body);
		$ex_body = join("\n", @$ex_body);
		if ($body =~ /^\s*$/) { next; }		# ʸʤǡ̵
		if ($ex_body !~ /^\s*$/) {		# ɵ³ɤǽ
			$body .= "\n\n====\n$ex_body";
		}
		# ⡼ɡ
		if ($convert_breaks) { $diary{parser} = 'simple_p'; }
				else { $diary{parser} = 'simple';   }
		# ѿ˳Ǽ
		$diary{text} = $body;
		$body = $ex_body = undef;

		#-------------------------------------------------------------
		# ǡ¸
		#-------------------------------------------------------------
		if (! $diary_obj->save_diary(\%parser_cache, \%diary, \@comments, \@trackbacks)) {	# ¸
			$imports ++;
		}
	}
	$diary_obj->{exists_diaries} = $#days +1;
	$diary_obj->{import_diaries} = $imports;
	return 0;
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# Movable Typeեǡ UTC Ѵ
#------------------------------------------------------------------------------
#	MM/DD/YYYY hh:mm:ss
#	MM/DD/YYYY hh:mm:ss AM/PM
sub date2utc {
	my $date = shift;
	my $tz   = shift;
	if ($date !~ /^(\d\d)\/(\d\d)\/(\d\d\d\d) (\d\d):(\d\d):(\d\d)\s*(\w*)/) { return ; }
	my $mon  = $1;
	my $day  = $2;
	my $year = $3;
	my $hour = $4;
	my $min  = $5;
	my $sec  = $6;
	if ($7 && $hour == 12) { $hour=0; }
	if (uc($7) eq 'PM') { $hour += 12; }
	return (Time::Local::timegm($sec,$min,$hour,$day,$mon-1,$year) - $tz);
}
#------------------------------------------------------------------------------
# -----פǶڤ줿νޤǥ
#------------------------------------------------------------------------------
sub load_section {
	my $ary = shift;
	my @section;
	while(@$ary) {
		my $data = shift(@$ary);
		if ($data eq '-----') { last; }
		push(@section, $data);
	}
	if ($section[ $#section ] eq '') { pop(@section); }	# ǸζԤڤΤ
	return \@section;
}


1;
