use 5.6.0;
use strict;
#------------------------------------------------------------------------------
# Υ᡼빹ѥ⥸塼
#						(C)2007 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::Diary::Mail_post;
our $VERSION = '1.00';
#------------------------------------------------------------------------------
use Fcntl;	# for sysopen
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ}      = shift;
	$self->{list_file} = shift;
	$self->{auth_hours} = 2;
	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ᥤ롼
###############################################################################
#------------------------------------------------------------------------------
# ᡼빹Υᥤ
#------------------------------------------------------------------------------
sub main {
	my ($self) = @_;
	my $ROBJ = $self->{ROBJ};

	# pop ⡼
	if ($self->{pop_mode}) {
		return $self->output_html("mail/do_pop");
	}
	# pop ⡼ɰʳ HTTP 
	if (exists $ENV{REQUEST_METHOD}) {
		return $self->output_html("mail/not_pop_mode");
	}
	
	# ᡼ stdin 
	my $max_size = $self->{max_size} || 0x100000;	# 1MB default
	my $size = 0;
	my @ary;
	while(1) {
		my $x = <STDIN>;
		push(@ary, $x);
		$size += length($x);
		if ($x eq '' || $size > $max_size) { last; }
	}
	return $self->one_mail( \@ary );
}

#------------------------------------------------------------------------------
# skelton νȽ
#------------------------------------------------------------------------------
sub output_html {
	my ($self, $skelton) = @_;
	my $ROBJ = $self->{ROBJ};

	my $out = $ROBJ->call( $skelton );
	$ROBJ->print_content_type("text/html");
	$ROBJ->output_array($out);      # HTML
}

#------------------------------------------------------------------------------
# ᡼popƼ
#------------------------------------------------------------------------------
sub do_pop {
	my ($self) = @_;
	my $ROBJ = $self->{ROBJ};

	# եǧ
	my $fh;
	my $file = $ROBJ->get_filepath( $self->{pop_log_file} );
	if (! sysopen($fh, $file, O_CREAT | O_WRONLY | O_APPEND) ) {
		$ROBJ->message("File can't open for lock '%s'", $file);
	}
	chmod($ROBJ->{File_mode}, $file);
	if (flock($fh, 6) == 0) {
		$ROBJ->message("Now mail checking");
		close($fh); return -1;
	}
	my $r = $self->_do_pop();
	# ̤εϿ
	if ($r) {
		print $fh "$ROBJ->{Timestamp} pop fail (" . join('',@{$ROBJ->{Message}}) . ")\n";
	} else {
		print $fh "$ROBJ->{Timestamp} pop success ($self->{count} mails)\n";
	}
	close($fh);
	return $r;
}

sub _do_pop {
	my ($self) = @_;
	my $ROBJ = $self->{ROBJ};

	# POP⥸塼θƤӽФ
	eval { require Net::POP3;  };
	if ($@) { $ROBJ->message("Can't load 'Net::POP3' module."); return 1; }

	# Ф³
	my $pop = Net::POP3->new( $self->{pop_host}, Timeout => 10 );
	if (!$pop) { $ROBJ->message("Connection failed : $self->{pop_host}"); return 2; }

	# user / pass;
	my $r;
	if ($self->{pop_mode} eq 'apop') {
		$r = $pop->apop($self->{pop_user}, $self->{pop_pass});
	} else {
		$pop->user( $self->{pop_user} );
		$r = $pop->pass( $self->{pop_pass} );
	}
	if (!$r) { $ROBJ->message("User/Password error"); return 3; }

	# ᡼
	my $count = 0;
	my $list = $pop->list();
	my @keys = sort { $a <=> $b } keys(%$list);
	my $max_size = $self->{max_size} || 0x100000;	# 1MB default
	foreach(@keys) {
		my $size = $list->{$_};
		if ($size <= $max_size) {	# 礭᡼̵
			my $ary = $pop->get($_);
			# ĤΥ᡼
			$self->one_mail( $ary );
			$count++;
		}
		# ᡼
		$pop->delete($_);
	}
	$pop->quit();
	$self->{count} = $count;
	return 0;
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# ̤Υ᡼
#------------------------------------------------------------------------------
sub one_mail {
	my $self = shift;
	my $ary  = shift;
	my $ROBJ = $self->{ROBJ};
	my $Diary    = $ROBJ->{Diary};
	my $mail_obj = $ROBJ->loadpm("Base::Mail");
	if ($self->{debug}) { $mail_obj->{debug}=1; }

	# ᡼β
	my $mail = $mail_obj->parse_mail($ary);
	my $from = $mail->{from_address};
	my $text = $mail->{text} || $mail->{html};
	$text =~ s/\r\n/\n/g;
	$text =~ s/[\x00-\x08\x0b\x0c\x0e-\x1f\x7f]//g;
	if ($from eq '') { return 2; }

	# 顼᡼롩ʤ̵
	if ($from =~ /MAILER.*DAEMON/i) { return -1; }

	# ǧ⡼ɡ
	my $auth_string = $ROBJ->message_translate('mail-auth');
	my $text2 = $text;
	$text2 =~ s/^(.*?)\n.*/$1/s;	# ǽΣ
	$text2 =~ s/\s//g;		# 
	if (length($text)<300 && $text2 eq $auth_string) {	# ֥᡼뾵ǧפʸ
		return $self->mail_address_auth($from);
	}

	# ᡼ư
	my $regist_list = $ROBJ->fread_hash_cached($self->{list_file});
	my $diary_id = $regist_list->{$from};	#  Ģ
	my $DB       = $ROBJ->{DB};
	if ($diary_id eq '' || !$DB->find_table("${diary_id}_diary")) {
		my $msg = $ROBJ->message_translate('Not registered mail address : %s', $from);
		if ($self->{debug}) { print "[Mail_post.pm] $msg\n"; }
		$ROBJ->call("mail/send_error_message", $from, $msg);
		return 3;
	}
	if ($self->{debug}) { print "[Mail_post.pm] diary_id = $diary_id\n"; }

	# 񤭹ߥѥɤγǧ
	my $set  = $Diary->load_daybook_setting($diary_id);
	my $pass = $set->{write_pass};
	$text =~ s/^(.*?)\n//s;		# ǽιԤ
	if ($1 ne $pass) {
		if ($self->{debug}) { print "[Mail_post.pm] write pass error. '$1' ne '$pass'\n"; }
		$ROBJ->call("mail/send_pass_error", $from);
		return 4;
	}

	# 񤭹դ᡼إåpop_modeΤߡ
	my $date = $mail->{date};
	my %now  = %{ $ROBJ->{Now} };
	if ($self->{pop_mode} &&
	    $date =~ /\w\w\w, (\d\d?) (\w\w\w) (\d\d\d\d) (\d\d):(\d\d):(\d\d)(?: ([\+\-])(\d\d)(\d\d))?/) {
		my $mon = int(index('JanFebMarAprMayJunJulAugSepOctNovDec', $2)/3);
		$now{year}=$3; $now{mon}=$mon+1; $now{day}=$1;
		$now{hour}=$4; $now{min}=$5;     $now{sec}=$6;
		require Time::Local;
		my $gmt=Time::Local::timegm($6,$5,$4,$1,$mon,$3-1900);
		my $tz =($8*3600+$9*60)*($7 eq '+' ? 1:-1);
		$Diary->{tm} = $gmt - $tz;
	}

	# źղν
	$Diary->set_and_select_daybook( $diary_id );
	my $uploader = $ROBJ->{Uploader};
	my $attaches  = $mail->{attaches} || [];
	if (defined $uploader && @$attaches) {
		$ROBJ->{Pinfo} = [sprintf("%04d%02d", $now{year}, $now{mon} )];
		$uploader->initalize( $diary_id );		# ɬ Pinfo θ
		$uploader->make_currentfolder();
		# źղ
		my $allow_ex = $uploader->{allow_ex};
		my @inserts;
		foreach(@$attaches) {
			if ($_->{content_type} !~ /image/) { next; }
			my $filename = $_->{filename};
			$filename =~ tr|\\|/|;
			if ($filename =~ /\/([^\/]*)$/) { $filename = $1; }
			$filename =~ s/[\r\n\x00\"]//g;
			# ĥҥå
			my $file_ex;
			my $image_ex = $self->{image_files};
			if ($filename =~ /\.(\w+)$/) { $file_ex=$1; }
			$file_ex =~ tr/A-Z/a-z/;
			if (! grep { $file_ex eq $_ } @$image_ex ) { next; }
			# ե̾ν񤭴
			if ($set->{mail_file_rename}) {
				$filename = sprintf("%04d%02d%02d-%02d%02d%02d_%d",
							$now{year}, $now{mon}, $now{day},
							$now{hour}, $now{min}, $now{sec}, $#inserts+1) . ".$file_ex";
				if ($self->{debug}) { print "[Mail_post.pm] write filename : $filename\n"; }
			}
			# åץɤ
			my %file;
			$file{data} = $_->{data};
			$file{file_name} = $filename;
			$file{file_size} = length($_->{data});
			my %ret;
			my $r = $uploader->do_upload( \%file, \%ret );
			if ($self->{debug}) { print "[Mail_post.pm] upload $filename (ret:$r)\n"; }
			if (! $r) {
				push(@inserts, $ret{tag});
			} elsif ($r==10) {
				# Ʊ̾ե뤬綯͡ह
				$filename = sprintf("%04d%02d%02d-%02d%02d%02d_%d",
							$now{year}, $now{mon}, $now{day},
							$now{hour}, $now{min}, $now{sec}, $#inserts+1) . ".$file_ex";
				if ($self->{debug}) { print "[Mail_post.pm] samefile, rename : $filename\n"; }
				$file{file_name} = $filename;
				$r = $uploader->do_upload( \%file, \%ret );
				if ($self->{debug}) { print "[Mail_post.pm] upload $filename (ret:$r)\n"; }
				if (! $r) {
					push(@inserts, $ret{tag});
				} else {
					push(@inserts, "<!-- Ʊ̾Υե뤬ޤ : $filename -->");
				}
			}
		}
		# 
		my $image_string = $ROBJ->message_translate('image-insert');
		$text =~ s/$image_string/ pop(@inserts) /eg;
		if (@inserts) {
			my $tags =  join(' ', @inserts) . "\n";
			if ($set->{mail_image_under}) {
				if (substr($text, -1) ne '\n') { $tags="\n$tags"; }
				$text .= $tags;
			} else {
				$text = $tags . $text;
			}
		}
	}
	if ($self->{debug}) { print "[Mail_post.pm] text = $text\n"; }

	# 񤭹߽
	if (exists $mail->{x_mailer}) {
		$ENV{HTTP_USER_AGENT} = $mail->{x_mailer};
		$ROBJ->tag_escape( $ENV{HTTP_USER_AGENT} );
	}
	if (!defined $Diary->{myself}) {
		$Diary->{myself} = $Diary->{myself2} = $Diary->get_daybook_url( $diary_id );
		if ($Diary->{subdomain_mode} eq '') { $Diary->{server_url} = $ROBJ->{Server_url}; }
	}
	
	$Diary->{exsits_daybook} = 1;
	$Diary->{phone_mode}     = 1;
	my %form;
	$form{title}    = $mail->{subject};
	$form{category} = $set->{phone_dafault_category};
	$form{parser}   = $set->{phone_parser} || $set->{parser};
	foreach(keys(%form)) {
		$form{$_} =~ s/[\x00-\x08\x0a-\x1f\x7f]//g
	}
	$form{body_txt} = $text;
	# 񤭹ߥơʥե饰
	my $set = $Diary->{daybook_setting};
	foreach(qw(enable allow_com allow_hcom allow_tb disp_ref)) {
		if (!exists $form{$_}) { $form{$_}=$set->{$_}; }	# default
	}
	# 񤭹߽
	my $r = $Diary->diary_edit( \%form, "force_write", 1);	# 1=force write flag
	if ($r) {	# 
		$ROBJ->call("mail/send_error_message", $from, "diary_write() error : $r");
		return $r;
	}
	# 
	if ($set->{mail_send_success}) {
		$ROBJ->call("mail/send_post_success", $from);
	}
	return 0;
}


###############################################################################
# ᡼빹
###############################################################################
#------------------------------------------------------------------------------
# ᡼빹ѤΥɥ쥹
#------------------------------------------------------------------------------
sub get_mail_address_list {
	my ($self, $diary_id, $list_file) = @_;
	my $ROBJ = $self->{ROBJ};
	my $file = $self->{list_file};

	$diary_id =~ s/\W//g;
	if ($diary_id eq '') { return []; }

	# ꥹȤ᡼륢ɥ쥹õ
	my $h = $ROBJ->fread_hash_no_error($file);
	my @list;
	foreach(keys(%$h)) {
		if ($h->{$_} ne $diary_id) { next; }
		my ($address, $tm) = split('#', $_);
		if ($tm && $tm < $ROBJ->{TM}) { next; }		# ڤ
		push(@list, {address => $address, tm => $tm});
	}
	return \@list;

}

#------------------------------------------------------------------------------
# ᡼빹ѤΥɥ쥹Ͽ
#------------------------------------------------------------------------------
sub mail_address_edit {
	my ($self, $diary_id, $regist_address, $delete_list) = @_;
	my $ROBJ = $self->{ROBJ};
	my $file = $self->{list_file};

	$diary_id =~ s/\W//g;
	if ($diary_id eq '') { return 1; }
	if ($file eq '') { return -1; }

	# ᡼륢ɥ쥹ǧ
	$regist_address =~ s/\s//g;
	if ($regist_address ne '' && $regist_address !~ /^[\w\-\.]+\@(?:[\w\-]+\.)+[\w\-]+$/) {
		$ROBJ->message("Mail address format error (%s)", $regist_address);
		$regist_address = undef;
	}
	my %del_hash;
	map { $del_hash{$_}=1 } @$delete_list;

	# եԽ
	my $regist = 0;
	my $delete = 0;
	my ($fh, $h) = $ROBJ->fedit_readhash($file);
	foreach(keys(%$h)) {
		my ($address, $tm) = split('#', $_);
		# ڤκ
		if ($tm && $tm < $ROBJ->{TM}) {
			delete $h->{$_};
			next;
		}
		if ($h->{$_} ne $diary_id) { next; }
		# Ͽѡ
		if (!$tm && $address eq $regist_address) {
			$ROBJ->message("Mail address already registed (%s)", $regist_address);
			$regist_address=undef;
		}
		# 
		if ($del_hash{$address} || $address eq $regist_address) {
			delete $h->{$_};
			$delete++;
		}
	}
	# ɲ
	if ($regist_address ne '') {
		my $tm = $ROBJ->{TM} + $self->{auth_hours}*3600;
		$h->{"$regist_address#$tm"} = $diary_id;
		$regist = 1;
		# ǧѥ᡼
		$ROBJ->call('mail/send_regist_check', $diary_id, $regist_address);
	}
	$ROBJ->fedit_writehash($file, $fh, $h);
	# 
	$self->{regist} = $regist;
	$self->{delete} = $delete;
	return 0;
}

#------------------------------------------------------------------------------
# ᡼빹ѤΥɥ쥹ξǧ
#------------------------------------------------------------------------------
sub mail_address_auth {
	my ($self, $auth_address) = @_;
	my $ROBJ = $self->{ROBJ};
	my $file = $self->{list_file};

	# եԽ
	my $diary_id;
	my ($fh, $h) = $ROBJ->fedit_readhash($file);
	my %authed;
	foreach(keys(%$h)) {
		my ($address, $tm) = split('#', $_);
		if ($address eq $auth_address) {
			if ($tm > $ROBJ->{TM}) {
				$diary_id = $h->{$_};
				$authed{$address} = $diary_id;	# Ͽ
			}
			delete $h->{$_};		# Ͽκ
		}
	}
	$ROBJ->into($h, \%authed);	# %$h  %authed copy
	
	# ̤¸λ
	if ($diary_id eq '') {
		$ROBJ->fedit_exit($file, $fh);
		$ROBJ->call('mail/send_regist_check_error', $auth_address);
		return 1;
	}
	# ǧ
	$ROBJ->fedit_writehash($file, $fh, $h);
	# ϿΥ᡼
	$ROBJ->call('mail/send_registed', $diary_id, $auth_address);
	return 0;
}

1;
