#!/usr/local/bin/perl
require 5.004;
use strict;
#-------------------------------------------------------------------------------
# Split from Satsuki::Diary.pm for AUTOLOAD.
#-------------------------------------------------------------------------------
use Satsuki::Diary ();
package Satsuki::Diary;
our $DAYBOOKLIST_TABLE = '_daybooklist';
###############################################################################
# ɽϢ - skelton롼
###############################################################################
#------------------------------------------------------------------------------
# ȡȥåХåΥꥹ
#------------------------------------------------------------------------------
# ȵġ1 => ïǤ, 2 => Խ¼ԤΤ
my %sort_diary_allow = ( enable => 2, ip => 2, tm => 1, id => 1, name => 1,
	category => 1, yyyymmdd => 1, update_tm => 1, pkey => 1, title => 1,
	comments => 1, tbs => 1, comments_all => 2, tbs_all => 2 );
my %sort_comment_allow = ( enable => 2, ip => 2, tm => 1, id => 2, name => 1,
	hidden => 2, diary_pkey => 1, diary_yyyymmdd => 1, agent => 2 );
my %sort_trackback_allow = ( enable => 2, ip => 2, tm => 1, author => 1,
	agent => 1, author => 1, blog_name => 1 );
#
sub load_list {
	my ($self, $h, $diary_id) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	$diary_id =~ s/\W//g;
	if ($diary_id eq '' && !$self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 1; }
	# åե饰
	my $cache_flag = $h->{cache_on};
	my $allow_edit = $self->{allow_edit};

	#  or  or ȥåХå
	$diary_id ||= $self->{diary_id};
	my $diary_table = $diary_id . '_diary';
	my $type  = $h->{type};
	my $table;
	my $sort_check;
	if ($type eq 'comment')   { $table = $diary_id . '_comment'; $sort_check = \%sort_comment_allow; }
	if ($type eq 'trackback') { $table = $diary_id . '_tb';      $sort_check = \%sort_trackback_allow; }
	if (!defined $table)      { $table = $diary_table;           $sort_check = \%sort_diary_allow; }

	# ³ǧ
	my %db;
	my $sort = $h->{sort};
	$sort =~ s/\W//g;
	if (! $allow_edit) {
		$db{flag} ||= $h->{flag} || {};
		$db{flag}->{enable} = 1;
		if ($sort_check->{$sort} != 1) { $sort=''; }
	} else {
		if ($h->{flag}) { $db{flag} = $h->{flag}; }
		if (! $sort_check->{$sort})    { $sort=''; }
	}

	# 
	if (!defined $h->{sort_reverse}  || $h->{sort_reverse})  { $db{sort_reverse} =1; }
	if (!defined $h->{sort2_reverse} || $h->{sort2_reverse}) { $db{sort2_reverse}=1; }
	if ($sort ne '') { $db{sort} = $sort; $db{sort2} = 'tm'; }
		else     { $db{sort} = 'tm'; }

	# IDꡩ
	my $id = $h->{id};
	$id =~ s/\W//g;
	if ($id ne '') {
		$db{match_str} = {id => $id};
	}

	# ƥꡩ
	my $category = $h->{category};
	if ($category ne '') {
		if (index($category, '::') >=0) {
			if (substr($category,-2) eq '::') { chop($category); chop($category); }	
			$db{match_str} = {category => $category};		# ƥ긡
		} else {
			$db{match_str} = {category_main => $category};	# ƥ긡
		}
	}

	# ǯ
	my $ym = $h->{yyyymm};
	if (197000<$ym && $ym<999999) {
		$db{min} = {yyyymmdd => "${ym}01"};
		$db{max} = {yyyymmdd => "${ym}31"};
	}
	$db{limit}  = $h->{limit};
	$db{offset} = $h->{offset};
	$db{require_hits} = 1;		# 
	if ($cache_flag) { $db{cache} = 1; }
	my $logs = $DB->select($table, \%db);
	$h->{hits} = $db{hits};		# 

	#  or ΤȤʸǡ
	# ޤղù
	my %d;
	my $newest_tm;
	my $newest_title;
	my $yyyymmdd_col = (($type eq 'diary') ? 'yyyymmdd' : 'diary_yyyymmdd');
	foreach(@$logs) {
		if ($newest_tm < $_->{tm}) { $newest_tm=$_->{tm}; $newest_title=$_->{title}; }
		my $yyyymmdd = $_->{$yyyymmdd_col};
		$_->{year} = substr($yyyymmdd, 0, 4);
		$_->{mon}  = substr($yyyymmdd, 4, 2);
		$_->{day}  = substr($yyyymmdd, 6, 2);
		if ($type eq 'diary') {
			$_->{elink_key} = $_->{link_key};
			$self->link_key_encode($_->{elink_key});
		}
	}
	# ǿ
	$h->{newest_tm}    = $newest_tm;
	$h->{newest_title} = $newest_title;
	return $logs;
}

#------------------------------------------------------------------------------
# ĢꥹȤ
#------------------------------------------------------------------------------
sub load_daybook_list {
	my ($self, $sort) = @_;
	my $ROBJ = $self->{ROBJ};
	$sort =~ s/\W//g;
	if ($sort eq '') { $sort='diary_tm'; }

	my %h;
	$h{sort} = $sort;
	$h{no_error} = 1;
	if ($sort ne 'id')       { $h{sort_reverse} = 1; }
	if ($sort ne 'diary_tm') { $h{sort2} = 'diary_tm'; $h{sort2_reverse} = 1;}
	if ($sort eq 'diary_tm') { $h{cache} = 1; }
	if (! $ROBJ->{Auth}->{admin}) { $h{flag} = {hidden => 0}; }

	my $daybooks = $ROBJ->{DB}->select($DAYBOOKLIST_TABLE, \%h);

	my $domain = $self->{subdomain_mode};
	my $myself2 = $self->{phone_mode} ? $ROBJ->{Myself2p} : $ROBJ->{Myself2};
	foreach(@$daybooks) {
		if ($_->{id} eq $self->{single_mode}) {
			$_->{url}  = $myself2;
		} elsif ($domain) {
			$_->{url}  = "http://$_->{id}.$domain/" . $self->{phone_query};
		} else {
			$_->{url}  = $myself2 . "$_->{id}/";
		}
	}
	$self->{daybooks} = $#$daybooks +1;
	return $daybooks;
}

#------------------------------------------------------------------------------
# ƥꥹȤμ
#------------------------------------------------------------------------------
sub load_category_name_list {
	my ($self) = @_;
	my $ROBJ = $self->{ROBJ};
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return []; }
	my $set = $self->{daybook_setting};
	my $name_list = $set->{category_name_list};
	# if ($name_list eq '') { $ROBJ->message('Category does not exist'); return ; }
	if ($name_list eq '') { return []; }

	my $categories = [ split(/\n/, $name_list) ];
	my $diaries    = $set->{diaries};
	my @lines;
	my $search_base = "$self->{myself2}&amp;category?cat=";
	my @ary;
	foreach(@$categories) {
		my ($category, $option) = split("\t", $_, 2);
		if ($option eq '') { next; }
		my ($ecount, $c_level, $ohter_rss, $count) = split("=", $option);
		my %h;
		$h{category} = $category;
		$h{ecount}   = int($ecount);
		$h{count}    = int($count);
		$h{level}    = $c_level;
		$h{orss}     = $ohter_rss;
		# if ($count==0) { next; }	# ƥƥΤ

		# ƥ곬ؤʬ
		my $x = index($category, '::');
		my $category_main = $category;
		my $category_sub  = '';
		if ($x>=0) {
			$category_main = substr($category, 0, $x);
			$category_sub  = substr($category, $x+2);
		} else {
			$category     .= '::';		# ׻
		}
		$h{category_main}     = $category_main;
		$h{category_sub}      = $category_sub;
		$ROBJ->form_encode($category, $category_main);
		$h{category_uri}      = $search_base . $category;
		$h{category_main_uri} = $search_base . $category_main;

		push(@ary, \%h);	# execute
	}
	return \@ary;
}

#------------------------------------------------------------------------------
# ƥĥꥹȤμ
#------------------------------------------------------------------------------
sub load_contents_keylist {
	my $self  = shift;
	my $bound = shift || ' - ';
	my $invaild = shift;	# ۴ĻɻѤμʥ
	my $max_level = shift;
	if ($max_level eq '') { $max_level=999; } else { $max_level--; }
	my $ROBJ = $self->{ROBJ};
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return []; }
	my $set = $self->{daybook_setting};

	my @list;
	my $prev;
	my $len=$max_level;
	foreach( split(',', $set->{contents_keylist}) ) {
		$_ =~ s/^(\t*)//;
		my $level = length($1);
		if ($level > $len) { next; }
		$len = $max_level;
		my ($key, $name) = split("\t", $_, 2);
		if ($invaild ne '' && ($key eq $invaild)) { $len=$level; next; }
		if ($1 ne '') { $name = " " . $name; }
		push(@list, {key => $key, name => ($bound x $level) . $name, level => $level+1});
	}
	return \@list;
}

#------------------------------------------------------------------------------
# åץURLμ
#------------------------------------------------------------------------------
sub get_uploader_url {
	my $self = shift;
	my $url  = shift;
	my $now = $self->{now};
	my %h;
	$h{'Y'} = shift;
	$h{'m'} = shift;
	$h{'d'} = shift;
	$h{'i'} = $self->{diary_id};
	$h{'%'} = '%';
	$url    =~ s/\%(\w)/$h{$1}/g;
	if (index($url, ':')<0 && substr($url, 0, 1) ne '/'  ) {
		$url = $self->{ROBJ}->{Basepath} . $url;
	}
	return $url;
}

###############################################################################
# ԽɮϢ - skelton롼
###############################################################################
#------------------------------------------------------------------------------
# 񤯡Խ
#------------------------------------------------------------------------------
sub diary_edit {
	my ($self, $form, $write_pass, $force_write) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 12; }
	# 񤭹߸³ǧ
	my $diary_id = $self->{diary_id};
	my $setting  = $self->{daybook_setting};
	my $editor_mode;
	# 񤭹ߥѥɥ⡼
	if ($write_pass ne '') {
		if ($force_write || $write_pass eq $setting->{write_pass}) {
			my $a = $auth->get_userinfo( $diary_id );
			if (!$a && $setting->{write_id} ne '') {
				$a = $auth->get_userinfo( $setting->{write_id} );
			}
			$auth = $a;
		}
		if ($auth->{id} eq '') { $ROBJ->message('Operation not permitted'); return 25; }
	} else {
		if (! $auth->{ok})         { $ROBJ->message('Not login');               return 31; }
		if (! $self->{allow_edit}) { $ROBJ->message('Operation not permitted'); return 35; }
		$editor_mode = $self->{allow_edit} && !$self->{daybook_admin};
	}

	my $now      = $ROBJ->{Now};
	my $year     = $form->{year_int} || $self->{now}->{year};
	my $mon      = $form->{mon_int}  || $self->{now}->{mon};
	my $day      = $form->{day_int}  || $self->{now}->{day};
	my $title    = $form->{title};
	my $category = $form->{category};
	my $text     = $form->{body_txt};
	my $files    = $form->{files};
	$ROBJ->{Message_flag} = 0;	# åե饰ν

	my $err = $self->check_date($year, $mon, $day);
	if ($err ne '') { $ROBJ->message($err); }

	# ե饰å
	#   -->ѹ Diary/Mail_post  one_mail ѹ뤳
	my %diary;
	my @flags = qw(enable allow_com allow_hcom allow_tb disp_ref);
	foreach(@flags) {
		my $f = $form->{$_};
		if ($f) { $f=1; } else { $f=0; }
		$diary{$_} = $f;
	}

	# ϥǡå
	$ROBJ->tag_escape($title, $category);
	$category =~ s/^\s*(.*?)\s*$/$1/;	# ζ
	$category =~ s/\t/ /g;			# tabspaceִ

	if ($title =~ /^\s*$/) {	# ȥ뤬ʤ硢ȥդˤ
		$title = sprintf(" %04d-%02d-%02d", $year, $mon, $day);
		# $ROBJ->message('Title is empty');
	}
	$text =~ s/^(.*?)(?:\r\n|\n)*$/$1/s;	# βԤ
	# if ($diary{enable} && $text =~ /^\s*$/)  { $ROBJ->message('Main text is empty'); }
	if ($category eq '')   { $category = $self->{default_category}; }

	# Х롦ӸΥù
	if ($ROBJ->{Is_mobile} || $self->{phone_mode}) {
		$text =~ s|\?\?(\w.*?)\?\?|
			my $x=$1; $x =~ tr/!/:/; "[[$x]]"
			|eg;
		$text =~ s|\?(\w.*?)\?|
			my $x=$1; $x =~ tr/!/:/; "[$x]"
			|eg;
	}

	# ƥβ
	my ($category_main, $category_sub) = split(/\s*::\s*/, $category, 2);
	if ($category_sub eq '') { $category = $category_main; }
	$diary{category}      = $category;
	$diary{category_main} = $category_main;

	# ŤƤ
	my $edit_pkey  = $form->{edit_pkey_int};
	my $table_name = "${diary_id}_diary";
	my $pkey       = $edit_pkey;
	my $old = {};
	if ($edit_pkey) {
		my %d;
		$d{match_int} = {pkey => $edit_pkey};	# 
		$d{limit}     = 1;
		$old = $DB->select($table_name, \%d);
		if ($#$old < 0) { $ROBJ->message("Can't find the diary (%d)", $edit_pkey); return 10; }
		$old = $old->[0];

		# ¾ͤεԽǤʤ⡼ɽ
		if ($setting->{edit_self_only} && $editor_mode && $auth->{id} ne $old->{id}) {
			$ROBJ->message('Operation not permitted');
			return 36;
		}
	}

	# ͥwiki flag
	$diary{priority} = int( $form->{priority_int} );
	if ($diary{priority}<0) { $diary{priority}=0; }

	# wikiϢѹʤfor ӥڡ
	if ($form->{wiki_no_change}) {
		if ( $old->{pkey} ) {	# 쵭롩
			$diary{priority} = $old->{priority};
			$diary{link_key} = $old->{link_key};
			$diary{upnode}   = $old->{upnode};
		}

	} elsif ($diary{priority}) {
		# link_key/upnode 
		my $link_key = $form->{link_key};
		my $upnode   = $form->{upnode};
		# ζ
		$upnode =~ s/[\"\',]/_/g;
		$upnode =~ s/^\s*(.*?)\s*$/$1/;
		if ($link_key eq '') {
			$link_key = $form->{title};
			$link_key =~ s/[\"\',&]/_/g;
			$link_key =~ s/[\t]/ /g;	# TAB to Space
		}
		$link_key =~ s/^\s*(.*?)\s*$/$1/;
		if ($link_key =~ m%^(?:http:|https:|ftp:|/)%) { $link_key = " $link_key"; }

		# üʸ
		if ($link_key =~ /^[\"\',]/) {
			$ROBJ->message('Can not use character "%s" in content key', '\"\',');
		} elsif ($link_key =~ /^\s*$/) {
			$ROBJ->message('Content key is empty');
		} elsif ($link_key =~ m|^[\d&]|) {
			$ROBJ->message('Content key is not allow "%s" as first character', '0-9');
		}
		# link_key νʣ
		my %h;
		my @ary = split(/,\s*/, $setting->{contents_keylist});
		foreach( @ary ) {
			if ($_ =~ /^(.*?)\t/) { $h{$1}=1; }
		}
		$h{tb}=1;
		delete $h{ $old->{link_key} };	# εεkey
		my $i="";
		while ($h{"$link_key$i"}) { $i++; if ($i==1) { $i++; }; }
		$i && ($link_key .= "$i");
		# ʣ
		if ($h{$link_key}) { $link_key=$upnode=undef; $diary{priority}=0; }

		if ($upnode eq $link_key) { $upnode=""; }	# ʻȶػ
		$diary{link_key} = $link_key;
		$diary{upnode}   = $upnode;
		$self->{edit_link_key} = $link_key;
	} else {
		$diary{link_key} = undef;	#  "0$pkey" 
		$diary{upnode}   = undef;
	}

	# 顼
	if ($ROBJ->{Message_flag}) { return 2; }	# 顼ä


	# źեեå
	$diary{files} = '';
	if ($self->{allow_attach_files} && $files ne ''){
		my ($file, $size) = split(/\s*\,\s*/, $files);
		$file =~ s/%([0-9a-fA-F][0-9a-fA-F])/chr(hex($1))/eg;
		$ROBJ->uri_encode($file);
		my $file_ex  = substr($file, rindex($file, ".")+1);	# ĥ
		my $allow_ex = $ROBJ->fread_hash_cached( $self->{allow_attach_files} );
		$size = int($size);
		if ($allow_ex->{$file_ex} && $size > 0) {
			$diary{files} = "$file, $size, $allow_ex->{$file_ex}";
		}
	}

	$diary{yyyymmdd} = sprintf("%04d%02d%02d", $year, $mon, $day);
	$diary{title}    = $title;
	# Ƚ
	my $first_visible;
	my $keytb_list;
	if ($diary{enable} && (!$edit_pkey || !$old->{update_tm})) { $first_visible=1; }
	if ($first_visible && $form->{key_send_tb}) { $keytb_list=[]; }

	# ѡΥ
	my $parser = $form->{parser};
	$parser =~ s/\W//g;
	my $parser_dir = $self->{parser_skelton_dir};
	$ROBJ->call( $parser_dir . $parser );
	my $parser_obj = $self->{parser};	# ɤѡΥ֥
	if (! ref($parser_obj)) {		# Ԥ exit
		$ROBJ->message("Load parser '%s' failed", $parser);
		return 3;
	}
	# ץץåʸùץå˸ƤӽФ
	if ($parser_obj->{use_preprocessor} && $text ne '') {
		$parser_obj->preprocessor( \$text, $keytb_list );
	}
	$diary{parser}  = $parser;
	$diary{text}    = '---this is dummy---';
	$diary{_text}   = $text;	# parse Υƥ
	if ($text eq '') { $diary{_text}=$text=' '; }
	# 󥯥ƥġʳȥƥġ
	if (ord($diary{link_key}) == 0x20) {
		$text = $diary{link_key};
		$text =~ s/^ (?:http:)?//i;
		$text = "[http:$text]";
	}

	# 񤭹߽
	if (! $edit_pkey) {	# 񤭹
		$diary{tm}    = $self->{tm};
		$diary{name}  = $auth->{name};
		$diary{id}    = $auth->{id};
		$diary{ip}    = $ENV{REMOTE_ADDR};
		$diary{host}  = $ENV{REMOTE_HOST};
		$diary{agent} = $ENV{HTTP_USER_AGENT};
		$diary{comments} = $diary{comments_all} = 0;
		$diary{tbs}      = $diary{tbs_all}      = 0;
		$pkey = $DB->insert($table_name, \%diary);
		if (!$pkey) { $ROBJ->message('Diary post failed'); return 9; }
	}
	# pkey¸
	$self->{edit_pkey} = $pkey;
	# link_key ι
	if (! $diary{priority}) { $diary{link_key} = "0$pkey"; }
	my $elink_key = $diary{link_key};
	$self->link_key_encode( $elink_key );
	$self->{elink_key} = $elink_key;	# for skelton

	# URL (diary_pkey) 塢ѡ̤ƽԤ
	if ($text ne ' ') {
		if (ref($parser_obj) ne 'HASH') { 
			$parser_obj->{thispkey} = $pkey;
			$parser_obj->{thisurl}  = $self->{myself2} . $elink_key;
			$parser_obj->{thisyear} = $year;
			$parser_obj->{thismon}  = $mon;
			$parser_obj->{thisday}  = $day;
			$parser_obj->{thistm}   = $diary{tm};
			$text = $parser_obj->text_parser( $text );
		}
		# ĥʳν
		if ($self->{diary_allow_tags}) {
			$ROBJ->{set} = $self->{daybook_setting};
			my $tag_escape = $ROBJ->loadpm('TextParser::TagEscape', $self->{diary_allow_tags});
			$tag_escape->{allow_anytag} = $self->{trust_mode};
			$text = $tag_escape->escape($text);
		}
	}

	# 
	$diary{text} = $text;
	if ($edit_pkey) {	# Խξ
		if (!defined $old->{update_tm}) {	# ٤ƤʤȤ
			$diary{tm} = $ROBJ->{TM};	# 񤭹񤭴
		}
		if ($diary{enable} || $old->{update_tm}) {	#  or ˣٸƤ
			$diary{update_tm} = $ROBJ->{TM};	# 񤭴
		}
		my $r = $DB->update_match($table_name, \%diary, 'pkey', $pkey);
		if (!$r) { $ROBJ->message('Diary edit failed'); return 11; }
	} else {		# 񤭹߽ξ
		if ($diary{enable}) {			# ΤȤΤ update_tm 
			$diary{update_tm} = $ROBJ->{TM};
		}
		my $r = $DB->update_match($table_name, \%diary, 'pkey', $pkey);
		if (!$r) {
			$DB->delete_match($table_name, 'pkey', $pkey);
			$ROBJ->message('Diary post failed');
			return 12;
		}
	}

	#--------------------------------------------------
	# Խν
	# ָפΤȤ
	# ȡTB Υå夷ȥν񤭴
	#--------------------------------------------------
	if ($edit_pkey) {
		my %update;
		if (!$diary{enable}  && $old->{enable})   { $update{enable}      = 0; }
		if ($diary{title}    ne $old->{title})    { $update{diary_title} = $diary{title}; }
		if ($diary{yyyymmdd} ne $old->{yyyymmdd}) { $update{diary_yyyymmdd}  = $diary{yyyymmdd}; }
		if ($diary{link_key} ne $old->{link_key}) {
			$update{diary_elink_key} = $elink_key;
			$DB->update_match($table_name, {upnode => $diary{link_key}},
				'upnode', $old->{link_key});
		}
		# Ȥν񤭴
		if (%update && $old->{comments_all}) {
			my $r = $DB->update_match("${diary_id}_comment", \%update, 'diary_pkey', $pkey);
			# ǶΥȺƹ
			if ($r) { $self->generate_recent_comment($diary_id); }
		}
		# ȥåХå񤭴
		if (%update && $old->{tbs_all}) {
			my $r = $DB->update_match("${diary_id}_tb", \%update, 'diary_pkey', $pkey);
			# ǶΥȺƹ
			if ($r) { $self->generate_recent_trackback($diary_id); }
		}
	}
	#--------------------------------------------------
	# ҥΡɥåν
	#--------------------------------------------------
	if ($edit_pkey && $diary{upnode} ne $old->{upnode} && $old->{upnode} ne '') {
		# ԽˤŤ upnode ѹ줿
		$self->update_diary_children_cache($diary_id, $old->{upnode});
	}
	if ($diary{upnode} ne '') {
		$self->update_diary_children_cache($diary_id, $diary{upnode});
	}

	#--------------------------------------------------
	# ȥåХå
	#--------------------------------------------------
	my @tb_sends;
	for(my $i=0; $i<10; $i++) {
		my $tb = $form->{"tb$i"};
		chomp($tb);
		if ($tb =~ /^\s*$/) { next; }
		#if ($tb =~ /^http:\/\//i) {
			my %h;
			$h{url}     = $tb;
			$h{charset} = $form->{"char$i"};
			push(@tb_sends, \%h);
		#} else {
		#	$self->tb_message("Support protocol http only (%s)", $tb);
		#}
	}
	if ((@tb_sends || ref($keytb_list)) && $diary{enable}) {
		# ʸɥꥹȤΥ
		my $lines = $ROBJ->fread_lines($self->{tb_codelist_file});
		my @code_info;
		foreach(@$lines) {
			if ($_ =~ /^\s*$/ || $_ =~ /^#/) { next; }
			my @ary = (split(/\s+/, $_))[0, 1];
			push(@code_info, \@ary);
		}
		# ʸɥꥹȤȤξȹ
		foreach my $tb (@tb_sends) {
			if ($tb->{charset} =~ /^auto$/i) {	# ưȽ̻
				undef $tb->{charset};
				my $url = $tb->{url};
				foreach(@code_info) {
					if ($url =~ /$_->[0]/) {
						$tb->{charset} = $_->[1]; last;
					}
				}
			}
		}
		# Trackbackǡν
		my $jcode = $ROBJ->loadpm('Jcode');
		$jcode->init();
		my %tb;
		$tb{url}       = $self->{server_url} . $self->{myself2} . $elink_key;
		$tb{title}     = $diary{title};
		$tb{blog_name} = $setting->{blog_name};	# blogȥ
		$tb{x_author}  = $auth->{name};		# 񤤤͡adiaryĥ
		$ROBJ->tag_delete($tb{x_author});	# 

		my $excerpt = $form->{excerpt};	# 
		if ($excerpt =~ /^\s*$/) {
			$excerpt = $diary{text};
			$excerpt =~ s/<!--%msg-->.*?<!--%msg-->|<!--%more-->//sg;	# Seemore
			$excerpt =~ s/\n//g;		# Խ
			$ROBJ->tag_delete($excerpt);	# 
			$excerpt = $self->string_clip($excerpt, $setting->{tb_send_int});	# ʸޤڤĤ
		}
		$tb{excerpt} = $excerpt;

		foreach(@tb_sends) {
			$tb{tb_url}  = $_->{url};
			$tb{charset} = $_->{charset};
			my $xml = $self->send_trackback(\%tb);
			if (!ref $xml) { next; }	# 顼
			if ($xml->{error} == 1) {
				my $err_msg = $xml->{message};
				$jcode->from_to(\$err_msg, '', $ROBJ->{System_coding});
				$self->tb_message('Error : %s (from %s)', $err_msg, $tb{tb_url});
				next;
			}
			$self->tb_message("TB sended with coding '%s' (%s)", $tb{charset}, $tb{tb_url});
		}
		# key tb / id tb
		if (ref($keytb_list)) {
			my %keytb;
			foreach(@$keytb_list) {
				if (index($_, "\e") < 0) { $keytb{"$diary_id\e$_"}=1; next; }
				$keytb{$_}=1;
			}
			# ʣʤ keyˡ, idˡꥹ
			#   Ū˽񤭹߽Ԥ
			foreach(keys(%keytb)) {
				my ($send_diary_id, $send_pkey) = split("\e", $_, 2);
				# ǧ
				my %h;
				if ($send_pkey =~ /^\d+$/) {
					$h{match_int} = {pkey => $send_pkey};
				} else {
					$h{match_str} = {link_key => $send_pkey};
				}
				$h{flag}      = {enable => 1};		# ɽǽΤ
				$h{limit}     = 1;
				$h{no_error}  = 1;
				my $rec_diary = ($DB->select("${send_diary_id}_diary", \%h))->[0];
				if (!defined $rec_diary || ! $rec_diary->{allow_tb}) { next; }

				# 
				my %send_tb;
				my $set = $self->load_daybook_setting( $send_diary_id );
				$send_tb{enable}     = 1;
				$send_tb{tm}         = $ROBJ->{TM};
				$send_tb{title}      = $tb{title};
				$send_tb{excerpt}    = $self->string_clip($tb{excerpt}, $set->{tb_recived_int});
				$send_tb{blog_name}  = $tb{blog_name};
				$send_tb{author}     = $tb{x_author};
				$send_tb{url}        = $tb{url};
				$send_tb{agent}      = "(internal)";
				$send_tb{internal}   = ($diary_id eq $send_diary_id) ? 1 : 0;
				if ($diary_id ne $send_diary_id && $set->{defer_tb}) {
					$send_tb{enable}=0;	# ȥåХåα
				}
				# ξ򥭥å夷ƥǼ
				$send_tb{diary_pkey}      = $rec_diary->{pkey};
				$send_tb{diary_title}     = $rec_diary->{title};
				$send_tb{diary_yyyymmdd}  = $rec_diary->{yyyymmdd};
				$send_tb{diary_elink_key} = $rec_diary->{link_key};
				$self->link_key_encode($send_tb{diary_elink_key});

				my $r  = $DB->insert("${send_diary_id}_tb", \%send_tb);
				if (!$r) { return next; }
				$self->calc_trackbacks($send_diary_id, $rec_diary->{pkey});	# ȥåХåϿ
				$self->generate_recent_trackback($send_diary_id);		# ǶΥȥåХå
				if ($diary_id ne $send_diary_id) {
					$ROBJ->fappend_hash("$self->{setting_dir}$send_diary_id$self->{file_ex}", {newcome_flag => 1});
				}
			}
		}
	}

	$self->generate_month_list   ($diary_id, 1);	# ̥ꥹȤ
	$self->generate_category_list($diary_id, 1);	# ʬꥹȤ
	$self->generate_recent_diary ($diary_id, 0);	# ǶεԽ
	$self->generate_rss          ($diary_id);

	# Ping
	my $ping_servers = $setting->{ping_servers_txt};
	if ($diary{enable} && $form->{update_ping} && $ping_servers) {
		my @servers = split("\n", $ping_servers);
		my %ping;
		$ping{blog_name}   = $setting->{blog_name};	# blogȥ
		$ping{url}         = $self->{server_url} . $self->{myself};
		$ping{rssurl}      = $ROBJ->{Server_url} . $self->{this_archive_dir} . $self->{rss_file};
		$ping{diary_title} = $diary{title};
		# see http://www.xmlrpc.com/weblogsCom
		my $jcode = $ROBJ->loadpm('Jcode');
		$jcode->init();
		my $system_coding = $ROBJ->{System_coding};
		if ($system_coding ne 'UTF-8') {
			$ping{blog_name}   = $jcode->from_to($ping{blog_name},   $system_coding, 'UTF-8');
			$ping{diary_title} = $jcode->from_to($ping{diary_title}, $system_coding, 'UTF-8');
		}
		foreach(@servers) {
			if ($_ eq '' || substr($_, 0, 1) eq '#') { next; }
			$ping{ping_server} = $_;
			my $xml = $self->send_weblogUpdates_Ping(\%ping);
			if (!ref $xml) { next; }
			if (! exists $xml->{flerror}) {
				$self->ping_message('Error : Illegal reply "%s". (Is it ping server?)', $_);
				next;
			}
			if ($xml->{flerror} || $xml->{faultCode}) {
				my $err_msg = $xml->{message} || $xml->{faultString};
				$jcode->from_to(\$err_msg, 'UTF-8', $ROBJ->{System_coding});
				$self->ping_message('Error : %s (from %s)', $err_msg, $_);
				next;
			}
			my $msg = $xml->{message};
			$jcode->from_to(\$msg, 'UTF-8', $ROBJ->{System_coding});
			$self->ping_message("Ping sended : %s (from %s)", $msg, $_);
		}
	}

	return 0;		# 
}

#------------------------------------------------------------------------------
# Ȥ
#------------------------------------------------------------------------------
sub comment_post {
	my ($self, $form) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	my $diary_id = $self->{diary_id};
	my $setting  = $self->{daybook_setting};
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{allow_com})      { $ROBJ->message('Operation not permitted');    return 5; }

	my $name   = $form->{name};
	my $email  = $form->{email};	# ɸॹǤϻѤʤ
	my $url    = $form->{url};	# Ʊ
	my $text   = $form->{comment_txt};
	my $hidden = $form->{hidden};
	$self->set_db_flags($hidden);
	if ($auth->{ok}) {
		$name = $auth->{name};
	}

	# Ȥν
	$text =~ s/^(.*?)(?:\r\n|\n)*$/$1/s;	# βԤ
	if ($text =~ /^\s*$/) { $ROBJ->message('Main text is empty'); }
	if ($name =~ /^\s*$/) { $ROBJ->message('Name is empty'); }
	my $text_short = $text;
	$text_short =~ s/\n/ /g;	# Ԣڡ
	$text_short = $self->string_clip($text_short, $setting->{disp_com_chars_int});
	$ROBJ->tag_escape($text, $text_short, $name, $email, $url);	# Υ(" ޤ)
	$text       =~ s/\n/<br>/g;	# Ԥ br ִ

	# URL/᡼륢ɥ쥹ΰǧ
	$email =~ s/^\s*(.*?)\s*$/$1/;
	$url   =~ s/^\s*(.*?)\s*$/$1/;
	if ($email !~ /^[-_\.a-zA-Z0-9]+\@[-_\.a-zA-Z0-9]+$/) { $email=undef; }
	if ($url =~ m#^(?:http|https|ftp)://[-_\.a-zA-Z0-9]+/?#) {
		$ROBJ->uri_encode( $url );
	} else {
		$url=undef;
	}

	# ǧ
	my $diary_pkey = $form->{pkey_int};
	my $logs  = $self->load_diary(1, undef, "0$diary_pkey");
	my $diary = $logs->[0];	# ǡ

	if ($self->{load_days} != 1 || !$self->{diary_pkey_selected}) { $ROBJ->message('Illegal diary number (%s)', "$diary_id/0$diary_pkey"); }
	else {
		if (! $diary->{allow_com} || $setting->{allow_com_force} eq '0') {	# Բ
			$ROBJ->message('This diary comment not received');
		}
		if ($hidden && (! $diary->{allow_hcom} || $setting->{allow_hcom_force} eq '0')) {	# Ե
			$ROBJ->message('This diary hidden comment not allow');
		}
	}
	# secure id γǧ
	if (! $auth->{ok}) {
		if ($self->{phone_mode}) {
			my $secu_num = $form->{secure_num};
			my $yyyymmdd = $diary->{yyyymmdd};
			my $num = substr($yyyymmdd, 4, 2) + substr($yyyymmdd, 6, 2);
			if ($secu_num != $num) {
				$ROBJ->message('Security error. Please repost comment');
			}
		} else {
			my $secure_id = $form->{secure_id};
			my $secu_id_now = $ROBJ->make_secure_id($diary_id . $diary_pkey);
			my $secu_id_old = $ROBJ->make_secure_id($diary_id . $diary_pkey, 1);
			if ($secure_id ne $secu_id_now && $secure_id ne $secu_id_old) {
				$ROBJ->message('Security error. Please repost comment');
			}
		}
	}

	# 顼
	if ($ROBJ->{Message_flag}) { return 2; }	# 顼ä

	# Ȥν񤭹߽
	my %com;
	$com{enable}     = 1;
	$com{tm}         = $ROBJ->{TM};
	$com{diary_pkey} = $diary_pkey;
	$com{name}       = $name;
	$com{email}      = $email;
	$com{url}        = $url;
	$com{text}       = $text;
	$com{text_short} = $text_short;
	$com{hidden}     = $hidden;
	# ξ򥭥å夷ƥǼ
	$com{diary_title}    = $diary->{title};
	$com{diary_yyyymmdd} = $diary->{yyyymmdd};
	$com{diary_elink_key}= $diary->{link_key};
	$self->link_key_encode( $com{diary_elink_key} );
	$self->{elink_key} = $com{diary_elink_key};	# for skelton

	my $defer;
	if (!$self->{allow_edit} && $setting->{defer_com}) {	# αǽ
		$defer = $setting->{defer_com};
		if ($defer==2 && $auth->{ok}) { $defer=0; }	# 桼Τߵ
	}
	if ($defer || $hidden) { $com{enable}=0; }	# αǽ

	$com{id}     = $auth->{id};
	$com{ip}     = $ENV{REMOTE_ADDR};
	$com{host}   = $ENV{REMOTE_HOST};
	$com{agent}  = $ENV{HTTP_USER_AGENT};

	my $com_pkey  = $DB->insert("${diary_id}_comment", \%com);
	if (!$com_pkey) { $ROBJ->message('Comment post failed'); return 10; }
	$form->{defer_ok} = $defer;

	$self->calc_comments($diary_id, $diary_pkey);	# ȿϿ
	$self->generate_recent_comment($diary_id);	# ǶΥ
	$self->generate_rss           ($diary_id);
	# 嵭Ͽ
	if (! $self->{allow_edit}) {
		$ROBJ->fappend_hash("$self->{setting_dir}$diary_id$self->{file_ex}", {newcome_flag => 1});
		# Τ餻᡼
		if ($setting->{notify_mail_comment}) {
			$ROBJ->call("mail/notify_comment", "$self->{server_url}$self->{myself2}$diary->{elink_key}#c$com_pkey");
		}
	}
	return 0;		# 
}


#------------------------------------------------------------------------------
# ȥåХå
#------------------------------------------------------------------------------
# ȥåХå Version 1.1 
# ܸʸɳĥbody "charset" б
sub receive_trackback {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my ($r, @ary) = $self->do_receive_trackback(@_);
	$ROBJ->print_header('X-TB-Accept-Charset', 'EUC-JP, UTF-8, Shift_JIS, iso-2022-jp, iso-8859-1');
	$ROBJ->print_content_type('text/xml');
	if ($r eq '0') {
		print <<RESPONSE;
<?xml version="1.0" encoding="$ROBJ->{System_coding}"?>
<response>
<error>0</error>
</response>
RESPONSE
	} else {
		$r = $ROBJ->message_translate($r, @ary);
		print <<RESPONSE;
<?xml version="1.0" encoding="$ROBJ->{System_coding}"?>
<response>
<error>1</error>
<message>$r</message>
</response>
RESPONSE
	}
	$self->generate_rss( $self->{diary_id} );
	# 嵭Ͽ
	if ($r eq '0' && !$self->{allow_edit}) {
		$ROBJ->fappend_hash("$self->{setting_dir}$self->{diary_id}$self->{file_ex}", {newcome_flag => 1});
		# Τ餻᡼
		if ($self->{daybook_setting}->{notify_mail_tb}) {
			$ROBJ->call("mail/notify_tb", $self->{tb_url});
		}
	}
	$ROBJ->exit(0);
}

sub do_receive_trackback {
	my ($self, $form, $secure_id) = @_;
	my $ROBJ      = $self->{ROBJ};
	my $DB        = $ROBJ->{DB};
	my $diary_id  = $self->{diary_id};
	my $setting   = $self->{daybook_setting};
	if(! $ROBJ->{POST}) { return 'Trackback supported POST method only'; }
	if(! $self->{exsits_daybook}) { return 'The daybook does not exist'; }

	# ǧ
	my $diary_pkey = int($self->{display_op});
	my $logs = $self->load_diary(1);
	if ($self->{load_days} != 1 || !$self->{diary_pkey_selected}) { return ("Illegal diary number (%s)", "$diary_id/0$diary_pkey $self->{display_op}"); }

	my $diary = $logs->[0];
	if (! $diary->{allow_tb}) { return "This diary trackback not received (%s)", "$diary_id/0$diary_pkey"; }

	# եɤ߹
	my $title     = $form->{title};		# ȥ
	my $excerpt   = $form->{excerpt};	# 
	my $url       = $form->{url};
	my $blog_name = $form->{blog_name};	# blogȥ
	my $charset   = $form->{charset};	# ܳĥ
	my $author    = $form->{x_author};	# adiaryĥ
	if ($title eq '') { $title = $blog_name; }

	if ($title =~ /^\s*$/) { $title = '(no title)'; }
	if ($url   =~ /^\s*$/) { return 'Not exist from URL'; }

	# secure id γǧ
	my $secu_id_now = $ROBJ->make_secure_id($diary_id . $diary_pkey);
	my $secu_id_old = $ROBJ->make_secure_id($diary_id . $diary_pkey, 1);
	if ($secure_id ne $secu_id_now && $secure_id ne $secu_id_old) {
		return 'Trackback URL expired. Please check new Trackback URL';
	}

	# ʸɤѹ
	if ($charset eq '') { undef $charset; }
	my $system_coding = $ROBJ->{System_coding};
	my $jcode = $ROBJ->loadpm('Jcode');
	$jcode->init();
	$jcode->from_to(\$title,     $charset, $system_coding);
	$jcode->from_to(\$excerpt,   $charset, $system_coding);
	$jcode->from_to(\$blog_name, $charset, $system_coding);
	$jcode->from_to(\$author,    $charset, $system_coding);

	# Υ
	$ROBJ->tag_escape($title, $excerpt, $blog_name, $author);
	$url =~ s|[^\w\./:\?\=\&\%\*\#\-~]||g;		# ʸκ

	# ʸʾڤΤ
	$excerpt = $self->string_clip($excerpt, $setting->{tb_recived_int});

	# ȥåХåν񤭹߽
	my %tb;
	$tb{enable}     = 1;
	$tb{internal}   = 0;
	$tb{tm}         = $ROBJ->{TM};
	$tb{diary_pkey} = $diary_pkey;
	$tb{title}      = $title;
	$tb{excerpt}    = $excerpt;
	$tb{blog_name}  = $blog_name;
	$tb{author}     = $author;
	$tb{url}        = $url;
	$tb{ip}         = $ENV{REMOTE_ADDR};
	$tb{host}       = $ENV{REMOTE_HOST};
	$tb{agent}      = $ENV{HTTP_USER_AGENT};		# Extension by this system
	if ($setting->{defer_tb}) { $tb{enable}=0; }		# ȥåХåα
	# ξ򥭥å夷ƥǼ
	$tb{diary_title}    = $diary->{title};
	$tb{diary_yyyymmdd} = $diary->{yyyymmdd};
	$tb{diary_elink_key}= $diary->{link_key};
	$self->link_key_encode( $tb{diary_elink_key} );

	my $r  = $DB->insert("${diary_id}_tb", \%tb);
	if (!$r) { return 'Internal Error'; }
	$self->{tb_url} = "$self->{server_url}$self->{myself2}$diary->{elink_key}#tb$r";	# ѿ
	
	$self->calc_trackbacks($diary_id, $diary_pkey);		# ȥåХåϿ
	$self->generate_recent_trackback($diary_id);		# ǶΥȥåХå
	return 0;		# 
}

#------------------------------------------------------------------------------
# ȥåХå
#------------------------------------------------------------------------------
# ȥåХå Version 1.1  (charsetб)
#	$data->{tb_url}
#	$data->{url}
#	$data->{title}
#	$data->{excerpt}
#	$data->{blog_name}
#	$data->{charset}	UTF-8, EUC-JP, Shift_JIS, JIS, HEAD, GET
#
sub send_trackback {
	my ($self, $data) = @_;
	my $self = shift;
	my $ROBJ = $self->{ROBJ};

	# 饤֥
	my $jcode = $ROBJ->loadpm('Jcode');		# ܸѴWrapper
	my $HTTP  = $ROBJ->loadpm('Base::HTTP');	# HTTPѥå
	$HTTP->set_timeout( $self->{tb_timeout} );	# ॢȤ

	# URLɤ߹
	my $url = $data->{tb_url};
	if ($url !~ /^http:\/\/([^\/:]*)(:(\d+))?(.*)/) {
		$self->tb_message("URL format error (%s)", $url);
		return 1;
	}
	my $host = $1;
	my $port = $3 || 80;
	my $path = $4 || '/';
	$ROBJ->uri_encode($path);

	# ʸɤγǧ
	my $charset = $data->{charset};
	#------------------------------------------------------------
	# HEAD ʸȽ
	#------------------------------------------------------------
	if ($charset =~ /^head$/i) {
		my $request = <<HEAD;
HEAD $path HTTP/1.0
Host: $host
User-Agent: $self->{agent}

HEAD
		my $res = $HTTP->get_data($host, $port, $request);
		if (!defined $res) { $self->tb_message( $HTTP->{error_msg} ); return 10; }
		undef $charset;
		foreach(@$res) {
			chomp();
			if ($_ =~ /^content-type:.*charset=([-\w]+)/i) {
				$charset = $1;
			}
		}
		if ($charset eq '') { $self->tb_message("Charset recognize failed by %s (%s)", 'HEAD', $data->{tb_url}); }
	}
	#------------------------------------------------------------
	# GET ʸȽ
	#------------------------------------------------------------
	if ($charset =~ /^get$/i) {
		my $request = <<GET;
GET $path HTTP/1.0
Host: $host
User-Agent: $self->{http_agent}

GET
		my $res = $HTTP->get_data($host, $port, $request);
		if (!defined $res) { $self->tb_message( $HTTP->{error_msg} ); return 20; }

		$res     = join ('', @$res);
		$charset = $jcode->get_codename($res);
		if ($charset eq '') { $self->tb_message("Charset recognize failed by %s (%s)", 'GET', $data->{tb_url}); }
	}
	#------------------------------------------------------------
	# POST body 
	#------------------------------------------------------------
	my $system_coding = $ROBJ->{System_coding};
	if ($charset eq '') { $charset = $system_coding; }
	$data->{charset} = $charset;

	my @keys = qw(title excerpt blog_name x_author url charset);
	my @keys = keys(%$data);
	my $post_body;
	foreach(@keys) {
		if (!exists $data->{$_}) { next; }
		my $val = $data->{$_};
		if ($charset ne $system_coding) { $val = $jcode->from_to(\$val, $system_coding, $charset); }
		$ROBJ->form_encode($val);
		$post_body .= "$_=$val&";
	}
	chop($post_body);
	my $length = length($post_body);
	my $post_data = <<POST;
POST $path HTTP/1.0
Content-Type: application/x-www-form-urlencoded
Host: $host
User-Agent: $self->{http_agent}
Content-Length: $length

$post_body
POST


	#------------------------------------------------------------
	# POST ȯ
	#------------------------------------------------------------
	my $res = $HTTP->get_data($host, $port, $post_data);
	if (!defined $res) { $self->tb_message( $HTTP->{error_msg} ); return 100; }

	#------------------------------------------------------------
	# 쥹ݥ󥹤βϡȴǤ
	#------------------------------------------------------------
	my %xml;
	foreach(@$res) {
		if($_ =~ /<(\w+?)>(.+?)<\/\1>/) {
			$xml{$1} = $2;
		}
	}
	$xml{send_charset} = $charset;
	return \%xml;		# 
}

#------------------------------------------------------------------------------
# ȥåХåå
#------------------------------------------------------------------------------
sub tb_message {
	my $self = shift;
	my $msg  = shift;
	my $ROBJ = $self->{ROBJ};
	if (ref $self->{tb_message} ne 'ARRAY') { $self->{tb_message}=[]; }
	$msg = $ROBJ->message_translate($msg, @_);
	$ROBJ->tag_escape($msg);
	push(@{ $self->{tb_message}}, $msg);
}

#------------------------------------------------------------------------------
# Pingʳĥͽ
#------------------------------------------------------------------------------
# Extended Ping XML-RPC Request
#	$data->{ping_server}	PingURL
#	$data->{blog_name}	blogΥȥ
#	$data->{url}		blogURL
#	$data->{rssurl}		RSSURL
# ͤˤ(Thanks)
#	http://isnot.jp/?p=XML-RPC%A1%F8%B9%B9%BF%B7Ping%A4%CE%C1%F7%BF%AE
#
# Υ롼 send_trackback() ѿʤɤͭƤޤ
#
sub send_weblogUpdates_Ping {
	my ($self, $data) = @_;
	my $self = shift;
	my $ROBJ = $self->{ROBJ};

	# 饤֥
	my $HTTP = $ROBJ->loadpm('Base::HTTP');	# HTTPѥå
	$HTTP->set_timeout( $self->{ping_timeout} );	# ॢȤ

	# option load
	my $post_url = $data->{ping_server};
	my ($option, $timeout);
	($post_url, $option) = split('#', $post_url);
	($option, $timeout)  = split(',', $option);
	if (0 < $timeout && $timeout < 61) { $HTTP->set_timeout( $timeout ); }

	#------------------------------------------------------------
	# POST body
	#------------------------------------------------------------
	my $url       = $data->{url};
	my $blog_name = $data->{blog_name};
	my $rssurl    = $data->{rssurl};
	my $method    = "weblogUpdates.ping";
	my $check_url = $url;
	if ($option eq 'ex')     { $method="weblogUpdates.extendedPing"; }
	if ($option eq 'adiary') {	# adiary extended
		$method    = "weblogUpdates.adiary-extendedPing";
		$check_url = $data->{diary_title};
	}
	# XML
	$ROBJ->tag_escape_for_xml($blog_name, $url, $check_url, $rssurl);
	my $post_body = <<POST_BODY;
<?xml version="1.0"?>
<methodCall>
	<methodName>$method</methodName>
	<params>
		<param><value>$blog_name</value></param>
		<param><value>$url</value></param>
		<param><value>$check_url</value></param>
		<param><value>$rssurl</value></param>
	</params>
</methodCall>
POST_BODY

	my $length = length($post_body);
	my $post_data = <<POST;
User-Agent: $self->{http_agent}
Content-Type: text/xml
Content-Length: $length

$post_body
POST

	#------------------------------------------------------------
	# POST ȯ
	#------------------------------------------------------------
	my $res = $HTTP->post($post_url, $post_data);
	if (!defined $res) { $self->ping_message( $HTTP->{error_msg} ); return 100; }

	#------------------------------------------------------------
	# 쥹ݥ󥹤βϡȴǤ
	#------------------------------------------------------------
	my $data = join('', @$res);
	$data =~ s/[\r\n]//g;
	$data =~ s[\s*(?:<boolean>(.*?)</boolean>|<int>(.*?)</int>|<string>(.*?)</string>)\s*][$1$2$3]g;
	my %xml;
	while($data =~ m|<member>(.*?)</member>|sg) {
		my $member = $1;
		my ($name, $value);
		if ($member =~ /<name>(.*?)<\/name>/)   { $name =$1; } 
		if ($member =~ /<value>(.*?)<\/value>/) { $value=$1; } 
		$xml{$name} = $value;
	}
	return \%xml;		# 
}
#------------------------------------------------------------------------------
# Pingå
#------------------------------------------------------------------------------
sub ping_message {
	my $self = shift;
	my $msg  = shift;
	my $ROBJ = $self->{ROBJ};
	if (ref $self->{ping_message} ne 'ARRAY') { $self->{ping_message}=[]; }
	$msg = $ROBJ->message_translate($msg, @_);
	$ROBJ->tag_escape($msg);
	push(@{ $self->{ping_message}}, $msg);
}

###############################################################################
# ȥȡȥåХåꥹν
###############################################################################
#------------------------------------------------------------------------------
# Ƕ
#------------------------------------------------------------------------------
sub generate_recent_diary {
	my ($self, $diary_id, $no_save, $update)  = @_;
	my $h = $self->generate_recent('diary', "${diary_id}_diary", $diary_id, $no_save);

	$update ||={};
	$update->{diaries}      = $h->{hits};
	$update->{diary_tm}     = $h->{newest_tm} || 0;
	$update->{newest_title} = $h->{newest_title} || "";
	if ($no_save>1) { return; }
	return $self->update_daybookinfo( $diary_id, $update );
}

#------------------------------------------------------------------------------
# ǶΥȤ
#------------------------------------------------------------------------------
sub generate_recent_comment {
	my ($self, $diary_id, $no_save, $update)  = @_;
	my $h = $self->generate_recent('comment', "${diary_id}_comment", $diary_id, $no_save);

	$update ||={};
	$update->{comments}   = $h->{hits};
	$update->{comment_tm} = $h->{newest_tm} || 0;
	if ($no_save>1) { return; }
	return $self->update_daybookinfo( $diary_id, $update );
}

#------------------------------------------------------------------------------
# ǶΥȥåХå
#------------------------------------------------------------------------------
sub generate_recent_trackback {
	my ($self, $diary_id, $no_save, $update)  = @_;
	my $h = $self->generate_recent('trackback', "${diary_id}_tb", $diary_id, $no_save);

	$update ||={};
	$update->{tbs}   = $h->{hits};
	$update->{tb_tm} = $h->{newest_tm} || 0;
	if ($no_save>1) { return; }
	return $self->update_daybookinfo( $diary_id, $update );
}

#------------------------------------------------------------------------------
# ǶΥꥹȤʥ֥롼
#------------------------------------------------------------------------------
sub generate_recent {
	my ($self, $type, $table_name, $diary_id, $no_save) = @_;
	my $ROBJ   = $self->{ROBJ};
	my $set    = $self->load_daybook_setting( $diary_id );
	my $target = "recent_$type";

	# Υ
	my %h;
	my $displays = int($set->{"${target}_int"});
	$h{limit} = $displays || 1;		# ɽ
	if ($type eq 'diary') {			# Ƕε
		$h{sort}          = 'yyyymmdd';
		$h{sort_reverse}  = 1;		# եȡʿ
	}
	if ($type eq 'trackback') {
		$h{flag}->{internal} = 0;
	}
	$h{type} = $type;
	my $logs;
	{
		local ($self->{allow_edit}, $self->{daybook_admin});
		$self->{allow_edit} = $self->{daybook_admin} = 0;
		$logs = $self->load_list( \%h, $diary_id );
	}

	# ȥμ¹
	my @backup = ($self->{myself}, $self->{myself2});
	$self->set_myself( $diary_id );
	my $skelton = 'format/' . $target;
	my $data    = $ROBJ->call($skelton, $logs);
	my $string  = $ROBJ->chain_array($data);
	if ($displays == 0 || $h{hits}==0) { $string=''; }	# ɽ 0 ʤɽʤ
	($self->{myself}, $self->{myself2}) = @backup;

	# save
	$set->{$target} = $string;			# 
	if (!$no_save) {
		$self->save_daybook_setting( $diary_id );
	}
	return \%h;
}

#------------------------------------------------------------------------------
# ̥ꥹȤ
#------------------------------------------------------------------------------
sub generate_month_list {
	my ($self, $diary_id, $no_save) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $set  = $self->load_daybook_setting( $diary_id );
	# ˴ؤ¾ξƤӽФ
	$self->generate_contents_list($diary_id, 1);
	$self->generate_keylist      ($diary_id, 1);

	# ̥ꥹȤ롩
	my $month_list;
	if ($set->{disp_side_month_list}) {
		my %h;
		$h{select_cols} = ['yyyymmdd'];
		$h{flag}        = {enable => '1'};
		my $data = $DB->select("${diary_id}_diary", \%h);
		my %yyyymm;
		foreach(@$data) {
			$yyyymm{ substr($_->{yyyymmdd},0,6) }++;
		}
		my @yyyymm = sort {$b <=> $a} keys(%yyyymm);
		@yyyymm = map {
			{yyyymm => $_,
			 year => substr($_,0,4),
			 mon  => substr($_,4,2),
			 count => $yyyymm{$_} }
		} @yyyymm;

		# ȥμ¹
		my @backup = ($self->{myself}, $self->{myself2});
		$self->set_myself( $diary_id );
		my $skelton = 'format/month_list';
		my $data    = $ROBJ->call($skelton, \@yyyymm);
		$month_list = $ROBJ->chain_array($data);
		($self->{myself}, $self->{myself2}) = @backup;
	}

	$set->{month_list} = $month_list;
	if ($no_save) { return 0; }
	return $self->save_daybook_setting( $diary_id );
}


#------------------------------------------------------------------------------
# ƥꥹȤ
#------------------------------------------------------------------------------
sub generate_category_list {
	my ($self, $diary_id, $no_save, $level, $orss) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $set  = $self->load_daybook_setting( $diary_id );

	# ߤɽͥ٤
	if (ref($level) ne 'HASH') { $level = {}; }
	if (ref($orss)  ne 'HASH') { $orss  = {}; }
	my @list = split("\n", $set->{category_name_list});
	# format : ƥ̾ [TAB] =ɽ٥=flag [\n]
	foreach(@list) {
		my ($name, $option) = split("\t", $_, 2);
		if ($option eq '') { next; }
		my ($count, $c_level, $ohter_rss) = split("=", $option);
		if (!exists $level->{$name}) { $level->{$name} = $c_level;   }
		if (!exists $orss ->{$name}) { $orss ->{$name} = $ohter_rss; }
	}

	# ƥǽ
	my %h;
	my $sort = $set->{disp_category_sort};
	$h{group_col}    = 'category';
	$h{sort}         = $sort;
	$h{sort_reverse} = $set->{disp_category_sort_reverse};
	my $category_data = $DB->select_by_group("${diary_id}_diary", \%h);
	   $category_data = &level_sort($category_data, 'category', $level);	# ɽ٥Ǻƥ
	# ΤߤΥƥν
	$h{match_col} = 'enable';
	$h{match_val} = 1;
	my $category_enable_data = $DB->select_by_group("${diary_id}_diary", \%h);

	# ƥ깽¤
	my %sub;
	my $search_base;
	my %enable_count;
	foreach(@$category_enable_data) {
		$enable_count{ $_->{category} } = $_->{_count};
	}
	{
		my @backup = ($self->{myself}, $self->{myself2});
		$self->set_myself($diary_id);
		$search_base = "$self->{myself2}&amp;category?cat=";
		($self->{myself}, $self->{myself2}) = @backup;
	}
	my $diaries_all   = 0;
	my $e_diaries_all = 0;
	my %category_main_hash;
	my @category_main_list;
	foreach(@$category_data) {
		if (!defined $_) { next; }
		my $category = $_->{category};
		my $count  = $_->{_count};
		my $ecount = $enable_count{$category};

		# ƥƥ
		my $x = index($category, '::');
		my $category_main = $category;
		if ($x >= 0) { $category_main=substr($category, 0, $x); }
		my $h = $category_main_hash{$category_main};
		if (! $h) {
			$h = {};
			$category_main_hash{$category_main} = $h;
			push(@category_main_list, $h);
		}
		$h->{category_main} = $category_main;
		$h->{_count} += $count;		# ٤ƤΥ
		$h->{ecount} += $ecount;	# Υ

		# 
		$diaries_all   += $count;
		$e_diaries_all += $ecount;
		if ($x<=0) { next; }

		# sub category
		$_->{category_main}     = $category_main;
		$_->{category_sub}      = substr($category, $x+2);
		$_->{category_uri}      = $category;
		$_->{category_main_uri} = $category_main;
		$ROBJ->form_encode( $_->{category_uri}, $_->{category_main_uri} );
		$_->{category_uri}      = $search_base . $_->{category_uri};
		$_->{category_main_uri} = $search_base . $_->{category_main_uri};
		$_->{count}             = $count;
		$_->{ecount}            = $ecount;
		my $ary = $sub{$category_main} ||= [];
		push(@$ary, $_);
	}

	# ƥƥǽ
	my $category_main_data = &level_sort(\@category_main_list, 'category_main', $level);
	my @category_name;
	my $other_rss = 0;
	my @new_maindata;
	foreach(@$category_main_data) {
		my $category = $_->{category} = $_->{category_main};
		my $count    = $_->{_count};
		my $ecount   = $_->{ecount};	# count of enable
		push(@category_name, "$category\t$ecount=$level->{$category}=$orss->{$category}=$count");
		$other_rss |= $orss->{$category};
		if (exists $sub{ $category }) {
			my $subs = $sub{ $category };
			my @new_subs;
			foreach(@$subs) {
				my $c = $_->{category};
				push(@category_name, "$c\t$_->{ecount}=$level->{$c}=$orss->{$c}=$_->{count}");
				$other_rss |= $orss->{$c};
				if ($_->{ecount}>0) { push(@new_subs, $_); }
			}
			if (@new_subs) { $_->{have_sub_category} = \@new_subs; }
		}
		# 
		$ROBJ->form_encode($category);
		$_->{category_uri}      = $search_base . $category;
		$_->{category_main_uri} = $search_base . $category;
		# ȥѤͥԡ
		$_->{count}   = $_->{_count};
		if ($ecount>0) { push(@new_maindata, $_); }
	}

	# ȥμ¹
	$self->{set} = $set;	# ϡȥ񤭴뤳
	my $skelton = 'format/category_list';
	my $data    = $ROBJ->call($skelton, \@new_maindata);
	my $string  = $ROBJ->chain_array($data);

	# ǡ¸
	if ($#$category_data < 1) { $string=""; }	# ʬबĤΤȤꥹɽʤ
	$set->{diaries}            = $diaries_all;
	$set->{enable_diaries}     = $e_diaries_all;
	$set->{category_list}      = $string;
	$set->{category_name_list} = join("\n", @category_name);
	$set->{other_rss}          = $other_rss;
	if ($no_save) { return 0; }
	return $self->save_daybook_setting( $diary_id );
}

# ɽͥ٤˱ƥ
sub level_sort {
	my ($list, $key, $level) = @_;
	return [ sort {$level->{$b->{$key}} <=> $level->{$a->{$key}}} @$list ];
}

#------------------------------------------------------------------------------
# ȿ׻Ͽ
#------------------------------------------------------------------------------
sub calc_comments {
	my ($self, $diary_id, $diary_pkey) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};

	my %h;
	$h{match_int}   = {diary_pkey => $diary_pkey};
	$h{select_cols} = ['enable'];
	my $com = $DB->select("${diary_id}_comment", \%h);

	my $newest_t;
	my %update;
	my $c = 0;
	foreach(@$com) {
		if ($_->{enable}) { $c++; }
	}
	$update{comments}     = $c;
	$update{comments_all} = $#$com + 1;
	$update{update_tm}    = $ROBJ->{TM};
	return $DB->update_match("${diary_id}_diary", \%update, 'pkey', $diary_pkey);
}

#------------------------------------------------------------------------------
# ȥåХå׻Ͽ
#------------------------------------------------------------------------------
sub calc_trackbacks {
	my ($self, $diary_id, $diary_pkey) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};

	my %h;
	$h{match_int}   = {diary_pkey => $diary_pkey};
	$h{select_cols} = ['enable'];
	my $tb = $DB->select("${diary_id}_tb", \%h);

	my %update;
	my $c = 0;
	foreach(@$tb) {
		if ($_->{enable}) { $c++; }
	}
	$update{tbs}       = $c;
	$update{tbs_all}   = $#$tb + 1;
	$update{update_tm} = $ROBJ->{TM};
	return $DB->update_match("${diary_id}_diary", \%update, 'pkey', $diary_pkey);
}
#------------------------------------------------------------------------------
# pkeyꥹȤ
#------------------------------------------------------------------------------
sub generate_keylist {
	my ($self, $diary_id, $no_save) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $set  = $self->load_daybook_setting( $diary_id );

	# Key-list
	my %h;
	if ($set->{contents_separate}) {	# ƥĤ
		$h{match_int} = {priority => 0};
	}
	$h{sort}          = 'yyyymmdd';
	$h{sort_reverse}  = 1;
	$h{sort2}         = 'tm';
	$h{sort2_reverse} = $set->{disp_tmsort};	# ⥽
	$h{select_cols}  = ['pkey', 'link_key', 'yyyymmdd', 'enable'];
	my $key = 'pkey';
	my $log = $DB->select("${diary_id}_diary", \%h);

	$set->{keylist}     = '';
	$set->{keylist_all} = '';
	if ($#$log > 0) {	# 
		my $enablelist  = [ grep { $_->{enable} } @$log ];
		my $keylist     = [ map { $_->{link_key} } @$enablelist ];
		my $keylist_all = [ map { $_->{link_key} } @$log ];
		$set->{keylist}     = "," . join(',', @$keylist    ) . ",";
		$set->{keylist_all} = "," . join(',', @$keylist_all) . ",";
	}

	if ($no_save) { return 0; }
	return $self->save_daybook_setting( $diary_id );
}

#------------------------------------------------------------------------------
# ƥĥꥹȤ
#------------------------------------------------------------------------------
sub generate_contents_list {
	my ($self, $diary_id, $no_save) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $set  = $self->load_daybook_setting( $diary_id );

	# ƥĥꥹȤ
	my %h;
	$h{min}  = {priority => 1};
	$h{sort} = 'priority';
	$h{sort_reverse} = $set->{contents_sort_reverse};
	$h{sort2}         = 'tm';
	$h{sort2_reverse} = $set->{contents_sort_older} ? 0 : 1;
	$h{select_cols} = ['pkey', 'tm', 'yyyymmdd', 'title', 'name', 'category', 'category_main',
		'enable', 'priority', 'upnode', 'link_key', 'update_tm'];
	my $contents = $DB->select("${diary_id}_diary", \%h);

	# ޤƥĥꥹȤ
	my @contents_keylist;
	{
		my %child;
		map {
			# $_->{title} =~ s/^\[(.+?)\]\s*.*/$1/;	# ƥĸshort-titleʥܥġ
			push(@{ $child{ $_->{upnode} } }, $_)
		} @$contents;
		my $rec_func;
		$rec_func = sub {	# Ƶؿ
			my $sp  = shift;
			my $key = shift;
			my $ary = $child{$key};
			delete $child{$key};
			foreach(@$ary) {
				$key   = $_->{link_key};
				push(@contents_keylist, "$sp$key\t$_->{title}");
				if (exists $child{$key}) { &$rec_func("$sp\t", $key);  }
			}
		};
		&$rec_func('', '');
		# ɤˤ°ʤƥĥꥹ
		foreach(keys(%child)) {
			push(@contents_keylist, '**other');
			&$rec_func(' ', $_);
		}
	}

	# ɽ륳ƥĳؤ
	my %child;
	$contents = [ grep {$_->{enable}} @$contents ];
	my %key = map {
		if (ord($_->{link_key}) == 0x20) {	# 󥯡
			$_->{link_key} = substr($_->{link_key}, 1);
			$_->{link} = 1;
		}
		$_->{elink_key} = $_->{link_key};
		$self->link_key_encode( $_->{elink_key} );
		if ($_->{link}) {	# 󥯤ξ硢?,#,% ᤹
			$_->{elink_key} =~ s/%3[Ff]/?/;
			$_->{elink_key} =~ s/%23/#/;
			$_->{elink_key} =~ s/%25/%/g;
		}
		push(@{ $child{ $_->{upnode} } }, $_);
		$_->{link_key} => 1	# map to hash
	} @$contents;
	my $root = $child{''};
	my $nest = ($set->{wiki_items_int} eq '') ? 3 : $set->{wiki_items_int};
	# FrontPage뤫
	$set->{frontpage} = '';
	foreach(qw(FrontPage frontpage top index)) {
		if ($key{$_}) { $set->{frontpage}=$_; last; }
	}

	# Ƴؤλ
	if ($nest < 1) { $root = []; }
	foreach(@$root) {
		my $key = $_->{link_key};
		if ($nest < 2 || !exists $child{$key}) { next; }
		# ҤϿ
		my $node = $_->{child} = $child{$key};
		# ¹ǧϿ
		foreach(@$node) {
			$key = $_->{link_key};
			if ($nest < 3 || !exists $child{$key}) { next; }
			$node = $_->{child} = $child{$key};
		}
	}
	# ˥塼
	my $contents_list;
	my $contents_bar;
	if ($#$root >= 0) {	# ˥塼ѥǡ
		my @backup = ($self->{myself}, $self->{myself2});
		$self->set_myself( $diary_id );
		if ($set->{contents_bar}) {
			my $data      = $ROBJ->call('format/contents_bar', $root);
			$contents_bar = $ROBJ->chain_array($data);
		} else {
			my $skelton = 'format/contents_list';
			if ($set->{contents_module}) { $skelton .= '_module'; }
			# ȥμ¹
			my $data    = $ROBJ->call($skelton, $root);
			$contents_list = $ROBJ->chain_array($data);
		}
		($self->{myself}, $self->{myself2}) = @backup;
	}

	$set->{contents_menu_bar} = $contents_bar;
	$set->{contents_list}     = $contents_list;
	$set->{contents_keylist}  = join(',',@contents_keylist);
	if ($no_save) { return 0; }
	return $self->save_daybook_setting( $diary_id );
}

#------------------------------------------------------------------------------
# ꤵ줿 link_key Ƥ˻ĻҥΡɥå¸ʹ
#------------------------------------------------------------------------------
sub update_diary_children_cache {
	my ($self, $diary_id, $link_key)  = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $set  = $self->load_daybook_setting( $diary_id );
	if ($link_key eq '') { return ; }

	# ҥΡɤμ
	my %h;
	$h{min}       = {priority => 1};
	$h{match_str} = {upnode => $link_key};
	$h{flag}      = {enable => 1};
	$h{sort}          = 'priority';
	$h{sort_reverse}  = $set->{contents_sort_reverse};
	$h{sort2}         = 'tm';
	$h{sort2_reverse} = $set->{contents_sort_older} ? 0 : 1;
	$h{select_cols} = ['pkey', 'tm', 'yyyymmdd', 'title', 'name', 'category', 'category_main',
		'enable', 'priority', 'upnode', 'link_key', 'update_tm'];
	my $contents = $DB->select("${diary_id}_diary", \%h);

	my $children;
	if ($#$contents >= 0) {	# 
		map {
			if (ord($_->{link_key}) == 0x20) {	# 󥯡
				$_->{link_key} = substr($_->{link_key}, 1);
				$_->{link} = 1;
			}
			$_->{elink_key} = $_->{link_key};
			$self->link_key_encode( $_->{elink_key} );
			my $yyyymmdd = $_->{yyyymmdd};
			$_->{year} = substr($yyyymmdd, 0, 4);
			$_->{mon}  = substr($yyyymmdd, 4, 2);
			$_->{day}  = substr($yyyymmdd, 6, 2);
		} @$contents;
		my @backup = ($self->{myself}, $self->{myself2});
		$self->set_myself( $diary_id );
		# ȥμ¹
		my $data = $ROBJ->call('format/diary_children', $contents);
		$children = $ROBJ->chain_array($data);
		($self->{myself}, $self->{myself2}) = @backup;
	}

	# Ģ¸
	my $r = $DB->update_match("${diary_id}_diary", {"children_cache" => $children}, "link_key", $link_key);
	if ($r != 1) { return -1; }
	return 0;
}

###############################################################################
# RSS
###############################################################################
#------------------------------------------------------------------------------
# RSS
#------------------------------------------------------------------------------
sub generate_rss {
	my ($self, $diary_id) = @_;
	local ($self->{diary_id}, $self->{display_op}, $self->{daybook_admin}, $self->{allow_edit});
	# 桼⡼ɤ
	$self->{diary_id}      = $diary_id;
	$self->{daybook_admin} = $self->{allow_edit} = $self->{display_op} = undef;
	return $self->{ROBJ}->call( 'antenna/_index' );
}

#------------------------------------------------------------------------------
# RSSѤ
#------------------------------------------------------------------------------
sub load_diary_for_rss {
	my ($self, $diary_id, $other_flag) = @_;
	my $ROBJ = $self->{ROBJ};

	# load
	my $set   = $self->{daybook_setting};
	my $items = $set->{rss_items_int} || 10;
	my $logs;
	if ($other_flag) {	# ۿRSS
		my @categories;
		my $list = $self->load_category_name_list();
		foreach(@$list) {
			if ($_->{orss}) { push(@categories, $_->{category}); }
		}
		my %h;
		# ե饰դƥΤФơRSS
		$h{match_in_col} = 'category';
		$h{match_in}     = \@categories;
		$logs  = $self->load_diary( $items, $set, '&rss', \%h );
	} else {
		$logs  = $self->load_diary( $items, $set, '&rss' );
	}

	# RSSΥ
	my $tag_escape;
	if ($self->{rss_allow_tags}) {
		$tag_escape = $ROBJ->loadpm('TextParser::TagEscape', $self->{rss_allow_tags});
		$tag_escape->{allow_anytag} = $self->{trust_mode};
	}
	# ʸѴ
	my $jcode   = $ROBJ->loadpm('Jcode');
	my $charset = $ROBJ->{System_coding};
	my $length  = $self->{rss_summary_length} || 300;
	# RSS Τβù
	my $tm_max     = 0;
	my $update_max = 0;
	foreach(@$logs) {	# 
		# ǽ / 
		if ($_->{tm}        > $tm_max)     { $tm_max     = $_->{tm};        }
		if ($_->{update_tm} > $update_max) { $update_max = $_->{update_tm}; }

		# ղù  (dc sample)2006-05-02T13:54:30+09:00
		$_->{dc_date}    = $self->dc_date ( $_->{tm} );
		$_->{rfc_date}   = $ROBJ->rfc_date( $_->{tm} );
		$_->{dc_update}  = $self->dc_date ( $_->{update_tm} );
		$_->{rfc_update} = $ROBJ->rfc_date( $_->{update_tm} );

		## ³ɤפξ硢³ä
		$_->{text} =~ s/<!--%msg-->|<!--%more-->.*?<!--%more-->//sg;		# Seemore
		# ³ɤʸˤä
		$_->{text} =~ s/<!--.*?-->//sg;
		# ƥȥ
		my $text = $_->{text};
		if (defined $tag_escape) { $text=$tag_escape->escape($text); }
		$text =~ s/\]\]>/]]&gt;/g;
		$_->{description} = $text;

		# ʤĹդƥ
		$text =~ s/[\t\n]//g;		# indent / Ԥ
		$ROBJ->tag_delete($text);	# 
		my $new_text = $jcode->jsubstr($charset, $text, 0, $length);
		if (length($new_text) < length($text)) { $new_text .= '...'; }
		$ROBJ->tag_escape_amp($text);	# 
		$_->{description_short} = $new_text;

		# & Υ
		$ROBJ->tag_escape_for_xml($_->{title}, $_->{name}, $_->{category}, $_->{category_main}, $_->{files});
		# źեեʬ
		($_->{file_url}, $_->{file_size}, $_->{file_type}) = split(/\s*,\s*/, $_->{files});
		if (ord($_->{file_url}) == 0x2f) {	# Ƭʸ = /
			$_->{file_url} = $ROBJ->{Server_url} . $_->{file_url};
		}
	}
	# ѿå
	$self->{diary_tm}   = $tm_max;
	$self->{update_tm}  = $update_max;
	$self->{dc_date}    = $self->dc_date ( $tm_max );
	$self->{rfc_date}   = $ROBJ->rfc_date( $tm_max );
	$self->{dc_update}  = $self->dc_date ( $update_max );
	$self->{rfc_update} = $ROBJ->rfc_date( $update_max );
	return $logs;
}

#------------------------------------------------------------------------------
# xmlns:dc="http://purl.org/dc/elements/1.1/" դѴ
#------------------------------------------------------------------------------
sub dc_date {
	my $self = shift;
	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime( shift );
	return sprintf("%04d-%02d-%02dT%02d:%02d:%02d+00:00", $year+1900, $mon+1, $mday, $hour, $min, $sec);
}

###############################################################################
# Ģơ֥빹Ģ¸
###############################################################################
#------------------------------------------------------------------------------
# Ģơ֥ι
#------------------------------------------------------------------------------
sub update_daybookinfo {
	my ($self, $diary_id, $updates) = @_;
	my $ROBJ = $self->{ROBJ};

	$updates->{timestamp} = $ROBJ->{Timestamp};
	$updates->{all_tm}    = $ROBJ->{TM};
	$updates->{id}        = $diary_id;

	my $r  = $ROBJ->{DB}->update_match($DAYBOOKLIST_TABLE, $updates, 'id', $diary_id);
	if (!$r) { return 2; }	# Fail
	return 0;		# Success
}

#------------------------------------------------------------------------------
# Ģ¸
#------------------------------------------------------------------------------
sub save_daybook_setting {
	my ($self, $diary_id) = @_;
	my $ROBJ = $self->{ROBJ};
	my $set  = $self->load_daybook_setting( $diary_id );
	my $file = $self->{setting_dir} . $diary_id . $self->{file_ex};
	$ROBJ->fwrite_hash($file, $set);
	return 0;
}

###############################################################################
# ƥ롼
###############################################################################
#------------------------------------------------------------------------------
# ƥॳեΥ
#------------------------------------------------------------------------------
sub load_sysconfig {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};

	return $ROBJ->fread_hash_no_error( $self->{system_config_file} );
#	return $ROBJ->fread_hash_cached( $self->{system_config_file} );
}
#------------------------------------------------------------------------------
# ƥॳեΥ
#------------------------------------------------------------------------------
sub save_sysconfig {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $h = shift;
	$ROBJ->fwrite_hash( $self->{system_config_file}, $h );
}
#------------------------------------------------------------------------------
# ƥΥåץ졼ɥå
#------------------------------------------------------------------------------
sub check_upgrade {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $h = $self->load_sysconfig();
	if (! $h->{VERSION}) {	# ̤ = 󥹥ȡ
		$h->{VERSION}=$self->{VERSION};
		$self->save_sysconfig($h);
		return 0;
	}
	if ($h->{VERSION} < $self->{VERSION}) { return 1; }
	return 0;
}

###############################################################################
# ¾Υ֥롼
###############################################################################
#------------------------------------------------------------------------------
# 󥯤ѿ
#------------------------------------------------------------------------------
# ƤӽФ򤷤Ƥ
#	local ($self->{myself}, $self->{myself2});
sub set_myself {
	my ($self, $diary_id) = @_;
	my $ROBJ    = $self->{ROBJ};
	my $myself  = $ROBJ->{Myself};
	my $myself2 = $ROBJ->{Myself2};

	if ($self->{single_mode} eq $diary_id) { return ; }	# 󥰥桼⡼
	if ($self->{subdomain_mode}) {
		# ֥ɥᥤ⡼
		my $myself = "http://$diary_id.$self->{subdomain_mode}/";
		$self->{myself}  = $myself;			# ̾ѡQUERY
		$self->{myself2} = $myself;			# PATH_INFO

	} else {
		# ޥ桼
		$self->{myself}  = $myself2 . "$diary_id/";	# ̾ѡQUERY
		$self->{myself2} = $self->{myself};		# PATH_INFO 
	}
	return ;
}

#------------------------------------------------------------------------------
# DB Ѥ flag 
#------------------------------------------------------------------------------
sub set_db_flags {
	my $self = shift;
	foreach(@_) {
		if($_) { $_=1; } else { $_=0; }
	}
}

#------------------------------------------------------------------------------
# .htaccess ؤɵ
#------------------------------------------------------------------------------
sub create_htaccess {
	my ($self, $dir, $txt) = @_;
	my $ROBJ = $self->{ROBJ};
	my $file = $ROBJ->get_filepath( $dir . '.htaccess' );
	if (-e $file) { return ; }	# ¸ߤн񤭹ޤʤ

	$txt = "# Generated by adiary in $ROBJ->{Timestamp}\n" . $txt;
	$ROBJ->fwrite_lines($file, $txt);
}

###############################################################################
# ¾Υ֥롼
###############################################################################
#------------------------------------------------------------------------------
# IDURL
#------------------------------------------------------------------------------
sub get_daybook_url {
	my ($self, $id, $flag) = @_;
	my $ROBJ = $self->{ROBJ};
	if ($self->{subdomain_mode}) {
		return "http://$id.$self->{subdomain_mode}" . $ROBJ->{Myself};
	}
	my $url = $ROBJ->{Myself2};
	if ($id ne $self->{single_mode}) { $url .= "$id/"; }
	if ($flag) { return "$ROBJ->{Server_url}$url"; }
	return $url;
}

#------------------------------------------------------------------------------
# 
#------------------------------------------------------------------------------
sub load_icons_html {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	if ($self->{icon_dir} eq '') { return; }
	my $dir          = $ROBJ->get_filepath( $self->{icon_dir} );
	my $icon_cache   = $ROBJ->get_filepath( $self->{icon_cache_file} );
	my ($x,$skelton) = $ROBJ->check_skelton( 'format/icon_list' );
	my $tm_dir     = (stat($dir))[9];
	my $tm_skelton = (stat($skelton))[9];
	my $tm_cache   = (stat($icon_cache))[9];
	if ($dir eq '' || ! $tm_dir) { return []; }
	if ($tm_dir < $tm_cache && $tm_skelton < $tm_cache && $ROBJ->{Lastmodified_lib} < $tm_cache) {
		return $ROBJ->fread_lines_cached($icon_cache);
	}

	# ꥹȤ
	my $list;
	$list = $ROBJ->search_files($dir, '.gif');
	$list = [ map { substr($_, 0, length($_)-4) } @$list ];	# ĥҽ
	$list = [ grep { /[\w\- \.]+/ } @$list ];		# ʸե
	$list = [ sort {$a cmp $b} @$list ];

	# ȥcall
	my $out = $ROBJ->call( 'format/icon_list', $list);
	$ROBJ->fwrite_lines( $icon_cache, $out );
	return $out;
}

#------------------------------------------------------------------------------
# ʸǥåפ
#------------------------------------------------------------------------------
sub string_clip {
	my ($self, $string, $j_len) = @_;
	my $jcode = $self->{ROBJ}->loadpm('Jcode');
	my $len_orig = length($string);
	$string = $jcode->jsubstr($self->{ROBJ}->{System_coding}, $string, 0, $j_len);
	if ($len_orig > length($string)) { $string .= ($self->{clip_dots} || '...'); }	# ά ... ղ
	return $string;
}

#------------------------------------------------------------------------------
# ','򥨥פfor LIRS
#------------------------------------------------------------------------------
sub comma_escape {
	my $self = shift;
	foreach(@_) {
		$_ =~ s/([\\\,])/\\$1/g;
	}
	return $_[0];
}

#------------------------------------------------------------------------------
# link_key (wiki̾)Υ󥳡
#------------------------------------------------------------------------------
sub link_key_encode {
	my $self = shift;
	foreach(@_) {
		$_ =~ s/([^\.\/\~\*\-\w:;=\+&])/'%' . unpack('H2',$1)/eg;
	}
	return $_[0];
}


1;
