#!/usr/local/bin/perl
require 5.004;
use strict;
#-------------------------------------------------------------------------------
# Split from Satsuki::Diary.pm for AUTOLOAD.
#-------------------------------------------------------------------------------
# ǥϢ롼
# ĢϢ롼
# ȤʤɤκϢ롼
use Satsuki::Diary ();
use Satsuki::Diary_auto ();
package Satsuki::Diary;
our $DAYBOOKLIST_TABLE = '_daybooklist';
###############################################################################
# Ϣ
###############################################################################
#------------------------------------------------------------------------------
# Ģ
#------------------------------------------------------------------------------
sub daybook_setting {
	my ($self, $form) = @_;
	my $ROBJ     = $self->{ROBJ};
	my $auth     = $ROBJ->{Auth};
	my $diary_id = $self->{diary_id};
	if (! $auth->{ok})             { $ROBJ->message('Not login');                  return 1; }
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{daybook_admin})  { $ROBJ->message('Operation not permitted');    return 5; }

	# ¥桼ʸ󤫤ζ
	if (exists $form->{admin_users})     { $form->{admin_users}     =~ s/^\s*(.*?)\s*$/$1/; }
	if (exists $form->{edit_users})      { $form->{edit_users}      =~ s/^\s*(.*?)\s*$/$1/; }
	if (exists $form->{allow_com_users}) { $form->{allow_com_users} =~ s/^\s*(.*?)\s*$/$1/; }

	# Υ
	while(my ($k,$v) = each(%$form)) {
		$k =~ s/\W//g;
		$ROBJ->tag_escape($v);
	}
	# Υ
	if ($form->{description} && $self->{description_allow_tags}) {
		$form->{description} =~ s/[\r\n|\n|\r]/<br>/g;
		my $tag_escape = $ROBJ->loadpm('TextParser::TagEscape', $self->{description_allow_tags});
		$tag_escape->{allow_anytag} = $self->{trust_mode};
		$form->{description} = $tag_escape->escape( $form->{description} );
	}
	# Ping serverν񼰥å
	if ($form->{ping_servers_txt} ne '') {
		my @servers = split("\n", $form->{ping_servers_txt});
		foreach(@servers) {
			# Ƭ # ϥ
			if (substr($_, 0, 7) ne 'http://' && substr($_, 0, 1) ne '#')  { $_ = ''; }
		}
		my $txt = join("\n", @servers);
		$txt =~ s/\"/%22/g;
		$txt =~ s/\'/%27/g;
		$form->{ping_servers_txt} = $txt;
		$txt =~ s/\n/<br>/g;
		$ROBJ->tag_escape($txt);
		$form->{ping_servers_br_txt} = $txt;
	} elsif (exists $form->{ping_servers_txt}) {
		$form->{ping_servers_br_txt} = "";
	}
	# ١顼
	if (exists $form->{base_color}) {
		$form->{base_color} =~ s/[^\w:]//g;
		($form->{base_color}, $form->{base_color_rgb}) = split(':', $form->{base_color});
	}
	# 񤭹ID
	my $write_id = $form->{write_id};
	delete $form->{write_id};
	if (!$auth->get_userinfo($diary_id) && $auth->{admin}) {	# ԤΤǽ
		$write_id =~ s/\W//g;
		if ($auth->get_userinfo($write_id)) {
			$form->{write_id} = $write_id;
		} else {
			$form->{write_id} = $auth->{id};
		}
	}

	# ߤͤ˿ͤ򥪡С饤
	my %new_setting = %{ $self->{daybook_setting} };	# ߤ¸
	my $save_as_default;
	if ($auth->{admin} && $form->{save_as_default}) {
		$save_as_default = 1;
		%new_setting = ();
	}
	$ROBJ->into(\%new_setting, $form);			# %new_setting <- %$form

	# ǥե¸
	my $file = $self->{setting_dir} . $diary_id . $self->{file_ex};
	if ($save_as_default) {
		delete $new_setting{save_as_default};
		$file = $self->{my_default_setting_file};
	}
	$ROBJ->fwrite_hash($file, \%new_setting);

	# Ƕεʤɤκ
	$self->{"setting_$diary_id"} = $self->{daybook_setting} = \%new_setting;
	my %update;
	$self->update_daybooklist_info  ( $diary_id, 2, \%update );
	$self->generate_month_list      ( $diary_id, 2 );
	$self->generate_category_list   ( $diary_id, 2 );
	$self->generate_recent_diary    ( $diary_id, 2, \%update );
	$self->generate_recent_comment  ( $diary_id, 2, \%update );
	$self->generate_recent_trackback( $diary_id, 0, \%update );
	$self->generate_rss             ( $diary_id );
	return 0;
}
#------------------------------------------------------------------------------
# ꥹȾν񤭴
#------------------------------------------------------------------------------
sub update_daybooklist_info {
	my ($self, $diary_id, $no_save, $update) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $set  = $self->load_daybook_setting( $diary_id );

	$update ||= {};
	$update->{blog_name} = $self->string_clip($set->{blog_name}, ($self->{daybooklist_blog_name_len} || 24));
	$update->{hidden}    = ($set->{enable_force} eq '0' ? 1 : 0);
	if ($no_save) { return ; }
	return $DB->update_match($DAYBOOKLIST_TABLE, $update, 'id', $diary_id);
}

#------------------------------------------------------------------------------
# Ģѹ롼
#------------------------------------------------------------------------------
sub change_daybook_setting {
	my ($self, $new_set, $diary_id) = @_;
	my $ROBJ = $self->{ROBJ};
	$diary_id =~ s/\W//g;
	$diary_id ||= $self->{diary_id};
	# ߤͤ˿ͤ򥪡С饤
	my $new_setting = $self->load_daybook_setting($diary_id);
	$ROBJ->into($new_setting, $new_set);
	# ¸
	my $file = $self->{setting_dir} . $diary_id . $self->{file_ex};
	$ROBJ->fwrite_hash($file, $new_setting);
}

#------------------------------------------------------------------------------
# 桼եΥ
#------------------------------------------------------------------------------
sub load_usertag {
	my ($self, $theme) = @_;
	my $ROBJ = $self->{ROBJ};
	my $diary_id = $self->{diary_id};

	my $file = $ROBJ->get_filepath( $self->{usertag_dir} . $diary_id . '.txt' );
	if (!-e $file) { $file = $self->{default_usertag_file}; }
	return join('', @{ $ROBJ->fread_lines($file) });
}

#------------------------------------------------------------------------------
# 桼
#------------------------------------------------------------------------------
sub usertag_setting {
	my ($self, $tag_text) = @_;
	my $ROBJ = $self->{ROBJ};
	my $auth = $ROBJ->{Auth};
	my $diary_id = $self->{diary_id};
	if (! $auth->{ok})             { $ROBJ->message('Not login');                  return 1; }
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{allow_edit})     { $ROBJ->message('Operation not permitted');    return 5; }

	# ǥ쥯ȥå
	my $dir = $self->{usertag_dir};
	$ROBJ->mkdir($dir);

	# 륷Ȥ¸
	$ROBJ->{Error_flag} = 0;
	$ROBJ->fwrite_lines($dir . $diary_id . '.txt', $tag_text);
	if ($ROBJ->{Error_flag}) {
		$ROBJ->message('Save failed'); return 5;
	}

	return 0;
}

###############################################################################
# ǥϢ
###############################################################################
#------------------------------------------------------------------------------
# ƥץ졼ȥꥹȤκ
#------------------------------------------------------------------------------
sub load_templates {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	# ƥץ졼dir
	my $theme_dir  = $self->{theme_dir};
	my $theme_rdir = $ROBJ->get_filepath( $theme_dir );
	my $files = $ROBJ->search_files($theme_dir, undef, -1);
	# satsuki ǻϤޤƥץ졼ȤͥŪɽ
	$files  = [ sort {( (!index($b,'satsuki')) <=> (!index($a,'satsuki')) ) || $a cmp $b} @$files ];
	return $files;
}

#------------------------------------------------------------------------------
# ơޥꥹȤκ
#------------------------------------------------------------------------------
sub load_themes {
	my ($self, $template) = @_;
	my $ROBJ = $self->{ROBJ};

	# ƥץ졼dir
	$template =~ s/[^\w\-]//g;
	my $template_dir = "$self->{theme_dir}$template/";
	if ($template eq '') { $template_dir = $self->{system_template_dir}; }

	# ơޥꥹȤμ
	my $dir   = $ROBJ->get_filepath( $template_dir );
	my $files = $ROBJ->search_files($template_dir, undef, -1);
	$files  = [ sort @$files ];
	# ߤΥơޡʵ͡
	my $now_theme;
	if ($self->{template_dir} eq $template_dir) { $now_theme = $self->{theme}; }
	# 롼
	my @ary;
	foreach(@$files) {
		my %h;
		my $x = ord($_);
		if ($x == 0x5f || $x == 0x2e) { next; }	# Ƭ _ . ʤ¹Ԥʤ
		$h{theme_name}  = "$template/$_";
		$h{css_file}    = "$_/$_.css";
		$h{readme_file} = "$_/README";
		if ($_ eq $now_theme) { $h{selected} = ' selected'; }	# 
		push(@ary, \%h);
	}
	return \@ary;
}

#------------------------------------------------------------------------------
# 桼륷ȤΥ
#------------------------------------------------------------------------------
sub load_usercss {
	my ($self, $theme) = @_;
	my $ROBJ = $self->{ROBJ};
	my $diary_id = $self->{diary_id};

	my $file = $ROBJ->get_filepath( $self->{usercss_dir} . $diary_id . '.css' );
	if (!-e $file) { $file = $self->{default_usercss_file}; }
	return join('', @{ $ROBJ->fread_lines($file) });
}

#------------------------------------------------------------------------------
# ơޤ
#------------------------------------------------------------------------------
sub theme_select {
	my ($self, $theme_dir) = @_;
	my $ROBJ = $self->{ROBJ};
	my $auth = $ROBJ->{Auth};
	my $diary_id = $self->{diary_id};
	if (! $auth->{ok})             { $ROBJ->message('Not login');                  return 1; }
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{daybook_admin})  { $ROBJ->message('Operation not permitted');    return 5; }

	# ǡå
	my ($template, $theme) = split("/", $theme_dir);
	$template =~ s/[^\w-]//g;
	$theme    =~ s/[^\w-]//g;
	my $template_dir = $self->{theme_dir} . $template . '/';
	my $file = $ROBJ->get_filepath( "$template_dir$theme/$theme.css" );
	if (!-r $file) {	# ǥեȤ
		$template_dir = $self->{system_template_dir};
		$theme        = $self->{system_theme};
	}

	# ǥγǧ
	my $design_info = $ROBJ->fread_hash_no_error( "$template_dir$theme/design.info" );

	# ¸
	my %h;
	$h{theme}        = $theme;
	$h{template}     = $template;
	$h{template_dir} = $template_dir;
	if ($design_info->{base_color} ne '') {
		$h{base_color} = $design_info->{base_color};
		$h{base_color} =~ s/\W//g;
	}
	if ($design_info->{base_color_rgb} ne '') {
		$h{base_color_rgb} = $design_info->{base_color_rgb};
		$h{base_color_rgb} =~ s/\W//g;
	}
	my $file = $self->{setting_dir} . $diary_id . $self->{file_ex};
	$ROBJ->fappend_hash($file, \%h);
	return 0;
}

#------------------------------------------------------------------------------
# 桼륷Ȥ
#------------------------------------------------------------------------------
sub usercss_setting {
	my ($self, $css_text) = @_;
	my $ROBJ = $self->{ROBJ};
	my $auth = $ROBJ->{Auth};
	my $diary_id = $self->{diary_id};
	if (! $auth->{ok})             { $ROBJ->message('Not login');                  return 1; }
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{daybook_admin})  { $ROBJ->message('Operation not permitted');    return 5; }

	# ǥ쥯ȥå
	my $dir = $self->{usercss_dir};
	$ROBJ->mkdir($dir);

	# XSSкå桼⡼ɰʳǤϥå
	if (! $self->{trust_mode}) { $css_text = $self->css_escape( \$css_text ); }

	# 륷Ȥ¸
	$ROBJ->{Error_flag} = 0;
	$ROBJ->fwrite_lines($dir . $diary_id . '.css', $css_text);
	if ($ROBJ->{Error_flag}) {
		$ROBJ->message('Save failed'); return 5;
	}

	return 0;
}
#------------------------------------------------------------------------------
# 륷ȤΥ׽XSSк
#------------------------------------------------------------------------------
sub css_escape {
	my ($self, $_css) = @_;
	my $css;
	if (ref($_css) eq 'ARRAY')  { $_css = join('', @$_css); }
	if (ref($_css) eq 'SCALAR') { $css = $_css; } else { $css = \$_css; }

	# tab lf ʳʸ
	$$css =~ s/[\x00-\x08\x0b-\x1f]//g;
	# Ȥ
	my @comment;
	$$css =~ s|/\*(.*?)\*/ ? ?|push(@comment, $1), "\x01$#comment\x01"|seg;
	# ʸ
	my @str;
	$$css =~ s/(['"])((?:\\.|.)*?)\1/push(@str, $2), "\x02$#str\x02"/seg;
	foreach(@str) {
		$_ =~ s/\x0a//g;	# Խ
		$_ =~ s/\\"|"/\\22/g;
		$_ =~ s/\\'|'/\\27/g;
		if (ord(substr($_, -1)) > 0x7f) { $_ = $_ . ' '; }
	}
	# \ ˤλȤɻ
	$$css =~ s/\\([^"'\*\#])/$1/g;
	# ʸ
	$$css =~ s/[\x80-\xff]//g;
	# ʸν
	$$css =~ s/\@//g;
	while($$css =~ m[/\*|\*/&#|script|java|exp|eval|cookie|include]i) {	# ν
		$$css =~ s[/\*|\*/&#|script|java|exp|eval|cookie|include][]ig;
	}
	my $check = $$css;
	$check =~ s/[\x02-\x1f]//g;	# 浭
	if ($check =~ m[/\*|\*/&#|script|java|exp|eval|cookie|include]i) {	# 椢
		$$css =~ s/([\x02-\x1f])/ $1/g;	# spaceɲ
	}
	# url() γǧ
	$$css =~ s#url\(\s*(.*?)\s*\)#
		my $x  = $1;
		$x =~ s/'/%27/g;
		$x =~ s/"/%22/g;
		$x =~ s|\x02(\d+)\x02|$str[$1]|;
		if (substr($x,0,7) ne 'http://' && substr($x,0,8) ne 'http://' && substr($x,0,1) ne '/' && substr($x,0,2) ne './' && substr($x,0,3) ne '../') {
			$x = "./$x";
		}
		"url('$x')";
		#sieg;
	# ʸ
	$$css =~ s|\x02(\d+)\x02|"$str[$1]"|g;
	# Ȥ
	$$css =~ s|\x01(\d+)\x01|/*$comment[$1]*/  |g;

	return $$css;
}


#------------------------------------------------------------------------------
# ǥߥƥȤ
#------------------------------------------------------------------------------
sub usertext_setting {
	my ($self, $form) = @_;
	my $ROBJ = $self->{ROBJ};
	my $auth = $ROBJ->{Auth};
	my $diary_id = $self->{diary_id};
	if (! $auth->{ok})             { $ROBJ->message('Not login');                  return 1; }
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{daybook_admin})  { $ROBJ->message('Operation not permitted');    return 5; }

	# åΥ
	$ROBJ->{set} = $self->{daybook_setting};
	my $tag_escape = $ROBJ->loadpm('TextParser::TagEscape', $self->{usertext_allow_tags});
	$tag_escape->{allow_anytag} = $self->{trust_mode};	# ⡼ɤʤ

	my %h;
	foreach(qw(text_info text_main0 text_main1 bodyend_1st bodyend title_after text_footer text_side0 text_side1 text_side_a0 text_side_a1 text_side_b0 text_side_b1)) {
		$h{"${_}_src"} = $form->{$_ . '_txt'};
		$h{$_} = $tag_escape->escape( $form->{$_ . '_txt'} );
		$h{$_} =~ s/\n*$/\n/s;
	}

	$self->change_daybook_setting( \%h );
	return 0;
}

###############################################################################
# ǥ󡿾ܺ٥ǥϢ
###############################################################################
#------------------------------------------------------------------------------
# ǥꥹȤΥ
#------------------------------------------------------------------------------
sub load_desgin_list {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $diary_id = $self->{diary_id};
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{daybook_admin})  { $ROBJ->message('Operation not permitted');    return 5; }

	my $dir  = $self->{design_dir} . $diary_id . '/';
	my $info = $ROBJ->fread_hash_no_error($dir . $self->{design_info});
	my @name_list = split(',', $info->{design_list});
	my @list;
	foreach(@name_list) {
		if ($_ eq '') { next; }
		my %h;
		$h{id}        = $_;
		$h{name}      = $info->{"$_:name"};
		$h{theme_dir} = $info->{"$_:theme_dir"};
		push(@list, \%h);
	}
	return \@list;
}

#------------------------------------------------------------------------------
# ǥꥹȤ
#------------------------------------------------------------------------------
sub generate_design_list {
	my ($self, $diary_id) = @_;
	my $ROBJ = $self->{ROBJ};
	$diary_id =~ s/\W//g;

	my $dir  = $self->{design_dir} . $diary_id . '/';
	my $dirs = $ROBJ->search_files($dir, '', -1);
	my %info;
	foreach(@$dirs) {
		my $h = $ROBJ->fread_hash_no_error("$dir$_/$_.dat");
		if (!%$h) { next; }
		$info{"$_:name"} = $h->{name} || $_;
	}
	$info{design_list} = join(',', sort {$a cmp $b} @$dirs);
	$ROBJ->fwrite_hash($dir . $self->{design_info}, \%info);
}

#------------------------------------------------------------------------------
# ǥ򥳥ԡ
#------------------------------------------------------------------------------
sub design_copy {
	my ($self, $design_id) = @_;
	my $ROBJ = $self->{ROBJ};
	my $diary_id = $self->{diary_id};
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{daybook_admin})  { $ROBJ->message('Operation not permitted');    return 5; }
	$design_id =~ s/[^\w\-]//g;

	my $dir  = $ROBJ->get_filepath( $self->{design_dir} . $diary_id . '/' );
	my $info = $ROBJ->fread_hash_no_error($dir . $self->{design_info});
	$ROBJ->mkdir($self->{design_dir});
	$ROBJ->mkdir($dir);
	if ($design_id eq '' || ($design_id ne '_default' && !-e "$dir$design_id")) {
		$ROBJ->message('Not exists design id "%s"', $design_id); return 11;
	}
	# ԡ̾򸡺
	my $name_base = substr($design_id,0,24);
	$name_base =~ s/^_//;
	my $new_design = $name_base . "_copy" ;
	my $i=1;
	while((++$i)<99 && -e "$dir$new_design") { $new_design = $name_base . "_copy$i"; }
	if ($i>99) { $ROBJ->message('Internal Error(%s)', "design $i"); return -1; }

	# ԡ
	$self->{new_design_id} = $new_design;
	if ($design_id ne '_default') {
		$ROBJ->copy_dir("$dir$design_id", "$dir$new_design");
		rename("$dir$new_design/$design_id.dat", "$dir$new_design/$new_design.dat");
		$self->generate_design_list( $diary_id );
		return 0;
	}
	# ǥեȤ
	$ROBJ->mkdir("$dir$new_design");
	$ROBJ->copy_file( $self->{default_design_file}, "$dir$new_design/$new_design.dat" );
	my $r=$self->design_rebuild( $new_design );
	$self->generate_design_list( $self->{diary_id} );
	return $r;
}

#------------------------------------------------------------------------------
# ǥƹ
#------------------------------------------------------------------------------
sub design_rebuild {
	my ($self, $design_id) = @_;
	my $ROBJ = $self->{ROBJ};
	my $diary_id = $self->{diary_id};
	$design_id =~ s/[^\w\-]//g;
	my $file = "$self->{design_dir}$diary_id/$design_id/$design_id.dat";
	my $h    = $ROBJ->fread_hash( $file );
	if ($design_id eq '') {
		$ROBJ->message('Not exists design id "%s"', $design_id); return 11;
	}
	$h->{design_id} = $design_id;
	return $self->_design_edit( $h );
}

#------------------------------------------------------------------------------
# ǥ
#------------------------------------------------------------------------------
sub design_delete {
	my ($self, $design_id) = @_;
	my $ROBJ = $self->{ROBJ};
	my $diary_id = $self->{diary_id};
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{daybook_admin})  { $ROBJ->message('Operation not permitted');    return 5; }
	$design_id =~ s/[^\w\-]//g;

	my $dir = $ROBJ->get_filepath( $self->{design_dir} . $diary_id . '/' . $design_id);
	if ($design_id eq '' || !-e $dir) {
		$ROBJ->message('Not exists design id "%s"', $design_id); return 11;
	}
	# 桩
	if ($self->{daybook_setting}->{design_id} eq $design_id) { $self->design_select('_default'); }
	# ǥ쥯ȥ
	$ROBJ->dir_delete($dir);
	$self->generate_design_list( $diary_id );
	return 0;
}

#------------------------------------------------------------------------------
# ǥǡ
#------------------------------------------------------------------------------
sub load_design_data {
	my ($self, $design_id) = @_;
	my $ROBJ = $self->{ROBJ};
	my $diary_id = $self->{diary_id};
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{daybook_admin})  { $ROBJ->message('Operation not permitted');    return 5; }
	$design_id =~ s/[^\w\-]//g;

	my $dir = $ROBJ->get_filepath( $self->{design_dir} . $diary_id . '/' . $design_id . '/');
	if (!-e $dir) {
		$ROBJ->message('Not exists design id "%s"', $design_id); return 11;
	}
	my $h = $ROBJ->fread_hash($dir . "$design_id.dat");
	if (!%$h) { $ROBJ->message('Internal Error(%s)', "$design_id.dat"); return -1; }
	return $h;
}

#------------------------------------------------------------------------------
# ǥԽ¸
#------------------------------------------------------------------------------
sub design_edit {
	my ($self, $form) = @_;
	my $ROBJ = $self->{ROBJ};
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{daybook_admin})  { $ROBJ->message('Operation not permitted');    return 5; }
	my $r = &_design_edit(@_);
	$self->generate_design_list( $self->{diary_id} );
	return $r;
}
sub _design_edit {
	my ($self, $form) = @_;
	my $ROBJ = $self->{ROBJ};
	my $diary_id = $self->{diary_id};

	# ѿ
	my $dir = $ROBJ->get_filepath( $self->{design_dir} . $diary_id . '/' );
	my $trust_mode = $self->{trust_mode};
	my $design_id = $form->{design_id};
	my $new_id    = $form->{new_id};
	$design_id =~ s/[^\w\-]//g;
	$new_id    =~ s/[^\w\-]//g;
	if ($design_id eq '' || $design_id eq '_default' || !-e "$dir$design_id") {
		$ROBJ->message('Not exists design id "%s"', $design_id); return 11;
	}

	# ǥIDѹ
	my $old_id;
	if ($new_id ne '' && $design_id ne $new_id) {
		if ($new_id ne '_default' && !-e "$dir$new_id" && rename("$dir$design_id", "$dir$new_id")) {
			rename("$dir$new_id/$design_id.dat", "$dir$new_id/$new_id.dat");
			$old_id    = $design_id;
			$design_id = $new_id;
		} else {
			$form->{new_id} = $design_id;
			$ROBJ->message('Change faild design id "%s" to "%s"', $design_id, $new_id);
		}
	}
	$dir .= "$design_id/";

	# ̾ѹ
	my %info;
	my $name = $form->{name};
	$ROBJ->tag_escape($name);
	$info{name} = $name;
	# ᥤ / ɥС
	{
		my $skelton_dir = $dir . '_skelton/';
		my $main    = $form->{main_txt}    || $form->{main};
		my $mainone = $form->{mainone_txt} || $form->{mainone};
		my $sidebar = $form->{sidebar_txt} || $form->{sidebar};
		foreach($main, $mainone, $sidebar) {
			# @xxx module θƤӽФػ
			$_ =~ s/(name\s*=\s*[\"\']?)\@/$1%40/ig;
			# <!--$command--><!--@command-->ζػ
			$_ =~ s/<!--([\$\@])/<!-- $1/g;
			# Ƚ
			$_ =~ s/(\G|\n)#.*\n/$1/eg;
			# ǸԣĤˤ
			$_ =~ s/\n*$/\n/s;
		}
		$info{main}    = $main;
		$info{mainone} = $mainone;
		$info{sidebar} = $sidebar;

		# main
		$ROBJ->mkdir($skelton_dir);
		my $tag_escape = $ROBJ->loadpm('TextParser::TagEscape', $self->{main_allow_tags});
		$tag_escape->{allow_anytag} = $trust_mode;
		$main = $tag_escape->escape( '<module name="@header">' . "\n" . $main . '<module name="@footer">' . "\n");
		$ROBJ->fwrite_lines("${skelton_dir}_main.html", $main);

		# main_onelog
		$tag_escape->init($self->{mainone_allow_tags});
		$tag_escape->{allow_anytag} = $trust_mode;
		$mainone = $tag_escape->escape( '<module name="@header">' . "\n" . $mainone . '<module name="@footer">' . "\n");
		$ROBJ->fwrite_lines("${skelton_dir}_main_onelog.html", $mainone);

		# sidebar
		$tag_escape->init($self->{sidebar_allow_tags});
		$tag_escape->{allow_anytag} = $trust_mode;
		$sidebar = $tag_escape->escape( '<module name="@header">' . "\n" . $sidebar . '<module name="@footer">' . "\n");
		$ROBJ->fwrite_lines("${skelton_dir}_sidebar.html", $sidebar);
	}

	# ١ơ
	my $template = $form->{base_template};
	my $theme    = $form->{base_theme};
	if (exists $form->{theme}) {
		($template, $theme) = split("/", $form->{theme});
	}
	$template =~ s/[^\w-]//g;
	$theme    =~ s/[^\w-]//g;
	my $template_dir = $self->{theme_dir} . $template . '/';
	my $file = $ROBJ->get_filepath( "$template_dir$theme/$theme.css" );
	if ($theme ne '' && !-r $file) {	# ǥեȤ
		$template = $self->{system_template};
		$theme    = $self->{system_theme};
	}
	$info{base_template} = $template;
	$info{base_theme}    = $theme;

	# ١顼
	my $base_color = $form->{base_color};
	$base_color =~ s/[^\w:]//g;
	if ($base_color eq '') { $base_color="de:1841CD"; }
	($info{base_color}, $info{base_color_rgb}) = split(':', $base_color);

	# CSSν
	my $css_dir = $dir . 'css/';
	$ROBJ->mkdir($css_dir);
	my $css_text = $form->{css_txt};
	if (! $trust_mode) { $css_text = $self->css_escape( \$css_text ); }
	$info{css} = $css_text;
	if ($theme ne '') {
		$css_text = "\@import url(\"$ROBJ->{Basepath}$self->{theme_dir}$template/$theme/$theme.css\");\n" . $css_text;
	}
	$ROBJ->fwrite_lines($css_dir . 'css.css', $css_text);

	# ƥ⡼ɡ
	if ($form->{system_mode_yes}) {
		$info{system_mode_yes} = 1;
		$ROBJ->touch( $css_dir . 'system_mode_yes' );
	} else {
		$ROBJ->file_delete( $css_dir . 'system_mode_yes' );
	}

	# ¸
	$info{data_coding} = $ROBJ->{System_coding};
	$ROBJ->fwrite_hash($dir . "$design_id.dat", \%info);
	# 桩
	my $cur_id = $self->{daybook_setting}->{design_id};
	if ($cur_id eq $form->{design_id} || $cur_id eq $design_id) { $self->_design_select($design_id); }
	return 0;
}

#------------------------------------------------------------------------------
# ǥ
#------------------------------------------------------------------------------
sub design_select {
	my ($self, $design_id) = @_;
	my $ROBJ = $self->{ROBJ};
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{daybook_admin})  { $ROBJ->message('Operation not permitted');    return 5; }
	return &_design_select(@_);
}

sub _design_select {
	my ($self, $design_id) = @_;
	my $ROBJ = $self->{ROBJ};
	my $diary_id = $self->{diary_id};
	$design_id =~ s/[^\w\-]//g;

	my $dir  = $self->{design_dir} . $diary_id . '/';
	my $_dir = $ROBJ->get_filepath( $dir );
	my $info = $ROBJ->fread_hash_no_error($dir . $self->{design_info});
	if ($design_id eq '' || ($design_id ne '_default' && !-e "$_dir$design_id")) {
		$ROBJ->message('Not exists design id "%s"', $design_id); return 11;
	}

	# ǥIDѹʤ
	my $set = $self->{daybook_setting};
	if ($set->{design_id} eq '' && $design_id eq '_default') { return 0; }

	# ¸
	my %h;
	if ($design_id eq '_default') {
		$h{design_id}      = undef;
		$h{design_base_tm} = undef;
		$h{template_dir}   = $set->{old_template_dir} || $self->{system_template_dir};
		$h{template}       = $set->{old_template}     || $self->{system_template};
		$h{theme}          = $set->{old_theme}        || $self->{system_theme};
		$h{base_color}     = $set->{old_base_color}     || 'de';
		$h{base_color_rgb} = $set->{old_base_color_rgb} || '1841CD';
		$h{base_template_dir} = undef;
	} else {
		$h{design_id} = $design_id;
		my $x = $ROBJ->fread_hash("$_dir$design_id/$design_id.dat");
		if ($set->{design_id} eq '') {
			$h{old_template_dir}   = $set->{template_dir};
			$h{old_template}       = $set->{template};
			$h{old_theme}          = $set->{theme};
			$h{old_base_color}     = $set->{base_color};
			$h{old_base_color_rgb} = $set->{base_color_rgb};
			$h{base_template}      = $x->{base_template};
			$h{base_theme}         = $x->{base_theme};
		}
		$h{base_template_dir} = "$self->{theme_dir}$x->{base_template}/";
		$dir .= "$design_id/";
		$h{template_dir} = $dir;
		$h{theme}        = 'css';
		$h{desing_id}    = $design_id;
		$h{design_base_tm} = $ROBJ->get_file_lastmodified( $self->{default_design_file} );
		$h{base_color}     = $x->{base_color}     || 'de';
		$h{base_color_rgb} = $x->{base_color_rgb} || '1841CD';
	}
	# ¸
	$self->change_daybook_setting( \%h );
	return 0;
}


###############################################################################
# ԽϢ - skelton롼
###############################################################################
#------------------------------------------------------------------------------
# 
#------------------------------------------------------------------------------
sub diary_delete {
	my ($self, $pkey) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	if (! $auth->{ok})             { $ROBJ->message('Not login');                  return 1; }
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{allow_edit})     { $ROBJ->message('Operation not permitted');    return 5; }

	my $diary_id = $self->{diary_id};
	# Trackback κ
	my $r = $DB->delete_match("${diary_id}_tb", 'diary_pkey', $pkey);
	if ($r) {	# 
		$self->generate_recent_trackback($diary_id);	# ǶTB
	}
	# Ȥκ
	$r = $DB->delete_match("${diary_id}_comment", 'diary_pkey', $pkey);
	if ($r) {	# 
		$self->generate_recent_comment($diary_id);	# ǶΥȰ
	}
	# ƥΡɤʤǧ
	my %h;
	$h{match_int}   = {'pkey' => $pkey};
	$h{select_cols} = ['upnode'];
	my $ary = $DB->select("${diary_id}_diary", \%h);
	my $upnode = $ary->[0]->{upnode};

	# κ
	$r = $DB->delete_match("${diary_id}_diary", 'pkey', $pkey);

	# ƵˤҥΡɥꥹȤκ
	if ($upnode ne '') {
		$self->update_diary_children_cache($diary_id, $upnode);
	}
	# ղþκ
	$self->generate_month_list   ($diary_id, 2);	# ̥ꥹȤ
	$self->generate_category_list($diary_id, 2);	# ʬꥹȤ
	$self->generate_recent_diary ($diary_id, 0);	# ǶεԽ
	$self->generate_rss          ($diary_id);

	if ($r!=1) { $ROBJ->message("Diary delete failed"); return 10; }	# 
	return 0;			# 
}

#------------------------------------------------------------------------------
# ƥԽ
#------------------------------------------------------------------------------
sub category_edit {
	my ($self, $__form) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	if (! $auth->{ok})             { $ROBJ->message('Not login');                  return 1; }
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{allow_edit})     { $ROBJ->message('Operation not permitted');    return 5; }

	my $set       = $self->{daybook_setting};
	my $name_list = $set->{category_name_list};
	if ($name_list eq '') { $ROBJ->message('Category does not exist'); return ; }

	my $categories = [ split(/\n/, $name_list) ];
	my %level;
	my %other_rss;
	my $diary_id    = $self->{diary_id};
	my $diary_table = "${diary_id}_diary";
	my $change_flag;
	my $form = {};
	foreach(keys(%$__form)) {	# key Υ󥳡ɤ᤹
		my $k = $_;
		$k =~ tr/+/ /;
		$k =~ s/%([0-9a-fA-F][0-9a-fA-F])/chr(hex($1))/eg;
		$ROBJ->tag_escape($k);
		$form->{$k} = $__form->{$_};
	}
	my $cflags;
	foreach(@$categories) {
		my ($old_name, $option) = split("\t", $_, 2);
		my ($count, $old_level, $old_orss) = split("=", $option);
		my $category =      $form->{"${old_name}_name"};
		my $level    = int( $form->{"${old_name}_level"} );
		my $orss     = int( $form->{"${old_name}_orss"}  );	# other RSS
		#
		# ƥ̾ѹ
		#
		$ROBJ->tag_escape($category);
		if ($category !~ /^\s*$/ && $category ne $old_name) {
			# ƥ̾ν
			$category =~ s/^\s*(.*?)\s*$/$1/;	# ζ
			$category =~ s/\t/ /g;			# tabspaceִ
			my ($category_main, $sub) = split(/\s*::\s*/, $category, 2);	# , ڤ
			if ($category_main eq '') {
				$ROBJ->message('Category error "%s"', $category);
				next;
			}
			# ǡ١ι
			my %h;
			$h{category}      = $category_main;
			if ($sub ne '') { $h{category} .= "::$sub"; }
			$h{category_main} = $category_main;
			my $r = $DB->update_match($diary_table, \%h, 'category', $old_name);
			if ($r) {
				$ROBJ->message('Category change "%s" to "%s"', $old_name, $category);
				$old_name = $category;
				$level{$category}     = $level || undef;
				$other_rss{$category} = $orss  || undef;
				$change_flag = 10;
			} else { $ROBJ->message('Category "%s" change failed', $category); }
		}
		#
		# ƥ̾ɽ٥ѹ
		#
		if ($level != $old_level) {
			$level{$old_name} = $level || undef;
			$ROBJ->message('Category level set: "%s" is "%d"', $old_name, $level);
			$change_flag += 1;
		}
		if ($orss != $old_orss) {
			$other_rss{$old_name} = $orss || undef;
			$cflags++;
			$change_flag += 1;
		}
	}
	# 
	if ($change_flag) {
		$self->generate_category_list( $diary_id, 0, \%level, \%other_rss );	# ʬꥹȤ
	}
	if ($cflags) {
		$ROBJ->message('%d category flags change', $cflags);
		$self->generate_rss($diary_id);
	}
	return 0;
}

#------------------------------------------------------------------------------
# ȤԽ
#------------------------------------------------------------------------------
sub comment_edit {
	my ($self, $form, $mode) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $diary_id = $self->{diary_id};
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{allow_edit})     { $ROBJ->message('Operation not permitted');    return 5; }

	# ǧ
	my $diary_pkey = int($self->{display_op});
	$self->load_diary(1);
	if ($self->{load_days} != 1 || !$self->{diary_pkey_selected}) {
		$ROBJ->message("Illegal diary number (%s)"); return 10;
	}

	# ե
	my $table_name = "${diary_id}_comment";
	my $enable_ary  = [];
	my $disable_ary = [];
	my $delete_ary  = $form->{comment_delete_ary} || [];
	if ($mode eq '') {
		my $ary = $form->{comment_pkey_ary} || [];
		foreach(@$ary) {
			my $pkey = int($_);
			if ($form->{"comment_disable$pkey"}) { push(@$disable_ary, $pkey); }
							else { push(@$enable_ary,  $pkey); }
		}
	} else {
		my $ary = $form->{comment_check_pkey_ary} || [];
		if ($mode eq 'delete') { $delete_ary  = $ary; }
		if ($mode eq 'open')   { $enable_ary  = $ary; }
		if ($mode eq 'close')  { $disable_ary = $ary; }
	}

	# Ȥκ
	my $deletes = 0;
	if (@$delete_ary) { $deletes=$DB->delete_match($table_name, 'pkey', $delete_ary) +0; }
	$ROBJ->message("Delete %d comments", $deletes);

	# Ȥ̵
	my $changes =0;
	if (@$enable_ary)  { $changes += $DB->update_match($table_name, {enable => 1}, 'pkey', $enable_ary , 'enable', 0, 'hidden', 0); }
	if (@$disable_ary) { $changes += $DB->update_match($table_name, {enable => 0}, 'pkey', $disable_ary, 'enable', 1); }
	$ROBJ->message("Change enable flag %d on comments", $changes);

	$self->calc_comments($diary_id, $diary_pkey);	# ȿϿ
	$self->generate_recent_comment($diary_id);	# ǶΥ
	$self->generate_rss           ($diary_id);
	return 0;		# 
}

#------------------------------------------------------------------------------
# ȥåХåԽ
#------------------------------------------------------------------------------
sub trackback_edit {
	my ($self, $form, $mode) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $diary_id = $self->{diary_id};
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{allow_edit})     { $ROBJ->message('Operation not permitted');    return 5; }

	# ǧ
	my $diary_pkey = int($self->{display_op});
	$self->load_diary(1);
	if ($self->{load_days} != 1 || !$self->{diary_pkey_selected}) {
		$ROBJ->message("Illegal diary number", "$diary_id/0$diary_pkey"); return 10;
	}

	# ե
	my $table_name = "${diary_id}_tb";
	my $enable_ary = [];
	my $disable_ary= [];
	my $delete_ary = $form->{tb_delete_ary} || [];
	if ($mode eq '') {
		my $ary = $form->{tb_pkey_ary} || [];
		foreach(@$ary) {
			my $pkey = int($_);
			if ($form->{"tb_disable$pkey"}) { push(@$disable_ary, $pkey); }
						else    { push(@$enable_ary,  $pkey); }
		}
	} else {
		my $ary = $form->{tb_check_pkey_ary} || [];
		if ($mode eq 'delete') { $delete_ary  = $ary; }
		if ($mode eq 'open')   { $enable_ary  = $ary; }
		if ($mode eq 'close')  { $disable_ary = $ary; }
	}

	# ȥåХåκ
	my $deletes = 0;
	if (@$delete_ary) { $deletes=$DB->delete_match($table_name, 'pkey', $delete_ary) +0; }
	$ROBJ->message("Delete %d trackbacks", $deletes);

	# ȥåХå̵
	my $changes =0;
	if (@$enable_ary)  { $changes += $DB->update_match($table_name, {enable => 1}, 'pkey', $enable_ary , 'enable', 0); }
	if (@$disable_ary) { $changes += $DB->update_match($table_name, {enable => 0}, 'pkey', $disable_ary, 'enable', 1); }
	$ROBJ->message("Change enable flag %d on trackbacks", $changes);

	$self->calc_trackbacks($diary_id, $diary_pkey);		# ȥåХåϿ
	$self->generate_recent_trackback($diary_id);		# ǶΥȥåХå
	$self->generate_rss             ($diary_id);
	return 0;		# 
}

#------------------------------------------------------------------------------
# ꥹȤԽ
#------------------------------------------------------------------------------
sub list_edit {
	my ($self, $type, $form, $delete_ary) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $diary_id = $self->{diary_id};
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{allow_edit})     { $ROBJ->message('Operation not permitted');    return 5; }

	if ($type eq 'trackback') { $type='tb'; }
	if ($type ne 'diary' && $type ne 'comment' && $type ne 'tb') { return 10; }

	# ѹԤpkeyꥹ
	my $pkey_ary;
	if (ref($delete_ary)) {
		$pkey_ary = $delete_ary;
	} else {
		$pkey_ary = $form->{pkey_ary};
	}

	my $update_diary_pkeys = [];
	my $table = $diary_id . '_' . $type;
	# /TBѹԤꥹȤ
	if ($type ne 'diary') {
		my %h;
		$h{match_in_col} = 'pkey';
		$h{match_in}     = $pkey_ary;
		$h{select_cols}  = ['diary_pkey'];
		my $logs = $DB->select($table, \%h);
		# pkeyΥꥹ
		my %pkeys;
		map { $pkeys{$_->{diary_pkey}}=1 } @$logs;
		$update_diary_pkeys = [ keys(%pkeys) ];
	}

	# SQLȯ
	if (ref($delete_ary) && $type eq 'diary') { # 
		# Υ/TB
		$DB->delete_match("${diary_id}_comment", 'diary_pkey', $pkey_ary);
		$DB->delete_match("${diary_id}_tb",      'diary_pkey', $pkey_ary);
		# ƥΡɾμ
		my %h;
		$h{match_in_col} = 'pkey';
		$h{match_in}     = $pkey_ary;
		$h{select_cols}  = ['upnode'];
		my $ary = $DB->select("${diary_id}_diary", \%h);
		my %upnode;
		map { $upnode{ $_->{upnode} }=1 } @$ary;
		# κ
		$self->{rows} = $DB->delete_match($table, 'pkey', $pkey_ary);
		# ƥΡɤˤҵꥹȤι
		foreach(keys(%upnode)) {
			$self->update_diary_children_cache($diary_id, $_);
		}
	} elsif (ref($delete_ary)) { # ȡȥåХåκ
		# SQLȯԡʺ
		$self->{rows} = $DB->delete_match($table, 'pkey', $pkey_ary);
	} else { # ѹ
		my %update;
		if    ($form->{enable})  { $update{enable} = 1; }
		elsif ($form->{disable}) { $update{enable} = 0; }
		else { return 11; }
		# SQLȯ
		if ($type eq 'comment') {	# Ȥʤ
			$self->{rows} = $DB->update_match($table, \%update, 'pkey', $pkey_ary, 'hidden', 0);
		} else {
			$self->{rows} = $DB->update_match($table, \%update, 'pkey', $pkey_ary);
		}
	}

	# ǡΥå񤭴
	foreach(@$update_diary_pkeys) {
		if ($type eq 'comment') {
			$self->calc_comments($diary_id, $_);	# ȿƷ׻
		} else {
			$self->calc_trackbacks($diary_id, $_);	# ȥåХåƷ׻
		}
	}

	# 
	if ($type eq 'diary') {
		$self->generate_month_list   ($diary_id, 2);	# ̥ꥹȤ
		$self->generate_category_list($diary_id, 2);	# ʬꥹȤ
		$self->generate_recent_diary ($diary_id, 0);	# ǶεԽ
	} elsif ($type eq 'comment') {
		$self->generate_recent_comment($diary_id);
	} elsif ($type eq 'tb') {
		$self->generate_recent_trackback($diary_id);
	}
	$self->generate_rss          ($diary_id);
	return 0;		# 
}

#------------------------------------------------------------------------------
# ꥹȤκ
#------------------------------------------------------------------------------
sub list_delete {
	my ($self, $type, $pkey_ary) = @_;
	return $self->list_edit($type, undef, $pkey_ary);
}

1;
