#!/usr/local/bin/perl
require 5.004;
use strict;
#-------------------------------------------------------------------------------
# Split from Satsuki::Diary.pm for AUTOLOAD.
#-------------------------------------------------------------------------------
use Satsuki::Diary ();
use Satsuki::Diary_auto ();
use Satsuki::Diary_auto2 ();
use Satsuki::Diary_auto3 ();
package Satsuki::Diary;
our $DAYBOOKLIST_TABLE;
###############################################################################
# С󤫤Υåץ졼
###############################################################################
#------------------------------------------------------------------------------
# Version 2.09  Version 2.10ʹ
#------------------------------------------------------------------------------
sub adiary_upgrade_for_v210 {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	if (! $auth->{admin}) { $ROBJ->message('Operation not permitted'); return 5; }

	# Ģؤɲ
	my $daybooks = $DB->select($DAYBOOKLIST_TABLE, {no_error => 1});
	my $r=0;
	foreach (@$daybooks) {
		my $diary_id = $_->{id};
		my $table     = "${diary_id}_diary";
		# for diary
		if ( $DB->add_index($table, 'link_key') ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		# for trackback
		if ( $DB->add_index("${diary_id}_tb", 'internal') ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
	}
	return $r;
}

#------------------------------------------------------------------------------
# Version 1.44  Version 1.991ʹ
#------------------------------------------------------------------------------
sub adiary_upgrade_for_v1991 {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	if (! $auth->{admin}) { $ROBJ->message('Operation not permitted'); return 5; }

	# ƹ۾ؿ
	my $cond_func = sub {
		my $d = shift;
		if ($d->{_text} =~ /\[image:[^\]]*:small/) { return 0; }	# ƹۤ
		return 1;	# ƹۤʤ
	};

	#---------------------------
	# ͥե̾ѹ
	#---------------------------
	my $old_thumb = "thumbnail";
	my $new_thumb = ".thumbnail";
	my $image_dir = $ROBJ->get_filepath($self->{image_dir});
	my $sub = sub {
		my $func = shift;
		my $dir  = shift;
		my $count = 0;
		my $dirs = $ROBJ->search_files($dir, '', -1);
		foreach(@$dirs) {
			if ($_ eq $old_thumb) {
				$count++;
				rename("$dir$_", "$dir$new_thumb");
				next;
			}
			$count += &$func($func, "$dir$_/");
		}
		return $count;
	};

	my $daybooks = $DB->select($DAYBOOKLIST_TABLE, {no_error => 1});
	foreach (@$daybooks) {
		my $id = $_->{id};
		my $table_tb = $id . "_tb";
		#---------------------------
		# TB Ƚѥե饰
		#---------------------------
		# for trackback
		if ($DB->add_column($table_tb,  {name => "internal", type => "flag", index => 1}) ) {
			$ROBJ->message('Internal Error(%s)', $table_tb);
			return 5;
		}
		# ȥåХå򸡺
		my $this_daybook_url = $self->get_daybook_url($id, 1);
		my $tb_list = $DB->select($table_tb, {select_cols => ["pkey", "url"]});
		my @internal_pkey;
		my @external_pkey;
		foreach (@$tb_list) {
			if (index($_->{url}, $this_daybook_url) == 0) {
				push(@internal_pkey, $_->{pkey});
			} else {
				push(@external_pkey, $_->{pkey});
			}
		}
		# TB: 0(false)
		$DB->update_match($table_tb, {internal => 0}, 'pkey', \@external_pkey);
		# TB: 1(true)
		$DB->update_match($table_tb, {internal => 1}, 'pkey', \@internal_pkey);
		
		# ͥǥ쥯ȥ̾ѹ
		my $c = &$sub($sub, $image_dir . $id . '/');
		
		# κƹ
		if (!$c) { next; }	# ͥdirʤкƹۤɬפϤʤ
		$self->daybook_rebuild($id, $cond_func);
	}

	# Ģ˺ǿȥɲ
	if ($DB->add_column($DAYBOOKLIST_TABLE, {name => "newest_title", type => "text"}) ) {
		$ROBJ->message('Internal Error(%s)', $DAYBOOKLIST_TABLE);
		return 5;
	}
	# åץ졼ɾεϿ
	my $h = $self->load_sysconfig();
	if ($h->{VERSION}<1.991) {
		$h->{VERSION} = 1.991;
		$self->save_sysconfig( $h );
	}
	# ղþκƹ
	return $self->root_daybooks_info_rebuild();
}

#------------------------------------------------------------------------------
# Version 1.32  Version 1.40ʹ
#------------------------------------------------------------------------------
sub adiary_upgrade_for_v140 {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	if (! $auth->{admin}) { $ROBJ->message('Operation not permitted'); return 5; }

	# Ģؤɲ
	my $daybooks = $DB->select($DAYBOOKLIST_TABLE, {no_error => 1});
	my $r = 0;
	foreach (@$daybooks) {
		my $diary_id = $_->{id};
		my $table     = "${diary_id}_diary";
		my $table_com = "${diary_id}_comment";
		my $table_tb  = "${diary_id}_tb";
		#---------------------------
		# 쥫κ
		#---------------------------
		if ( $DB->drop_column($table, "upnode") ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		#---------------------------
		# wikiĥɲ
		#---------------------------
		if ( $DB->add_column($table, {name => "link_key", type => "text", index => 1, unique => 1}) ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		if ( $DB->add_column($table, {name => "upnode", type => "text", index => 1}) ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		if ( $DB->add_column($table, {name => "children_cache", type => "text"}) ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		# for comment
		if ( $DB->add_column($table_com, {name => "diary_elink_key", type => "text"}) ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		# for trackback
		if ( $DB->add_column($table_tb,  {name => "diary_elink_key", type => "text"}) ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		#---------------------------
		# /TBǡκ
		#---------------------------
		my $h = { search_cols => ['pkey', 'comments_all', 'tbs_all'] };
		my $list = $DB->select($table, $h);
		foreach(@$list) {
			my $pkey = $_->{pkey};
			$DB->update_match($table, {priority => 0, link_key => "0$pkey"}, 'pkey', $pkey);
			# Ƚ
			if ($_->{comments_all}) {
				$DB->update_match($table_com, {diary_elink_key => "0$pkey"}, 'diary_pkey', $pkey);
			}
			if ($_->{tbs_all}) {
				$DB->update_match($table_tb,  {diary_elink_key => "0$pkey"}, 'diary_pkey', $pkey);
			}
		}
	}

	if ($r) { return $r; }

	# ղþκƹ
	return $self->root_daybooks_info_rebuild();
}

#------------------------------------------------------------------------------
# Version 1.22  Version 1.30ʹ
#------------------------------------------------------------------------------
sub adiary_upgrade_for_v130 {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	if (! $auth->{admin}) { $ROBJ->message('Operation not permitted'); return 5; }

	# Ģؤɲ
	my $h = {name => "blog_name", type => "text"};
	if ( $DB->add_column($DAYBOOKLIST_TABLE, $h) ) {
		$ROBJ->message('Internal Error(%s)', $DAYBOOKLIST_TABLE);
		return 1;
	}
	my $h = {name => "hidden", type => "flag", index => 1};
	if ( $DB->add_column($DAYBOOKLIST_TABLE, $h) ) {
		$ROBJ->message('Internal Error(%s)', $DAYBOOKLIST_TABLE . "(2)");
		return 2;
	}
	$DB->update_match($DAYBOOKLIST_TABLE, {hidden => 0});
	# ղþκƹ
	return $self->root_daybooks_info_rebuild();
}

#------------------------------------------------------------------------------
# Version 1.04  Version 1.10ʹ
#------------------------------------------------------------------------------
sub adiary_upgrade_for_v110 {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	if (! $auth->{admin}) { $ROBJ->message('Operation not permitted'); return 5; }

	my $daybooks = $DB->select($DAYBOOKLIST_TABLE, {no_error => 1});
	my $cond_func = sub {
		my $d = shift;
		if ($d->{text} =~ /<!-- Seemore -->/) { return 0; }	# ƹۤ
		return 1;	# ƹۤʤ
	};
	my ($r, $c);
	foreach (@$daybooks) {
		my $diary_id = $_->{id};
		my $table = "${diary_id}_diary";
		# бɲ
		my $h = {name => "phone_cache", type => "text"};
		if ( $DB->add_column($table, $h) ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		$h = {name => "phone_cache_tm", type => "int", index => 1};
		if ( $DB->add_column($table, $h) ) {
			$ROBJ->message('Internal Error(%s)', $table); 
			$r++;
		}
		# κƹ
		$r += $self->daybook_rebuild($diary_id, $cond_func);
		$c += $self->{success};
	}
	$self->{rebuild} = $c;
	return $r;
}

#------------------------------------------------------------------------------
# 15Version 1.00 RC1 ʹ
#------------------------------------------------------------------------------
sub adiary_upgrade_for_rc1 {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	if (! $auth->{admin}) { $ROBJ->message('Operation not permitted'); return 5; }

	my $daybooks = $DB->select($DAYBOOKLIST_TABLE, {no_error => 1});
	my $r;
	foreach (@$daybooks) {
		my $diary_id = $_->{id};
		# ơ֥ؤѹ
		my $table = "${diary_id}_diary";
		my $h = {name => "priority", type => "int", index => 1};
		if ( $DB->add_column($table, $h) ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		$h = {name => "upnode", type => "int", index => 1};
		if ( $DB->add_column($table, $h) ) {
			$ROBJ->message('Internal Error(%s)', $table); 
			$r++;
		}
		$h = {priority => 0};
		$DB->update_match($table, $h);
		# ȥơ֥ؤѹ
		$table = "${diary_id}_comment";
		$h = {name => "pass", type => "text"};
		if ( $DB->add_column($table, $h) ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		$DB->add_index($table, "hidden");
	}
	if ($r) { return $r; }
	
	# ղþκƹ
	return $self->root_daybooks_info_rebuild();
}

1;
