use strict;
#------------------------------------------------------------------------------
# ܸʸѴ
#						(C)2006-03 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::Jcode;
our $VERSION = '1.10';
#------------------------------------------------------------------------------
# http://homepage2.nifty.com/hobbit/html/jcode.html
# ˤ UTF-8 ѴбưŪѥåŪ˼¹Ԥ롣
#		Windows	Unicode
#		EFBD9E		E3809C
#		EFBC8D		E28892
#		E288A5		E28096
# ϰɽǽ
#		EFBFA2		E080AC
#		EFBFA0		E080A2
#		EFBFA1		E080A2
#
my $EXTRA_UTF8_PATCH   = 1;
my $load_coder;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ

	$self->{EXTRA_UTF8_PATCH} = $EXTRA_UTF8_PATCH;
	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ᥤ롼
###############################################################################
#------------------------------------------------------------------------------
# 
#------------------------------------------------------------------------------
sub init {
	if (defined $load_coder) { return $load_coder; }

	if ($_[0] eq __PACKAGE__ || ref $_[0] eq __PACKAGE__) { shift; }
	my ($op) = shift;
	$load_coder = 0;
	if ($op =~ /jcode/i) {	# Jcode.pm ͥ
		if (&load_Jcode() || &load_encode() ) { return $load_coder; };
	} else {		# Encode.pm ͥ
		if (&load_encode() || &load_Jcode() ) { return $load_coder; };
	}
	# if error, die
	die "Load failed Encode::* and Jcode.pm.";
	return undef;
}

sub load_encode {
	if ($] < 5.008000) { return ; }
	local $SIG{__DIE__} = undef;
	eval {
		require Encode;
		require Encode::Guess; import Encode::Guess qw(euc-jp shiftjis iso-2022-jp);
	};
	if (! $@) { $load_coder = 1; return 1; }
	return ;
}

sub load_Jcode {
	local $SIG{__DIE__} = undef;
	eval { require Jcode; };
	if ($@) { return ; }
	$Jcode::USE_ENCODE = 0;		# Encode.pm Ȥ碌ʤ
	return ($load_coder = 2);
}

#------------------------------------------------------------------------------
# ܸѴ
#------------------------------------------------------------------------------
sub from_to {
	if (!defined $load_coder) { &init(); }

	my $ex_patch = $EXTRA_UTF8_PATCH;
	if (ref($_[0]) eq __PACKAGE__) {
		my $self = shift;
		$ex_patch = $self->{EXTRA_UTF8_PATCH};
	} elsif ($_[0] eq __PACKAGE__) { shift; }
	# main start
	my ($str, $from, $to) = @_;
	if (ref($str) ne 'SCALAR') { my $s=$str; $str=\$s; }
	if ($$str =~ /^[\x00-\x0d\x10-\x1a\x1c-\x7e]*$/
	 || &get_Jcodename($from) eq &get_Jcodename($to) ) { return $$str; }
	# ʸɤ
	if ($from eq '') { $from = &get_codename( $str ); }
	if ($ex_patch && ($from eq '' || $from =~ /UTF.*8/i)) {
		$$str =~ s/\xEF\xBD\x9E/\xE3\x80\x9C/g;	#  EFBD9E E3809C
		$$str =~ s/\xEF\xBC\x8D/\xE2\x88\x92/g;	#  EFBC8D E28892
		$$str =~ s/\xE2\x88\xA5/\xE2\x80\x96/g;	#  E288A5 E28096
	}
	if ($load_coder == 1) {		# Encode
		if ($from =~ /UTF.*8/i) {	# from  UTF8 ΤȤ
			Encode::_utf8_on($$str);
			eval { $$str = Encode::encode($to, $$str); };
		} else {
			eval { Encode::from_to($$str, $from, $to); };
		}
	} elsif ($load_coder == 2) {
		$from = &get_Jcodename($from);
		$to   = &get_Jcodename($to);
		my $s = Jcode->new($str, $from);
		$$str = $s->$to;
	}
	if ($ex_patch && $to =~ /UTF.*8/i) {
		$$str =~ s/\xE3\x80\x9C/\xEF\xBD\x9E/g;	#  E3809C EFBD9E
		$$str =~ s/\xE2\x88\x92/\xEF\xBC\x8D/g;	#  E28892 EFBC8D
		$$str =~ s/\xE2\x80\x96/\xE2\x88\xA5/g;	#  E28096 E288A5
	}
	return $$str;
}

#------------------------------------------------------------------------------
# ʸȽ
#------------------------------------------------------------------------------
my %name2canonical = (euc => 'EUC-JP', sjis => 'Shift_JIS', jis => 'iso-2022-jp', utf8 => 'UTF-8');
sub get_codename {
	if (!defined $load_coder) { &init(); }

	if ($_[0] eq __PACKAGE__ || ref $_[0] eq __PACKAGE__) { shift; }
	my ($str, $from, $to) = @_;
	if (!ref $str) { my $s=$str; $str=\$s; }
	if ($load_coder == 1) {		# Encode
		my $code = Encode::Guess::guess_encoding($$str);
		if (ref $code) { return $code->name(); }
		return 'UTF-8';		# if unknown, return UTF-8(default)
	} elsif ($load_coder == 2) {
		my $code = Jcode::getcode($$str);
		if (exists $name2canonical{$code}) { return $name2canonical{$code}; }
		return $code;
	}
	return ;
}

#------------------------------------------------------------------------------
# ʸȽ
#------------------------------------------------------------------------------
sub get_codename_from_charset {
	if ($_[0] eq __PACKAGE__ || ref $_[0] eq __PACKAGE__) { shift; }
	my $code = &get_Jcodename(@_);
	if (exists $name2canonical{$code}) { return $name2canonical{$code}; }
	return $code;
}

#------------------------------------------------------------------------------
# ܸб substr();
#------------------------------------------------------------------------------
sub jsubstr {
	if (!defined $load_coder) { &init(); }

	if ($_[0] eq __PACKAGE__ || ref $_[0] eq __PACKAGE__) { shift; }
	my $code = shift;
	my ($txt, $start, $len) = @_;
	if ($txt !~ /[\x7f-\xff]/) { return &mysubstr(@_); }

 	if ($load_coder == 1) {		# Encode
 		if ($code =~ /UTF.*8/i) {
			Encode::_utf8_on($txt);
			$txt = &mysubstr($txt, $start, $len);
			Encode::_utf8_off($txt);
		} else {
			my $utf8 = Encode::decode($code, $txt);
			$utf8 = &mysubstr($utf8, $start, $len);
			$txt  = Encode::encode($code, $utf8);
		}
	} elsif ($load_coder == 2) {
		$code = &get_Jcodename($code);
		if ($code ne 'euc') { Jcode::convert(\$txt, 'euc', $code); }	# to, from
		if ($start != 0) { $start = &getbytes_euc_chars($txt, 0, $start); }
		$len = &getbytes_euc_chars($txt, $start, $len);
		$txt = &mysubstr($txt, $start, $len);
		if ($code ne 'euc') { Jcode::convert(\$txt, $code, 'euc'); }	# to, from
	}
	return $txt;
}

#------------------------------------------------------------------------------
# ֥롼Jcode.pm ѡ
#------------------------------------------------------------------------------
sub get_Jcodename {
	my ($code) = @_;
	if ($code =~ /utf.*8/i)   { return 'utf8'; }
	if ($code =~ /euc.*/i)    { return 'euc'; }
	if ($code =~ /shift.*jis/i || $code =~ /sjis/i) { return 'sjis'; }
	if ($code =~ /jis/i)      { return 'jis'; }
	if ($code =~ /2022\-jp/i) { return 'jis'; }
	return ;
}

# ХȤʸΥХȿ
sub mysubstr {
	my ($txt, $start, $len) = @_;
	if (defined $len) { return substr($txt, $start, $len); }
	return substr($txt, $start);
}

# ХȤʸΥХȿ
sub getbytes_euc_chars {
	my ($str, $base, $len) = @_;
	if (!defined $len) { return undef; }
	if ($base+$len < length($str)) { return length($str)-$base; }
	my $p = $base;
	for(my $i=0; $i<$len; $i++) {
		my $x = ord(substr($str, $p, 1));
		if ($x & 0x80) {
			if ($x == 0x8f) { $p+=3; } else { $p+=2; }
		} else { $p++; }
	}
	return ($p - $base);
}


1;
