use strict;
#------------------------------------------------------------------------------
# ƥɸѡSatsukiѡ
#                                                (C)2006-03 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::TextParser::Satsuki;
use Satsuki::AutoLoader;
our $VERSION = '1.32';
#------------------------------------------------------------------------------
my  $TAG_PLUGIN_CLASS = 'TextParser::TagPlugin::Tag_';
our $SEARCH_TAG_CLASS = 'tag ';		# ǸȾѥڡ򣱤
#------------------------------------------------------------------------------
# εĤ
#   1 ʸ
#   2 
# $selfΥϥåͤ򵭽
my %allow_override = (asid => 1, 
 timestamp_date => 1, timestamp_time => 1, timestamp_format => 1,
 anchor_name_base =>1, footnote_name_base => 1, unique_linkname => 1,
 section_count => 2, subsection_count => 2, section_anchor => 1, subsection_anchor => 1,
 section_linkall => 1, subsection_linkall => 1, 
 http_target => 1, image_target => 1, autolink => 2, list_block => 2, 
 br_mode => 1, paragraph_mode => 1);
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);   # $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ} = shift;
	$self->{x}    = {};	# ѿ

	# 
	$self->init_tags();
	foreach(@_) {
		$self->load_tagdata($_, 1);	# 1 = additonal load flag
	}

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ˡΥɥ롼
###############################################################################
#------------------------------------------------------------------------------
# ˡν
#------------------------------------------------------------------------------
sub init_tags {
	my $self = shift;
	$self->{tags}   = {};
	$self->{macros} = {};
}

#------------------------------------------------------------------------------
# ɲå
#------------------------------------------------------------------------------
# ǡ¤
# $tag = $tags{tag_name};
#	$tag{data}   = tag data
#	$tag{argc}   = argments for url data
#	$tag{option} = tag option
# (search only)
#	$tag{name}   = tag name
#	$tag{title}  = title
#	$tag{class}  = html style sheet class
# (alias or html tag)
#	$tag{alias}  = alias to
#	$tag{html}   = html tag
sub load_tagdata {
	my ($self, $data, $flag) = @_;
	my $ROBJ = $self->{ROBJ};
	my $file;
	if (!ref($data)) {
		$file = $data;
		$data = $ROBJ->get_filepath( $data );
		if (!-r $data) { return ; }
		$data = $ROBJ->fread_lines_cached( $data );
	}

	# ߤ
	my $basepath = $ROBJ->{Basepath};
	my $tags   = $self->{tags};
	my $macros = $self->{macros};
	my @load_files;
	while(@$data) {
		my $line = shift(@$data);
		chomp($line);
		if (ord($line) == 0x23) { next; }		# Ƭ'#'ϥ
		#---------------------------------------------------------------
		# ץ饰ɡ
		#---------------------------------------------------------------
		if ($line =~ /^plugin\s+(\w+)/i) {
			eval{ $ROBJ->loadpm("${TAG_PLUGIN_CLASS}$1", $tags); };
			if ($@) { $ROBJ->error('[plugin load failed] %s', $@); }
			next;
		}
		#---------------------------------------------------------------
		# ¾Υե
		#---------------------------------------------------------------
		if ($line =~ /^load\s+([\w\/\.]+)/i) {
			if ($flag) { push(@load_files, $ROBJ->get_relative_path($file, $1)); }
			next;
		}
		#---------------------------------------------------------------
		# ޥ
		#---------------------------------------------------------------
		if ($line =~ /^\*(.+?)\s*$/) {
			my $tag = $1;
			my @ary;
			while (@$data) {
				my $x = shift(@$data);
				if (ord($x) == 0x23) { next; }	# Ƭ # 
				chomp($x);
				if ($x =~ /^\s*$/) { last; }
				unshift(@ary,$x);
			}
			$macros->{$tag} = \@ary;
			next;
		}
		#---------------------------------------------------------------
		# 
		#---------------------------------------------------------------
		if ($line !~ /^(.+?)\s*=\s*(.*?)\s*$/s) { next; }	# '=' ΤʤԤ̵
		my $tag   = $1;
		my $value = $2;
		$tag =~ s/[\"\']//g;
		my @ary = split(':', $tag);
		if ($#ary > 1) {	# : İʾ夢
			my $cmd = shift(@ary); pop(@ary);
			while (@ary) {
				$cmd .= ':' . shift(@ary);
				$tags->{$cmd} ||= {};
			}
		}
		my $tag_hash = $tags->{$tag} ||= {};
		if (substr($value,0,1) eq '>') {	# alias
			$tag_hash->{alias} = substr($value, 1);

		} elsif (substr($value,0,5) eq 'html:') { # HTMLִ
			my $tag = substr($value, 5);
			$tag =~ s/>/&gt;/g;
			$tag =~ s/</&lt;/g;
			($tag_hash->{html}, $tag_hash->{attribute}) = split(/\s+/, $tag, 2);
			if ($tag_hash->{attribute} ne '') {
				$tag_hash->{attribute} = ' ' . $tag_hash->{attribute};
			}
		} else {
			if (substr($value,0,1) eq '<') {	# HTMLִ
				$value = "$tag,ASCII,9," . $value;
			}
			# Ρʥ󥯡˥饹
			my $class = $tag_hash->{name} = $tag;
			if ($class =~ /(.*?)\#(.*)/s) {
				$class = $1;	# "#"μޤ
				if ($2 ne '') { $class .= " $2"; }
			}
			$class =~ s/[^A-Za-z0-9 ]/-/g;
			$tag_hash->{class} = "$SEARCH_TAG_CLASS$class";
			# ȥʤ
			my ($title, $option, $url) = split(/\s*,\s*/, $value, 3);
			$ROBJ->tag_escape( $title, $option );
			if ($url =~ /^(\d+)\s*,\s*(.*)$/) { $tag_hash->{argc}=$1; $url=$2; }	# 
			$url =~ s/\"/&quot;/g;
			if ($title  ne '') { $tag_hash->{title}  = $title;  }
			if ($option ne '') { $tag_hash->{option} = $option; }
			if ($url eq 'block:') {	# blockǤʤСԤФޤɤ߹
				$url = '';
				while(@$data) {
					my $add = shift(@$data);
					chomp($add);
					# $add =~ s/^\s*(.*?)\s*\n?$/$1/;	# ζ
					if ($add eq '') { last; }
					$url .= $add;
				}
			}
			if ($url ne '') {
				my $s1 = substr($url, 0, 1);
				$tag_hash->{data} = $url;
				if (substr($url,0,1) eq '<') {	# HTMLִ
					$tag_hash->{replace_html}=1;
				}
			}
		}
	}
	# ¾Υեɡʥ顼ʤ
	foreach(@load_files) {
		$self->load_tagdata( $_ );
	}
}

#------------------------------------------------------------------------------
# ѿ x ν
#------------------------------------------------------------------------------
sub init_x {
	my $self = shift;
	return ($self->{x} = {});
}


###############################################################################
# ץץå
###############################################################################
#------------------------------------------------------------------------------
# ǡʸˤβù
#------------------------------------------------------------------------------
# *t* λդФˡ
#
sub preprocessor {
	my ($self, $text, $tb_list, $option) = @_;
	if (! ref($text)) { my $x = $text; $text = \$x; }
	# *t* ʤв⤷ʤ
	if ($$text !~ /\*t[\*:]|\[time::/ && (!ref($tb_list) || $$text !~ /\[(?:id|key):.*?\]/))  { return 2; }

	# Ȥ֥å
	my @ary;
	$$text .= "\n";
	$$text  =~ s/(<!--.*?-->|\{.*?\}|(?:\G|\n)>+(?:\[|\|\||\|\w+).*?\n\#?(\]|\|\|)<+\n)/push(@ary, $1), "\n\x01$#ary\x01\n"/esg;
	$$text  =~ s/(\{\{[^\}]*\}\}|\{[^\}]*\})/push(@ary, $1), "\x01$#ary\x01"/eg;

	# ִ
	my $now_tm = $self->{ROBJ}->{TM} || time();
	# time 
	$$text =~ s/\[time::/[time:$now_tm:/g;
	# *t*section
	$$text =~ s/(?:\G|\n)\*(\*?)t([\*\:])/"\n*$1" . ($now_tm++) . $2/eg;
	# $text =~ s/\n\*([^\n]+)/"\n*" . ((index($1,'*')<0) ? (($now_tm++) . '*'):'') . $1/eg;

	# tb list
	if (ref($tb_list)) {
		while($$text =~ m/\[key:([^:\]]+)(?:\:.*?)?\]/g)      { push(@$tb_list, $1); }
		while($$text =~ m/\[id:(\w+):([^:\]]+)(?:\:.*?)?\]/g) { push(@$tb_list, "$1\e$2"); }
	}

	# ᤹
	$$text =~ s/\n\x01(\d+)\x01\n/$ary[$1]/g;
	chop($$text);
	return $$text;
}

###############################################################################
# ᥤ롼
###############################################################################
#------------------------------------------------------------------------------
# ʸ
#------------------------------------------------------------------------------
sub text_parser {
	my ($self, $lines, $opt) = @_;
	if (ref($lines) eq 'ARRAY') {
		foreach(@$lines) { chomp($_); }
	} else {
		$lines = [ split(/\n/, $lines) ];
	}
	$opt ||= {};	# ץ

	# 
	$self->{sections}       = [];	# array
	$self->{subsections}    = {};	# hash / ֹ椴Ȥ˥ǡǼ
	$self->{options}        = {};	# hash
	$self->{replace_data} ||= {};	# ִѥǡ
	$self->{section_count}     = int($opt->{section_count});	# section counter
	$self->{subsection_count}  = int($opt->{subsection_count});	# sub-section counter
	$self->{section_hnum}      = int($opt->{section_hnum}) || 3;	# section level
	$self->{section_linkall}   = int($opt->{section_linkall});
	$self->{subsection_linkall}= int($opt->{subsection_linkall});

	# ѿ
	my %backup;
	while(my ($k,$v) = each(%allow_override)) {
		$backup{$k} = $self->{$k};
	}
	# ˡ̾ʣɽ<a name="">ʣк
	# ɬѿΤȤ˵Ҥ뤳!!
	$self->{unique_linkname} ||= 'k'.($self->{thispkey} || int(rand(0x80000000)));

	# [01]֥åȽ
	$lines = $self->block_parser($lines);

	# [02]tableꥹȤʤɤΥ֥å
	$lines = $self->blocks_and_section($lines);

	# [03]ȼνʹƬޡʤɡ
	$lines = $self->replace_original_tag($lines);

	# [99]
	my $data = join('', @$lines);
	$self->post_process( \$data );

	# ѿ
	while(my ($k,$v) = each(%backup)) { $self->{$k} = $v; }

	# פʸ
	if (! $self->{escape_no_dencode}) {
		# ( ) [ ] { } | * ^ ~: = + - 
		$data =~ s/&#(40|41|91|93|123|125|124|58|42|94|126|61|43|45);/chr($1)/eg;
	}
	return $data;
}

###############################################################################
# [01] ȡ>><<׷ϤΥ֥åȽ
###############################################################################
# ԤΤԤϽλȤߤʤ
sub block_parser {
	my ($self, $lines) = @_;
	my @ary;
	my ($block_end, $block_tag);
	my $p     = 1;	# ͭ⡼ɡ0:Τޤϥ⡼
	my $tag   = 1;	# htmlͭ⡼
	my $atag  = 1;	# adiaryĥͭ⡼
	my $bcom  = 0;	# ֥å楳ͭ⡼
	my $br    = 0;	# <br>⡼
	my $cite;	# blockquote Τդ cite 
	my $macros = $self->{macros};	# ޥ
	my @block_stack;
	my $in_comment = 0;
	while($#$lines >= 0) {
		my $line = shift(@$lines);
		$line =~ s/[\x00-\x03]//g;
		my $line_orig = $line;
		# Ǥ
		if ($in_comment) {
			my $x = index($line, '-->');
			if ($x < 0) { next; }		# ϽϤʤ
			# ȤĤƤ
			$in_comment = 0;
			$line = substr($line, $x +3);	# Ĥ
		}
		#-------------------------------------------------
		# ׵ˡִ
		#-------------------------------------------------
		if ($atag) {	# adiaryĥtagʤĤˡˤͭ
			#  \ ˤϢ
			while(substr($line, -1) eq "\\") {
				chop($line);
				if (substr($line, -1) eq "\\") { #  \\ <br>Ϣ
					chop($line);
					$line .= "<br>";
				}
				$line       =~ s/\s\s*$/$1/;	# \ μΥڡ
				$lines->[0] =~ s/^\s+/ /;	# Ƭڡ
				$line .= shift(@$lines);
			}
			# mini verbatimɽ  {xxx}, {<tag>}, {[xxx:tag]}
			$line =~ s/\\([\{\}])/ "\x01#" . ord($1) . ';'/eg;	# { } Υ
			$line =~ s/\{\{(.*?)\s?\}\}|(\[\[.*?\]\])/
				$2 ? $2 : $self->mini_pre($1) /eg;		# mini pre {{ xxx }}
			$line =~ s/\{(.*?)\s?\}|(\[\[.*?\]\])/
				$2 ? $2 : $self->mini_verbatim($1) /eg;		# mini varbatim {<xxx>}
			$line =~ tr/\x01/&/;	# \x01  & ᤹
			# ޥŸ
			$line =~ s#\[\*toc(?:|:(.*?))\]#<toc>$1</toc>\n#g;
			$line =~ s/\[\*(.*?)\]/ $macros->{$1} && unshift(@$lines, @{ $macros->{$1} }), ''/eg;
		}
		#-------------------------------------------------
		# Ƚ
		#-------------------------------------------------
		if ($tag) {	# ͭ
			$line =~ s/<!--.*?-->//g;		# Ƚ
			my $x = index($line, '<!--');
			if ($x >= 0) {				# Ȥ
				$in_comment = 1;
				$line = substr($line, 0, $x);	# 
			}
		}
		#-------------------------------------------------
		# ֥åˡγϽ
		#-------------------------------------------------
		if ($atag) {	# ˡͭ
			my $new_block_end;
			my $dc;		# ǥեȥ饹
			my $s2 = substr($line, 0, 2);
			my $s3 = substr($line, 0, 3);
			my $s4 = substr($line, 0, 4);
			my $s5 = substr($line, 0, 5);
			# $p		Ԥ
			# $tag		htmlͭ
			# $atag		ˡͭ
			# $bcom		֥å楳on
			if ($s2 eq '>|') {
			  push(@block_stack, [$block_end, $block_tag, $p, $tag, $atag, $bcom, $br, $cite]);
			     if ($s5 eq '>|aa|') { $new_block_end =  '||<'; $block_tag='div'; $p=$tag=$atag=0; $br=1; $dc="ascii-art"; }
					# extended super pre by http://d.hatena.ne.jp/hatenadiary/20061215/1166155734
			  elsif ($line =~ /^>\|(\w+)\|/) { $new_block_end = '||<'; $block_tag='pre'; $p=$tag=$atag=0; $dc="syntax-highlight"; }
			  elsif ($s4 eq '>||#')  { $new_block_end = '#||<'; $block_tag='pre'; $p=$tag=$atag=0; $bcom=1; }
			  elsif ($s3 eq '>||')   { $new_block_end =  '||<'; $block_tag='pre'; $p=$tag=$atag=0; }
			  elsif ($s2 eq '>|')    { $new_block_end =   '|<'; $block_tag='pre'; $p=0; }
			} elsif ($s3 eq '>>>') {
			  push(@block_stack, [$block_end, $block_tag, $p, $tag, $atag, $bcom, $br, $cite]);
			     if ($s5 eq '>>>||') { $new_block_end ='||<<<'; $block_tag='div'; $p=$tag=$atag=0; }
			  elsif ($s4 eq '>>><')  { $new_block_end = '><<<'; $block_tag='div'; $p=$tag =0; }
			  elsif ($s4 eq '>>>[')  { $new_block_end = ']<<<'; $block_tag='div'; $p=$atag=0; }
			  elsif ($s4 eq '>>>|')  { $new_block_end = '|<<<'; $block_tag='div'; $p=0; }
			  elsif ($s3 eq '>>>')   { $new_block_end =  '<<<'; $block_tag='div'; }

			} elsif ($s2 eq '>>') {
			  push(@block_stack, [$block_end, $block_tag, $p, $tag, $atag, $bcom, $br, $cite]);
			     if ($s4 eq '>>||')  { $new_block_end = '||<<'; $block_tag='blockquote'; $p=$tag=$atag=0; }
			  elsif ($s3 eq '>>|')   { $new_block_end =  '|<<'; $block_tag='blockquote'; $p=0; }
			  elsif ($s2 eq '>>')    { $new_block_end =   '<<'; $block_tag='blockquote'; }
			}
			# \x01 ǥȡ[]޻ߥޡ
			if ($new_block_end) {
				$block_end = $new_block_end;
				$cite="";
				my $class  = $dc || substr($line, length($block_end));
				my $add_attri;
				# $class =~ s/[^\w\-]//g;	# 饹ʸ󤫤
				if ($block_tag eq 'blockquote') {
					if ($class =~ m|^(\[(https?://[^:\"\]]*)[^\]]*\])(.*)|) {	# ꡩ
						$add_attri = " cite=\"$2\"";
						$cite  = "<cite>$1</cite>";
						$class = $3;
					} elsif ($class =~ m!^(\[(key|this|id):[^\]]*\])(.*)!) {
						$cite  = "<cite>$1</cite>";
						$class = $2;
					}
				}
				if (!$dc && $class =~ /[^\w\- ]/) {	# ϥȤǧʤ
					# $p=$tag=$atag= 1; $bcom=0;
					# $block_end = undef;
					# push(@ary, $line);
					($block_end, $block_tag, $p, $tag, $atag, $bcom, $br, $cite) = @{ pop(@block_stack)};
				} else {
					my $c = lc($class);
					if ($block_tag eq 'div' && ($c eq 'ins' || $c eq 'del')) {
						$block_tag = $class;
						$class     = '';
					} elsif ($class ne '') {	# 饹
						$class = " class=\"$class\"";
					}
					if ($block_tag eq 'pre') { push(@ary, "<pre$add_attri$class>\n\x01"); } else { push(@ary, "<$block_tag$add_attri$class>\n"); }
					next;
				}
			}
		}
		#-------------------------------------------------
		# ֥åν
		#-------------------------------------------------
		if ($block_end) {
			# ֥åν
			if ($line eq $block_end) {
				if ($p) { push(@ary, "$cite</$block_tag>\n"); } else { push(@ary, "$cite</$block_tag>\n\x01"); }
				# $p=$tag=$atag= 1; $bcom=0;
				# $block_end = undef;
				($block_end, $block_tag, $p, $tag, $atag, $bcom, $br, $cite) = @{ pop(@block_stack)};
				next;
			}
			# HTML̵֥å
			if (! $tag) {	# html[]̵֥åͭ
				$line =~ s/&/&amp;/g;
				$line =~ s/</&lt;/g;
				$line =~ s/>/&gt;/g;
			}
			# ֥å楳ȵǽ
			if ($bcom) {
				$line =~ s/##(\{(.+?)\}|\[(.+?)\]|\|(.+?)\|)/<strong class="comment">$2$3$4<\/strong>/g;
				$line =~  s/#(\{(.+?)\}|\[(.+?)\]|\|(.+?)\|)/<span class="comment">$2$3$4<\/span>/g;
			}
			# [tag] ΤĤˡ̵
			if (! $atag && $bcom) {			# (()) ͭˤ롧֥å楳ȵǽ
				$line =~ s/([\[\]\{\}\|:])/'&#' . ord($1) . ';'/eg;
				$line =~ s/^([\-\+\*=])/   '&#' . ord($1) . ';'/eg;
			} elsif (! $atag) {
				$line =~ s/([\[\]\{\}\|:\(\)])/'&#' . ord($1) . ';'/eg;
				$line =~ s/^([\-\+\*=])/       '&#' . ord($1) . ';'/eg;
			} else {
				$line =~ s/^====/&#61;===/;	# ֥å³ɤɽ̵
			}
			# ԥ⡼
			if ($br) {
				$line .= "<br>";
			}
			# ʤ⡼
			if (! $p) {
				push(@ary, "$line\n\x01");	# \x01 ǥ/ˡ޻ߥޡ
				next;
			}

		}
		#-------------------------------------------------
		# Խ
		#-------------------------------------------------
		if ($line eq '') {
			if ($line_orig ne '') { next; }
			my $c = 1;
			while($#$lines >= 0) {
				if ($lines->[0] ne '') { last; }
				shift(@$lines);
				$c++;
			}
			push(@ary, {null_lines => $c});
			next;
		}
		#-------------------------------------------------
		# ̾
		#-------------------------------------------------
		push(@ary, $line);
	}
	# block äƤʤȤ
	if ($block_end) {
		if ($block_tag eq 'pre') { push(@ary, "</pre>\n\x01"); } else { push(@ary, "</$block_tag>\n"); }
	}

	return \@ary;
}

#--------------------------------------------------------------------
# ߥ verbatim ˡ
#--------------------------------------------------------------------
sub mini_verbatim {
	my ($self, $line) = @_;
	$self->tag_syntax_escape($line);	# tag
	return $line;
}

#--------------------------------------------------------------------
# ߥ pre ˡ
#--------------------------------------------------------------------
sub mini_pre {
	my ($self, $line) = @_;
	$self->tag_syntax_escape($line);	# tag
	return "<span class=\"mono\">$line</span>";
}

###############################################################################
# [02] table/ꥹȤΥ֥å
###############################################################################
# ԤΤԤϽλȤߤʤ
my %marks;
$marks{'*'}     = \&section;
$marks{'**'}    = \&subsection;
$marks{'***'}   = \&subsubsection;
$marks{'|'}     = \&table;
$marks{'='}     = \&dummy;
$marks{'=='}    = \&dummy;
$marks{'==='}   = \&dummy;
$marks{'===='}  = \&more_read;
$marks{'====='} = \&super_more_read;

sub blocks_and_section {
	my ($self, $lines) = @_;
	my $ROBJ = $self->{ROBJ};
	my @ary;
	my $class;

	# ѿ
	$self->{more_read}        = 0;
	$self->{in_section}       = 0;
	$self->{now_anchor_name}  = "$self->{unique_linkname}p0";	# default
	$self->{tr_count}         = 0;
	$self->{table_rows}       = undef;	# table buffer

	# ƬФǤʤ硢section 򳫻Ϥ
	my $top = $lines->[0];
	if (ref($top)) { shift(@$lines); $top=$lines->[0]; }	# Ƭ̵
	if (substr($top, 0, 1) ne '*' || substr($top, 0, 2) eq '**') {
		$self->{in_section} = 1;
		if (!$self->{no_div_section}) { push(@ary, "<div class=\"section\">\n"); }
	}

	my $in_table;
	push(@$lines, "\n");	# dummy line
	while($#$lines >= 0) {
		my $line = shift(@$lines);
		# $s1-$s3 Ƭ 1byte-3byte
		my $s1 = substr($line, 0, 1);
		my $s2 = substr($line, 0, 2);
		my $s3 = substr($line, 0, 3);
		#-------------------------------------------------
		# ơ֥νϡ
		#-------------------------------------------------
		if ($in_table && $s1 ne '|') {
			$self->table_output( \@ary, $class );
			$class='';
			$in_table = undef;
		}
		#-------------------------------------------------
		# Ѥ߹ԤФ
		#-------------------------------------------------
		my $end_mark = substr($line, -1);		# \n/\x01 ǽԤϽѤ
		if (ref($line) || $end_mark eq "\n" || $end_mark eq "\x01") {
			push(@ary, $line);
			next;
		}

		#-------------------------------------------------
		# table/list֥åȽ
		#-------------------------------------------------
		# ѿ국ˡ
		if ($s3 eq ':::') {
			$line = substr($line, 3);
			if ($line =~ /(\w+)(\.\w+)?\s*=\s*(\"[^\"]*\"|.*)/) {
				if ($2 ne '') {
					$self->{x}->{$1}->{$2}=$3;
				} else {
					$self->{x}->{$1}=$3;
				}
			}
			next;
		# 饹ɽ
		} elsif ($s2 eq '::' && length($line)>2) {
			$class = substr($line, 2);
			if ($class =~ /^(\w+)\s*=\s*(.*)/) {
				# Ūͽ񤭴
				if ($allow_override{$1}==1) {
					$self->{$1}=$2;
					$ROBJ->tag_escape( $self->{$1} );
				} elsif ($allow_override{$1}==2) {
					$self->{$1}=int($2);
				}
				$class='';
				next;
			}
			$class =~ s/[^\w\- ]//g;
			$class = " class=\"$class\"";
			next;
		}
		if ($s1 eq ':') {	# : Υꥹɽ
			push(@ary, "<dl$class>\n"); $class='';
			my $list_block = $self->{list_block};	# ꥹȤ֥åǽ
			if ($line eq '::') {
				$list_block=1;
			} else {
				unshift(@$lines, $line);
			}
			while(@$lines && ord($lines->[0]) == 0x3a) {
				$line = shift(@$lines);
				my @add;
				if ($list_block) {
					my $block_c=0;
					while(@$lines) {
						my $x = $lines->[0];
						if (ref($x) || ord($x) == 0x3a) { last; }
						# ֥åǡбå
						if ($x =~ m[^\t*</(?:blockquote|div|pre)>[\n\x01]$]) {
							$block_c--;if ($block_c<0) { last; }
						} elsif ($x =~ m[^\t*<(?:blockquote|div|pre)[^>]*>[\n\x01]$]) {
							$block_c++;
						}
						push(@add, shift(@$lines));
					}
				}
				my ($dummy, $dt, $dd) = split(':', $line, 3);
				if (@add) {
					my $br; if ($self->{br_mode}) { $br='<br>'; }
					push(@ary, "\t<dt>$dt</dt><dd>$dd$br\n", @add, "\t</dd>\n");
				} else {
					push(@ary, "\t<dt>$dt</dt><dd>$dd</dd>\n");
				}
				# ꥹȹܸζԣԤ̵
				if ($list_block && ref($lines->[0]) && $lines->[0]->{null_lines}==1) { shift(@$lines); }
			}
			push(@ary, "</dl>\n");
			next;
		}
		if ($s1 eq '+' || $s1 eq '-') {   # -/+ Υꥹɽ
			my $list_block = $self->{list_block};	# ꥹȤ֥åǽ
			if (length($line)==1) { $list_block=1; } 
					else  { unshift(@$lines, $line); }
			$self->split_list_block(\@ary, $lines, 1, $class, $list_block);
			next;
		}
		if (!$in_table && $s1 eq '|') {	# | Υơ֥ɽ
			$in_table = 1;
		}
		#-------------------------------------------------
		# ³ɤȽ
		#-------------------------------------------------
		my $mark = substr($line, 0, 1);
		if (exists $marks{$mark}) {
			for(my $i=2; $i<6 ;$i++) {
				my $x = substr($line, 0, $i);
				if (! exists $marks{$x}) { last; }
				$mark = $x;
			}
			my $rewrite = &{ $marks{$mark} }($self, $line);
 			if (!defined $rewrite) { next; }
			if (ref($rewrite)) {  push(@ary, @$rewrite); } else { push(@ary, $rewrite); }
			next;
		}
		# Ƭ - * μȾѥڡ֤׽б
		if (ord($line) == 0x20 && index(' - + * | : = > < #', substr($line, 0, 2)) > 0) {
			push(@ary, substr($line, 1));
			next;
		}
		#-------------------------------------------------
		# ̾
		#-------------------------------------------------
		push(@ary, $line);
	}
	if ($self->{in_section}) { push(@ary, {section_end => 1}); }	# section֤ޡ
	if ($self->{more_read})  { push(@ary, "<!--%more-->\n"); }
	if (!$self->{no_div_section}) { push(@ary, "</div>\n"); }	# section λ

	# 󥿥ȥΥν
	foreach(@{ $self->{sections} }) {
		$_->{title} = $self->parse_tag( $_->{title} );	# 
		$_->{title} =~ s/\(\(.*?\)\)//g;		# κ
		my $subs = $self->{subsections}->{ $_->{section_count} };
		if ($subs) {
			foreach(@$subs) {
				$_->{title} = $self->parse_tag( $_->{title} );	# 
				$_->{title} =~ s/\(\(.*?\)\)//g;		# κ
			}
		}
	}
	return \@ary;
}

#--------------------------------------------------
# ꥹȥ֥å
#--------------------------------------------------
sub split_list_block {
	my ($self, $ary, $lines, $depth, $class, $list_block) = @_;
	my $tag = 'ul';
	my $indent = "\t" x ($depth-1);
	if (substr($lines->[0], 0, 1) eq '+') { $tag='ol'; }
	push(@$ary, "$indent<$tag$class>\n");
	my $next_line;
	while(@$lines) {
		if (ref($lines->[0]) || $lines->[0] !~ /^([\+\-]+)(.*)/) { last; }
		my $length = length($1);
		my $data   = $2;
		if ($length < $depth) { last; }
		if ($length > $depth) {
			if ($next_line) {
				if ($next_line !~ /^\t*$/) { push(@$ary, "$next_line\n"); }
				$next_line='';
				$self->split_list_block($ary, $lines, $depth+1, '', $list_block);
				push(@$ary, "$indent\t</li>\n");
				next;
			}
			$self->split_list_block($ary, $lines, $depth+1, '', $list_block);
			next;
		}
		shift(@$lines);
		if ($next_line) { push(@$ary, "$next_line</li>\n"); }
		if ($data =~ /^=(\d+)(?:\s+(.*))?/) {	# ͻ
			$next_line = "$indent\t<li value=\"$1\">$2";
		} else {
			$next_line = "$indent\t<li>$data";
		}
		# ꥹȤ֥å
		if ($list_block) {
			my $f=1;
			my $block_c=0;
			while(@$lines) {
				my $x = $lines->[0];
				if (ref($x) || $x =~ /^[\+\-]/) { last; }
				# ֥åǡбå
				if ($x =~ m[^\t*</(?:blockquote|div|pre)>[\n\x01]$]) {
					$block_c--;if ($block_c<0) { last; }
				} elsif ($x =~ m[^\t*<(?:blockquote|div|pre)[^>]*>[\n\x01]$]) {
					$block_c++;
				}
				if ($f) {
					my $br; if ($self->{br_mode}) { $br='<br>'; }
					push(@$ary, "$next_line$br\n");		# ֥å국
					$next_line="$indent\t"; $f=0
				}
				push(@$ary, shift(@$lines));
			}
			# ꥹȹܸζԣԤ̵
			if (ref($lines->[0]) && $lines->[0]->{null_lines}==1) { shift(@$lines); }
		}
	}
	if ($next_line) { push(@$ary, "$next_line</li>\n"); }
	push(@$ary, "$indent</$tag>\n");
}

#------------------------------------------------------------------------------
# ˡ롼
#------------------------------------------------------------------------------
#--------------------------------------------------------------------
# ߡʲ⤻Τޤޡ
#--------------------------------------------------------------------
sub dummy {
	return $_[1];
}

#--------------------------------------------------------------------
# *section_title
#--------------------------------------------------------------------
sub section {
	my ($self, $line) = @_;
	my @ary;
	# section֤ޡ
	if ($self->{in_section}) { push(@ary, {section_end => 1}); }

	# ³ɤߤ
	if ($self->{stop_h3_more_read}) {
		push(@ary, "<!--%more-->\n");
		$self->{stop_h3_more_read} = $self->{more_read} = 0;
	}
	# section ν
	if ($self->{in_section} && !$self->{no_div_section}) { push(@ary, "</div>\n"); }

	# section γ
	if ($self->{in_section}) { push(@ary, "\n"); }
	if (!$self->{no_div_section}) { push(@ary, "<div class=\"section\">\n"); }
	$self->{in_section} = 1;

	# 󥫥󥿤ν
	my $sec_count = $self->{section_count} += 1;
	$self->{subsection_count} = 0;

	# Фν
	$line = substr($line, 1);
	my $anchor    = $self->{section_anchor};
	my $name_base = $self->{anchor_name_base} || "$self->{unique_linkname}p";
	my $name      = $name_base . $sec_count;
	if ($line =~ /^([\w\-\d]+)(:[^\*]+)?\*(.*)/s) {
		$name = $1;
		$line = $3;
		my $force_format = substr($2,1) || $self->{timestamp_format};
		if ($name > 100000000) {	# ﵭˡ
			my $ROBJ = $self->{ROBJ};
			my $format = $self->{timestamp_time} || '%J:%M';
			my $h = $ROBJ->time2timehash( $name );
			if ($h->{day} != $self->{thisday} || $h->{mon} != $self->{thismon} || $h->{year} != $self->{thisyear}) {
				$format = $self->{timestamp_date} || '%Y/%m/%d';
			}
			$format = $force_format || $format;	# timestamp_format  override
			$line .= ' <span class="timestamp">'
				. $self->{ROBJ}->tm_printf($format, $name) . '</span>';
		}
	}
	# [ƥ]ɽؤб
	$line =~ s/(?:^|\G)\[([^:]+?)\]/[sectioncategory:$1]/g;

	$anchor =~ s/%n/$sec_count/g;
	$self->{now_anchor_name} = $name;
	# ¸
	push(@{ $self->{sections} }, {name => $name, title => $line, anchor => $anchor, section_count => $sec_count});

	my $hnum = $self->{section_hnum};
	if ($anchor && !$self->{section_linkall}) {		# 󥫡Τߥ
		push(@ary, "<h$hnum><a href=\"$self->{thisurl}#$name\" name=\"$name\"><span class=\"sanchor\">$anchor</span></a>$line</h$hnum>\n");
	} else {
		push(@ary, "<h$hnum><a href=\"$self->{thisurl}#$name\" name=\"$name\" class=\"linkall\"><span class=\"sanchor\">$anchor</span>$line</a></h$hnum>\n");
	}
	return \@ary;
}
#--------------------------------------------------------------------
# **subsection_title
#--------------------------------------------------------------------
sub subsection {
	my ($self, $line) = @_;
	$line =~ /^(\*+)/;
	my $level = length($1) +2;
	$line = substr($line, $level-2);

	# 󥫥
	my $sec_count    = $self->{section_count};
	my $subsec_count = $self->{subsection_count} += 1;
	my $anchor = $self->{subsection_anchor};
	my $name   = $self->{now_anchor_name};
	$name .= '.' . $subsec_count;
	$anchor =~ s/%n/$sec_count/g;
	$anchor =~ s/%s/$subsec_count/g;
	if ($line =~ /^([\w\-\d]+)(:[^\*]+)?\*(.*)/s) {
		$name = $1;
		$line = $3;
		my $force_format = substr($2,1) || $self->{timestamp_format};
		if ($name > 100000000) {	# ﵭˡ
			my $ROBJ = $self->{ROBJ};
			my $format = $self->{timestamp_time} || '%J:%M';
			my $h = $ROBJ->time2timehash( $name );
			if ($h->{day} != $self->{thisday} || $h->{mon} != $self->{thismon} || $h->{year} != $self->{thisyear}) {
				$format = $self->{timestamp_date} || '%Y/%m/%d';
			}
			$format = $force_format || $format;	# timestamp_format  override
			$line .= ' <span class="timestamp">'
				. $self->{ROBJ}->tm_printf($format, $name) . '</span>';
		}
	}
	# ¸
	my $subsections = $self->{subsections}->{$sec_count} ||= [];
	push(@$subsections, {name => $name, title => $line, anchor => $anchor, section_count => $sec_count, subsection_count => $subsec_count});

	my $hnum = $self->{section_hnum} +1;
	if ($anchor && !$self->{subsection_linkall}) {		# 󥫡Τߥ
		return "<h$hnum><a href=\"$self->{thisurl}#$name\" name=\"$name\"><span class=\"sanchor\">$anchor</span></a>$line</h$hnum>\n";
	}
	return  "<h$hnum><a href=\"$self->{thisurl}#$name\" name=\"$name\" class=\"linkall\"><span class=\"sanchor\">$anchor</span>$line</a></h$hnum>\n";
}

#--------------------------------------------------------------------
# ***subsubsection_title
#--------------------------------------------------------------------
sub subsubsection {
	my ($self, $line) = @_;
	$line =~ /^\*(\*+)(.*)/s;
	my $level = length($1) + $self->{section_hnum};
	return "<h$level>$2</h$level>\n";
}

#--------------------------------------------------------------------
# tableˡ- |name|data
#--------------------------------------------------------------------
sub table {
	my ($self, $line) = @_;
	# caption
	if ($self->{table_rows}) {	# table˵Һ
		# ⤷ʤ
	} elsif (substr($line,0,9) eq '|caption=') {
		$self->{table_caption} = substr($line,9);
		return;
	} elsif (substr($line,0,9) eq '|summary=') {
		$self->{table_summary} = substr($line,9);
		return;
	} elsif (substr($line,0,2) eq '|=') {
		$self->{table_summary} = $self->{table_caption} = substr($line,2);
		return;
	}

	# table ⥯饹
	if (substr($line,0,3) eq '|::') {
		my $class = substr($line,3);
		$class =~ s/[^\w\-\| ]//g;
		# th, td 饹
		if (substr($class,0,1) eq '|') {
			my @ary = split(/\s*\|\s*/, $class);
			shift(@ary);	# ɤ߼Τ
			$self->{td_classes} = \@ary;
			return;
		}
		# tr饹
		$self->{tr_class} = " $class";
		return undef;
	}


	# table 1 ROW κ
	my $rows = $self->{table_rows} ||= [];
	my @cols;

	my @ary = split(/\s*\|\s*/, $line);
	shift(@ary);	# ǽɤ߼Τ
	if ($ary[$#ary] =~ /^\s*$/) { pop(@ary); }
	$line = '';
	my $td_classes = $self->{td_classes} || [];
	my @td_class_ary = @{ $td_classes };
	foreach(0..$#ary) {
		my $x = $ary[$_];
		my $h = {cols=>1, rows=>1};
		$h->{class} = shift( @td_class_ary );
		if (substr($x,0,1) eq '*') {
			$h->{th}   = 1;
			$h->{data} = substr($x,1);
		} elsif ($x eq '<' && $#cols >= 0) {	# Ϣ
			$h = $cols[$#cols];
			$h->{cols} ++; 
		} elsif (($x eq '~' || $x eq '^') && $#$rows >= 0 && $_ < $#{ $rows->[$#$rows]}) {	# Ϣ
			$h = $rows->[$#$rows]->[$_];
			$h->{rows} ++;
		} else {
			$h->{data} = $x;
		}
		push(@cols, $h);
	}
	if ($#cols > 0) {
		foreach(reverse(0..($#cols-1))) {
			if ($cols[$_]->{data} eq '>') {	# Ϣ
				$cols[$_] = $cols[$_+1];
				$cols[$_]->{cols} ++;
			}
		}
	}

	# tr饹
	my $class    = 'even';
	my $tr_count = ++ $self->{tr_count};
	if ($tr_count & 1) { $class='odd'; }
	$class .= $self->{tr_class};
	$self->{tr_class} = undef;
	push(@cols, $class);
	push(@$rows, \@cols);
	return undef;
	# return "\t<tr class=\"$class\">$line</tr>\n";
}

#---------------------------
# ơ֥ν
#---------------------------
sub table_output {
	my ($self, $out, $class) = @_;
	my $ROBJ = $self->{ROBJ};
	my $rows = $self->{table_rows};
	my $summary = $self->{table_summary};
	my $caption = $self->{table_caption};
	$self->{table_rows} = $self->{tr_class} = $self->{td_classes} = undef;
	$self->{table_summary} = $self->{table_caption} = undef;
	$self->{tr_count} = 0;
	if (!defined $rows) { return ; }

	# Ϣ롩
	foreach my $row_num (reverse(0..($#$rows-1))) {
		my $cols = $rows->[$row_num];
		foreach(0..($#$cols-1)) {
			my $h = $cols->[$_];
			if ($h->{data} eq '_' && ref($rows->[$row_num+1]->[$_])) {
				$h = $rows->[$row_num]->[$_] = $rows->[$row_num+1]->[$_];
				$h->{rows}++;
			}
		}
	}

	# caption & summary
	$self->tag_syntax_escape($summary);		# ˡ escape
	$ROBJ->tag_escape($caption);
	if ($summary ne '') { $summary=" summary=\"$summary\""; }
	# 
	push(@$out, "<table$class$summary>\n");
	if ($caption ne '') { push(@$out, "<caption>$caption</caption>\n"); }
	push(@$out, "<tbody>\n");
	while(@$rows) {
		my $cols = shift(@$rows);
		my $tr_class = pop(@$cols);
		my $line;
		foreach(0..$#$cols) {
			my $h = $cols->[$_];
			if ($h->{output}) { next; }	# ٽϤΤϽϤʤ
			# 
			$h->{output} = 1;
			my $at;
			if ($h->{cols} >1) { $at .= " colspan=\"$h->{cols}\""; }
			if ($h->{rows} >1) { $at .= " rowspan=\"$h->{rows}\""; }
			if ($h->{class})   { $at .= " class=\"$h->{class}\"";  }
			if ($h->{th}) {
				$line .= "<th$at>$h->{data}</th>";
			} else {
				$line .= "<td$at>$h->{data}</td>";
			}
		}
		push(@$out, "\t<tr class=\"$tr_class\">$line</tr>\n");
	}
	push(@$out, "</tbody></table>\n");
}


#--------------------------------------------------------------------
# ³ɤ - ====
#--------------------------------------------------------------------
sub more_read {
	my ($self, $line) = @_;
	if ($self->{more_read}) { return ; }
	$self->{more_read}         = 1;
	$self->{stop_h3_more_read} = 1;
	my $seemore_msg = $self->{seemore_msg} || '³ɤ';
	my $seemore_anchor = ($self->{now_anchor_name} ne '') ? ('#'.$self->{now_anchor_name}):'';
	return <<HTML;
<!--%msg-->$self->{indent}<p class="seemore"><a class="seemore" href="$self->{thisurl}$seemore_anchor">$self->{seemore_msg}</a></p><!--%msg--><!--%more-->
HTML
}

#--------------------------------------------------------------------
# ³ɤʴάˡ - =====
#--------------------------------------------------------------------
sub super_more_read {
	my ($self, $line) = @_;
	if ($self->{more_read}) { return ; }
	$self->{more_read} = 1;
	my $seemore_msg = $self->{seemore_msg} || '³ɤ';
	return <<HTML;
<!--%msg-->$self->{indent}<p class="seemore"><a class="seemore" href="$self->{thisurl}#$self->{now_anchor_name}">$self->{seemore_msg}</a></p><!--%msg--><!--%more-->
HTML
}

###############################################################################
# [03] ȼִ
###############################################################################
sub replace_original_tag {
	my ($self, $lines) = @_;

	my $br_mode  = $self->{br_mode};
	my $p_mode   = $self->{paragraph_mode};
	my $p_class  = $self->{paragraph_class};
	my $ls_mode  = $self->{ls_mode};		# Դֽ⡼
	my $indent   = $self->{indent};
	my $autolink = $self->{autolink};
	$self->{footnote_no} = 0;

	# p class
	$p_class =~ s/[^\w\-]//g;
	if ($p_class ne '') { $p_class = " class=\"$p_class\""; }

	# 
	my ($prev, $next, $this, $prev_f, $this_f, $next_f);
	push(@$lines, "\x01");

	my @ary;
	my @footnote;
	$self->{footnote} = \@footnote;
	$self->{note_buf} = {};
	my $in_paragraph  = 0;
	foreach(@$lines) {
		# 
		$prev = $this; $prev_f = $this_f;
		$this = $next; $this_f = $next_f;
		$next = $_;    $next_f = 0;
		my $f = substr($_,-1);
		if ($f eq "\x01") { $next_f= 1; chop($next); }	# ǥ޻
		if ($f eq "\n")   { $next_f=10;  }
		if (ref($_))      { $next_f=256; }
		if (!defined $this) { next; }

		# Τɤ餫ޥ
		my $flag = $prev_f + $next_f;

		# Section(H3) ν
		if (ref($this) && $this->{section_end}) {
			$self->output_footnote(\@ary, \@footnote);
			@footnote = ();
			next;
		}
		# ԡ
		if (ref($this)) {
			my $null_lines = $this->{null_lines};
			if (! $ls_mode) {	# Դֽ򤷤ʤ⡼
				push(@ary, "$indent\n" x $null_lines);
				next;
			}
			if ($flag || $p_mode) { $null_lines--; } 
			push(@ary, "$indent<br>\n" x $null_lines);
			next;
		}

		# autolink
		if ($autolink && $this =~ /https?:|ftp:/) {
			my @ary;
			$this =~ s/(<\w(?:[^>"']|[=\s]".*?\"|[=\s]'.*?')*?>)/push(@ary, $1), "\x03$#ary\x03"/esg;
			$this =~ s!(\G|\n|[^\"\[])(https?|ftp):(//[\w\./\#\@\?\&\~\=\+\-%\[\]:;,\!*]+)!
					my $x="$1\[$2:"; my $y=$3;
					$y =~ s/([\[\]:])/"&#" . ord($1) . ';'/eg;
					"$x$y]";
				!eg;
			$this =~ s/\x03(\d+)\x03/$ary[$1]/sg;
		}
		# 
		$this = $self->parse_tag( $this );
		#  ((xxxx))
		$this =~ s/\(\((.*?)\)\)/ $self->footnote($1) /eg;

		# ˡ֤ǹԤˤʤä
		if ($this eq '') { next; }

		# 
		if ($this_f==1) { push(@ary, $this);          next; } # ǥȤʤ
		if ($this_f)    { push(@ary, "$indent$this"); next; } # Ѥ߹ԤϥǥȤΤ
		if ($p_mode==1) { push(@ary, "$indent<p$p_class>$this</p>\n"); next; } # ԡᣱ
		if (! $p_mode)  {	# ʤ
			if ($br_mode) { push(@ary, "$indent$this<br>\n"); }    # Խ
				else  { push(@ary, "$indent$this\n");     }
			next;
		}
		if ($p_mode==2) {	# Ԥ
			my $head = '';
			if (! $in_paragraph) { $head="$indent<p$p_class>"; $in_paragraph=1; } # λϤޤ 
			elsif ($br_mode)     { $head="$indent";   }                           # Խ⡼
			push(@ary, "$head$this");
			if ($next_f) {		# ν
				push(@ary, "</p>\n");
				$in_paragraph=0;
				next;
			}
			if ($br_mode) { push(@ary, "<br>\n"); }	# Խ
			next;
		}
	}
	# ϡʥǽϤΤס
	# $self->output_footnote(\@ary, \@footnote);

	return \@ary;
}

#--------------------------------------------------------------------
# ΥѡȽ
#--------------------------------------------------------------------
sub parse_tag {
	my $self = shift;
	my $this = shift;

	# [[keyword]] ɽ  ϤƤkeywordɽѴ
	$this =~ s/\[\[([^:]*?)\]\]/\[keyword:$1\]/g;
	# [&icon-name]  [icon:icon-name]
	$this =~ s/\[&(.*?)\]/\[icon:$1\]/g;

	# ˡν
	my $count=100;
	# [[ ]] Խ
	$this =~ s/\[\[/\x01/g;
	$this =~ s/\]\]/\x02/g;
	while ($count>0 && $this =~ /(.*?)\x01([^\x01]+)\s?\x02(.*)/) {
		my $p0 = $1;	# tag
		my $p1 = $3;	# tag
		$this = $self->special_command( $2, 1 );
		$this =~ s/\[/&#91;/g;
		$this =~ s/:/&#58;/g;
		$this = $p0 . $this . $p1;
		$count--;
	}
	$this =~ s/\x01/\[\[/g;
	$this =~ s/\x02/\]\]/g;
	# [ ] 
	while ($count>0 && $this =~ /(.*?)\[([^\[\]]+)\](.*)/) {
		my $p0 = $1;	# tag
		my $p1 = $3;	# tag
		$this = $self->special_command( $2 );
		$this =~ s/\[/&#91;/g;
		$this =~ s/:/&#58;/g;
		$this = $p0 . $this . $p1;
		$count--;
	}
	return $this;
}

#--------------------------------------------------------------------
# ޥɤν
#--------------------------------------------------------------------
sub special_command {
	my $self      = shift;
	my $cmd_line  = shift;
	my $verb_flag = shift;
	my $tags    = $self->{tags};

	$cmd_line =~ s/\\:/\x01/g;
	my @cmd = map { s/\x01/:/g; $_ } split(':', $cmd_line);
	my $cmd = shift(@cmd);
	while (exists $tags->{ "$cmd:$cmd[0]" } && @cmd) {	# Ϣ륳ޥ
		$cmd = $cmd . ':' . shift(@cmd);
	}
	if ($verb_flag) {	# [[ ]] ĶǤ : 򤽤Τޤ޽񤱤
		my $str = join(':', @cmd);
		@cmd = ($str);
	}
	if (exists $tags->{ $cmd }) {
		my $tag = $tags->{ $cmd };
		# alias 
		my $real_cmd = $cmd;
		if ($tag->{alias}) {
			$real_cmd = $tag->{alias};
			$tag      = $tags->{ $real_cmd };
		}
		# ꤢꡩ
		my $arg_cmd = $real_cmd . '##' . ($#cmd +1);
		if (exists $tags->{ $arg_cmd }) {
			$tag = $tags->{ $arg_cmd };
		} else {
			my $x = $#cmd + 1;
			if (! $tag->{html}) {	# ASCII 
				$x=0;
				foreach(@cmd) {
					if ($_ =~ /[\x80-\xff]/ || $_ eq 'title') { last }
					$x++;
				}
			}
			my $arg_cmd = $real_cmd . '#' . $x;
			if (exists $tags->{ $arg_cmd }) { $tag = $tags->{ $arg_cmd }; }
		}

		# ִƤӽФ
		my $data   = $tag->{data};
		my $option = $tags->{"=$tag->{option}"};	# ü쥪ץ

		if (ref($option)) {	# ü쥪ץˤִ
			return &$option($self, $tag, $cmd, \@cmd);
		} elsif (ref($data)) {	# CODE ref ΤȤϻѥ롼󥳡
			return &$data($self, $tag, $cmd, \@cmd);
		} elsif($tag->{html}) {	# HTMLִ
			return $self->html_tag($tag, \@cmd);
		} elsif($data) {	# ʳΤȤѸִ롼
			return $self->search($tag, $cmd, \@cmd);
		}
	}
	# ̤ΤΥޥ
	return "\[$cmd_line\]";
}

#--------------------------------------------------------------------
# ɽ
#--------------------------------------------------------------------
sub footnote {
	my ($self, $note) = @_;
	my $footnote = $self->{footnote};

	# ƱƤϡƱfootnote򻲾Ȥ
	my $number;
	my $name;
	my $name_txt;
	my $name_base = $self->{footnote_name_base} || "$self->{unique_linkname}n";
	my $note_buf = $self->{note_buf};
	if (exists $note_buf->{$note}) {	# Ʊ᤬
		$number = $note_buf->{$note};
		$name     = "f$name_base$number";
		$name_txt = "$name_base$number";
	} else {
		$note_buf->{$note} = $number = (++ $self->{footnote_no});
		$name     = "f$name_base$number";
		$name_txt = "$name_base$number";
		push(@$footnote, <<HTML);
	<p class="footnote"><a href="$self->{thisurl}#$name_txt" name="$name">*$number</a> : $note</p>
HTML
	}
	$self->tag_delete($note);
	$note =~ s/"/&quot;/g;

	return "<span class=\"footnote\"><a title=\"$note\" href=\"$self->{thisurl}#$name\" name=\"$name_txt\">*$number</a></span>";
}

#--------------------------------------------------------------------
# ɽν
#--------------------------------------------------------------------
sub output_footnote {
	my ($self, $out, $footnote) = @_;
	my $no_section = $self->{no_div_section};
	my $indent     = $self->{indent};
	if (@$footnote) {
		if (! $no_section) { push(@$out, "$indent</div>\n"); }

		push(@$out, "$indent<div class=\"footnote\">\n");
		foreach(@$footnote) {
			push(@$out, "$indent$_");
		}

		if ($no_section)   { push(@$out, "$indent</div>\n"); }
	}
}

#------------------------------------------------------------------------------
# ˡ롼
#------------------------------------------------------------------------------
#--------------------------------------------------------------------
# htmlִ
#--------------------------------------------------------------------
sub html_tag {
	my ($self, $tag, $ary) = @_;
	my ($name, $class) = split('\.', $tag->{html});
	if ($class ne '') { $class=" class=\"$class\""; }
	if (!@$ary) { return "<$name$class$tag->{attribute}></$name>"; }
	return "<$name$class$tag->{attribute}>" . join(':', @$ary) . "</$name>";
}

#--------------------------------------------------------------------
# Ѹִʸˡ
#--------------------------------------------------------------------
sub search {
	my ($self, $tag, $cmd, $ary) = @_;
	my $ROBJ = $self->{ROBJ};
	my $replace_data = $self->{replace_data};

	# Query 
	my $code = $tag->{option};
	my $argc = $tag->{argc};
	my $url  = $tag->{data};

	my $jcode;
	my ($reg, $val);
	my $system_coding = $ROBJ->{System_coding};
	# ʸѴ
	$code =~ tr/a-z/A-Z/;
	if ($code && $code ne 'ASCII' && ord($code) != 0x25) {	# 0x25=%
		$jcode = $self->{jcode} ||= $ROBJ->loadpm('Jcode');
	}

	if (! $argc) {	#Ŀʤ
		$argc = 1;
		$url .= '$1';
	}

	my @argv  = splice(@$ary, 0, $argc);
	if ($#$ary>=0 && $tag->{replace_html}) {
		# ΤޤޤΤȤǸϢ롣
		# 2 [color:red:xxx:yyy]  "red" / "xxx:yyy" ˤ
		$argv[$argc-1] .= ':' . join(':', @$ary);
		@$ary = ();
	}
	my @argv2 = @argv;
	$ROBJ->tag_escape(@argv2);
	my $name = join(':', @argv2);
	unshift(@argv,  $ROBJ->{Basepath});
	$url =~ s/\#(\d)/$argv[$1]/g;		# ʸѴ
	foreach(@argv) {
		if (ord($code) == 0x25) { $_ = sprintf($code, $_); }	# 0x25=%
		elsif ($jcode) { $jcode->from_to(\$_, $system_coding, $code); }
		$self->form_encode($_);
	}
	$url =~ s/\$(\d)/$argv[$1]/g;			# ʸѴ
	$url =~ s/\$\{(\w+)\}/$replace_data->{$1}/g;	# Ǥեǡִ

	# Τޤ
	if ($tag->{replace_html}) {
		$url =~ s/&quot;/"/g;
		return $url;
	}

	# ̾
	if ($ary->[0] ne '' && $ary->[0] ne 'title') { $name=join(':', @$ary); }
	if (substr($name,0,6) eq 'title=') { $name=substr($name, 6); } 
	# ȥ°
	my $title=$tag->{title};
	if ($title ne '') { $title=" title=\"$title\""; }

	# 󥯹
	return "<a href=\"$url\" class=\"$tag->{class}\"$title>$name</a>";
}

#--------------------------------------------------------------------
# ץ󥿥ʽϤʤ
#--------------------------------------------------------------------
sub option {
	my ($self, $tag, $cmd, $ary) = @_;
	$self->{options}->{$cmd} = $ary;
	return '';
}

###############################################################################
# [99] ݥȥץ
###############################################################################
sub post_process {
	my ($self, $r_data) = @_;

	# ܼ
	if ($$r_data =~ m|<toc>(.*?)</toc>|) {
		my %h;
		my $thisurl = $self->{thisurl};
		map { $h{$_}=1; } split(':', $1);
		my $class="toc";
		my $sec_format = sub { "<li><a href=\"$thisurl#$_->{name}\">$_->{title}</a>" };
		if ($h{anchor} || $h{number}) {
			$sec_format = sub { "<li>$_->{anchor} <a href=\"$thisurl#$_->{name}\">$_->{title}</a>" };
		}
		if ($h{none} || $h{number}) { $class .= " none"; }
		# ܤꥹȺ
		my @ary;
		push(@ary, "<ul class=\"$class\">\n");
		foreach(@{ $self->{sections} }) {
			my $subs = $self->{subsections}->{ $_->{section_count} };
			if ($subs && @$subs) {
				push(@ary, "\t" . &$sec_format() . "\n");
				push(@ary, "\t<ul class=\"$class\">\n");
				foreach(@$subs) {
					push(@ary, "\t\t" . &$sec_format() . "\n");
				}
				push(@ary, "\t</ul></li>\n");
			} else {
				push(@ary, "\t" . &$sec_format() . "\n");
			}
		}
		push(@ary, "</ul>\n");
		my $str = join('', @ary);
		$$r_data =~ s|<toc>(.*?)</toc>\n?|$str|g;
	}
	return;
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# /ˡΥסʥ󥳡ɡ
#------------------------------------------------------------------------------
# աۤ顢֥åˡΥ⽤뤳ȡ
sub tag_syntax_escape {
	my $self=shift;
	foreach(@_) {
		$_ =~ s/&/&amp;/g;
		$_ =~ s/</&lt;/g;
		$_ =~ s/>/&gt;/g;
		$_ =~ s/"/&quot;/g;		# _~^*  table ˡ
		$_ =~ s/([\[\]\{\}\(\)\|:_~^*])/'&#' . ord($1) . ';'/eg;
	}
}

#------------------------------------------------------------------------------
# ν
#------------------------------------------------------------------------------
sub tag_delete {
	my $self=shift;
	foreach(@_) {
		$_ =~ s/<\/.*?>//sg;
		$_ =~ s/<\w([^>"']|[=\s]".*?"|[=\s]'.*?')*?>//sg;
	}
}

#------------------------------------------------------------------------------
# URI󥳡
#------------------------------------------------------------------------------
sub uri_encode {
	my $self=shift;
	foreach(@_) {
		$_ =~ s/([^\.\/\~\*\-\w\#:;=\+\?&%])/'%' . unpack('H2',$1)/eg;
	}
}

sub form_encode {
	my $self=shift;
	foreach(@_) {
		$_ =~ s/([^\.\/\~\*\-\w\#:;])/'%' . unpack('H2',$1)/eg;
	}
}

#------------------------------------------------------------------------------
# class/target/title
#------------------------------------------------------------------------------
sub make_attri {
	my $self=shift;
	my ($ary, $tag, $type) = @_;

	# target/class/rel 
	my $target = $self->{"${type}_target"};
	my $class  = $self->{"${type}_class"};
	my $rel    = $self->{"${type}_rel"};
	while(1) {
		my $x = substr($ary->[0], 0, 6);
		if (substr($x, 0, 7) eq 'target=') { $target = substr(shift(@$ary), 7); next; }
		if (substr($x, 0, 6) eq 'class=' ) { $class  = substr(shift(@$ary), 6); next; }
		if (substr($x, 0, 4) eq 'rel='   ) { $rel    = substr(shift(@$ary), 4); next; }
		last;
	}
	$target =~ s/[^\w\-]//g;
	$class  =~ s/[^\w\s\-]//g;
	$rel    =~ s/[^\w\-]//g;

	if ($class ne '' && $tag->{class} ne '') { $class =" $class"; }
	if ($class ne '' || $tag->{class} ne '') { $class =" class=\"$tag->{class}$class\""; }
	if ($tag->{title} ne '') { $class .= " title=\"$tag->{title}\""; }
	if ($target ne '') { $class .=" target=\"$target\""; }
	if ($rel ne '')    { $class .=" rel=\"$rel\""; }

	# °ʸ֤
	return $class;
}
#--------------------------------------
# name 
#--------------------------------------
sub make_name {
	my $self=shift;
	my ($ary, $name) = @_;
	if ($ary->[0] ne '') { $name=join(':', @$ary); }
	if (substr($name, 0, 6) eq 'title=') { $name=substr($name, 6); }
	return $name;
}

1;
