use strict;
#------------------------------------------------------------------------------
# Amazonˡץ饰
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::TextParser::TagPlugin::Tag_amazon;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# 󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;	# ɤ߼Τ
	my $ROBJ  = shift;	# ɤ߼Τ

	my $tags = shift;
	$tags->{amazon} = {data => \&amazon_search};
	$tags->{asin}   = {data => \&amazon_asin};
}

###############################################################################
# 롼
###############################################################################
#------------------------------------------------------------------------------
# Amazonˡ(Amazon search)
#------------------------------------------------------------------------------
sub amazon_search {
	my ($parser_obj, $tag, $cmd, $ary) = @_;

	my $keyword = shift(@$ary);
	my $name    = $keyword;
	# ʸѴ
	my $ROBJ = $parser_obj->{ROBJ};
	my $system_coding = $ROBJ->{System_coding};
	if ($system_coding ne 'UTF-8') {
		my $jcode = $parser_obj->{jcode} ||= $ROBJ->loadpm('Jcode');
		$jcode->from_to(\$keyword, $system_coding, 'UTF-8');
	}
	# URI󥳡
	$parser_obj->form_encode($keyword);
	my $nihongo = "%E6%97%A5%E6%9C%AC%E8%AA%9E";	# 'ܸ' by UTF-8

	# ID &tag=user-id
	my $asid = $parser_obj->{asid};
	$asid =~ s/[^\w\-\.]//g;	# ʸ
	if ($asid ne '') { $asid="&tag=$asid"; }

	# °/̾
	my $attri = $parser_obj->make_attri($ary, $tag);
	   $name  = $parser_obj->make_name ($ary, $name);

	return "<a href=\"http://www.amazon.co.jp/exec/obidos/external-search?mode=blended$asid&encoding-string-jp=$nihongo&keyword=$keyword\"$attri>$name</a>";
}

#------------------------------------------------------------------------------
# asin/isbnˡ(amazon)
#------------------------------------------------------------------------------
sub amazon_asin {
	my ($parser_obj, $tag, $cmd, $ary) = @_;

	# ID &tag=user-id
	my $asid = $parser_obj->{asid};
	$asid =~ s/[^\w\-\.]//g;	# ʸ
	# if ($asid ne '') { $asid .= '/ref=nosim'; }

	# ASIN/ISBN
	my $isbn = shift(@$ary);
	$isbn =~ s/[^\w\.]//g;	# ʸ
	my $asin = $isbn;
	$asin =~ s/\-//g;
	if (length($asin) == 13) {	# 13ISBN
		$asin = substr($asin, 3, 9);	# 4ʸܡ12ʸܼ
		# åǥåȤκƷ׻
		my $sum;
		my $x=10;
		foreach(split('', $asin)) {
			$sum += $_*($x--);
		}
		$sum = 11 - ($sum % 11);
		if ($sum == 10) { $sum='X'; }
		$asin .= $sum;
	}

	# ⡼ɡ
	if ($ary->[0] eq 'img' || $ary->[0] eq 'image' || $ary->[0] eq 'detail') {
		shift(@$ary);
		return &amazon_asin_image($parser_obj, $tag, $cmd, $ary, $isbn, $asin, $asid);
	}

	# °/̾
	$cmd =~ tr/a-z/A-Z/;
	my $attri = $parser_obj->make_attri($ary, $tag);
	my $name  = $parser_obj->make_name ($ary, "$cmd:$isbn");

	return "<module name=\"popup-image\" href=\"http://www.amazon.co.jp/exec/obidos/ASIN/$asin/$asid\" image_url=\"images-jp.amazon.com/images/P/$asin.09.MZZZZZZZ.jpg\"$attri>$name</a>";
}

#------------------------------------------------------------------------------
# asin/isbn - imageˡ(amazon)
#------------------------------------------------------------------------------
sub amazon_asin_image {
	my ($parser_obj, $tag, $cmd, $ary, $isbn, $asin, $asid) = @_;

	# ǧ
	my $size = '.09.MZZZZZZZ.jpg';	# midium
	if ($ary->[0] eq 'large') {
		shift(@$ary);
		$size = '.09.LZZZZZZZ.jpg';
	} elsif ($ary->[0] eq 'small') {
		shift(@$ary);
		$size = '.09.THUMBZZZ.jpg';
	}
	my $size_tag;
	if    ($ary->[0] =~ /^w(\d+%?)$/) { $size_tag=" width=\"$1\"";  shift(@$ary); }
	elsif ($ary->[0] =~ /^h(\d+%?)$/) { $size_tag=" height=\"$1\""; shift(@$ary); }

	# ȥ
	$cmd =~ tr/a-z/A-Z/;
	my $attri = $parser_obj->make_attri($ary, $tag, 'image');
	my $name  = $parser_obj->make_name ($ary, "$cmd:$isbn");
	$name =~ s/"/&quot;/g;

	return "<a href=\"http://www.amazon.co.jp/exec/obidos/ASIN/$asin/$asid\"$attri><img src=\"http://images-jp.amazon.com/images/P/$asin$size\" alt=\"$name\" class=\"asin\"$size_tag></a>";
}


1;
