#!/usr/local/bin/perl
use 5.6.0;
use strict;
#-------------------------------------------------------------------------------
# ꤫ΥХ adiaryĥ ver.1.07
#                       Copyright(C)2007 ꤫ / ꤫
#-------------------------------------------------------------------------------
# Uploader.pm		Copyright(C)2006,2008 nabe@abk(Original and modified)
#-------------------------------------------------------------------------------
# ߥˤĤ
#  桼ǥ쥯ȥޤǤϺ : initalize()
#åץǥȥǥȥޤǺ : make_currentfolder()
#ͥ񤭹ִ֤˥ͥǥ쥯ȥ
#-------------------------------------------------------------------------------
package Satsuki::Uploader;
use Satsuki::AutoLoader;
#-------------------------------------------------------------------------------
our $VERSION = '1.07';
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my ($class, $ROBJ) = @_;
	my $self = {};
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ

	$self->{ROBJ} = $ROBJ;	# root object save

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ᥤ
###############################################################################
sub main {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};

	$ROBJ->read_form();		# եɤ߹
	$ROBJ->get_cookie();		# cookieɤ߹
	my $cookie = $ROBJ->{Cookie};

	#-------------------------------------------------------------
	# Cookie  Authorization 
	#-------------------------------------------------------------
	$self->{allow_upload} = 1;
	my $auth = $ROBJ->{Auth};
	my $session = $cookie->{session};
	if (ref $session eq 'HASH') {	# 󥻥å
		$auth->session_auth($session->{id}, $session->{sid});
		$ROBJ->make_csrf_check_key($session->{sid});
	}
	# Ģγǧ
	if (! $auth->{ok}) {
		if ($ROBJ->{Diary}->{image_album_deny_noauth}) {
			return $self->error("Operation not permitted");
		} else {
			$self->{allow_upload} = 0;
		}
	}

	#-------------------------------------------------------------
	# ȥ PATH (URL) ù
	#-------------------------------------------------------------
	my $pinfo = $ROBJ->read_path_info();	# PATH_INFOɤ߹
	# 裱 : diary_id
	my $diary_id = $self->{diary_id} = shift(@$pinfo);
	$diary_id =~ s/\W//g;
	$self->{diary_id} = $diary_id;
	# Ģγǧ
	if (!$DB->find_table("${diary_id}_diary")) {
		return $self->error('Can not find daybook "%s"', $diary_id);
	}

	#-------------------------------------------------------------
	# ³ǧ
	#-------------------------------------------------------------
	my $auth_id = $auth->{id};
	if ($diary_id ne $auth_id && !$auth->{admin}) {
		my $Diary = $ROBJ->{Diary};
		my $file  = $ROBJ->get_filepath($Diary->{setting_dir} . $diary_id . $Diary->{file_ex});
		my $set   = $ROBJ->fread_hash_cached($file);

		my $flag = 1;
		my @admin_users = split(/\s*,\s*/, $set->{admin_users});
		my @edit_users  = split(/\s*,\s*/, $set->{edit_users});
		foreach(@admin_users, @edit_users) {
			if ($_ eq $auth_id) { $flag=0; last; }
		}
		if ($auth->{ok} && ($set->{edit_users} eq '*' || $set->{admin_users} eq '*')) {
			$flag=0;
		}
		if ($flag) {
			$self->{allow_upload} = 0;
		}
	}

	#-------------------------------------------------------------
	# Ķ/ѿ 
	#-------------------------------------------------------------
	$self->initalize();
	
	#-------------------------------------------------------------
	# Query
	#-------------------------------------------------------------
	my $query = $ENV{QUERY_STRING};
	$query =~ s/&.*//;	# & ʹߤ̵
	$self->{query} = $query;
	$self->{query} =~ s/%([0-9a-fA-F][0-9a-fA-F])/chr(hex($1))/eg;
	$ROBJ->form_encode( $self->{query} );
	my @query;
	$self->{query_ary} = \@query;
	if (index($query,'=') < 0) {	# = ޤޤʤ
		$query =~ s/[^\w\/\-\+]//g;
		@query = split('/', $query);
	}

	#-------------------------------------------------------------
	# action (POST) ν
	#-------------------------------------------------------------
	if ($ROBJ->{POST}) {
		$self->{action_data} = $ROBJ->call_action( $ROBJ->{Form}->{action} );
	}

	#-------------------------------------------------------------
	# ڡ
	#-------------------------------------------------------------
	my $skelton = shift(@query);
	if ($skelton eq '') {
		$skelton = $self->{default_skelton};
	} else {
		my $file = $ROBJ->check_skelton($skelton);
		if (! defined $file || substr($skelton,0,1) eq '_') {
			return $self->error("Operation not permitted");
		}
	}
	# 
	$self->output_html($skelton);
	return 0;
}

###############################################################################
# ɽ
###############################################################################
#------------------------------------------------------------------------------
# HTMLȽ
#------------------------------------------------------------------------------
sub output_html {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my ($skelton) = @_;

	my $out;
	if ($self->{action_is_main}) {
		$out = $self->{action_data}
	} else {
		$out = $ROBJ->call($skelton);
	}
	# å
	if ($ROBJ->{POST} || $ROBJ->{Auth}->{ok} || $self->{no_cache}) {	# POST/loginϤ
		$ROBJ->print_header( "Cache-Control", 'no-cache' );
	} else {
		# 餯ưʤΤǻѤʤ(2008/02/07 by nabe)
		# $ROBJ->print_lastmodified();
	}

	$ROBJ->print_content_type($self->{content_type} || "text/html");
	$ROBJ->output_array($out);	# HTML
}

#------------------------------------------------------------------------------
# 顼ɽƽλ
#------------------------------------------------------------------------------
sub error {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	$ROBJ->message(@_);
	$self->output_html( $self->{error_skelton} );
	return 1;
}
###############################################################################
# ȥѥ֥롼
###############################################################################
#------------------------------------------------------------------------------
# եꥹȤμ
#------------------------------------------------------------------------------
sub load_folderlist {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};

	# եꥹȤΥ
	my $data = $self->{user_info}->{dir_list};
	if (!$data && $self->update_folderlist()) {
		return $ROBJ->error('Can not create folder list');
	}

	# ɤ߹
	my @list = split("\n", $data);
	@list = map { 
		chomp();
		my ($name, $path) = split(/\t/);
		{name => $name, path=>$path}
	} @list;
	return \@list;
}

#------------------------------------------------------------------------------
# ꥹȤμ
#------------------------------------------------------------------------------
sub imagelist {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};

	# ե¸ǥ쥯ȥ
	my $dir    = $self->{user_dir};
	my $subdir = $self->{currentfolder};
	if($subdir == -1){ return -1; }
	$dir .= $subdir;
	my $thumb_dir = $self->{thumbnail_dir};
	my $dirfull = $ROBJ->get_filepath($dir);	# եѥ

	my %h;
	$h{i} = $self->{diary_id};
	$h{b} = $ROBJ->{Basepath};
	$h{u} = $self->{image_dir};
	$h{d} = $subdir;
	$h{h} = $ROBJ->{Server_url};
	$h{'%'} = '%';

	my $allow_ex_img_hash = $self->{allow_ex_img_hash};
	my $hidden_hash = $ROBJ->array2hash( $self->{hidden_files} );

	my $idx = 0;
	my @filelist;
	my $list = $ROBJ->search_files($dir, "", 0);
	foreach(@$list){
		my $filename  = $_;
		my $thumbname = $self->{thumbnail_dir}.$filename.".jpg";

		# ꥹȤɽʤե
		if ($_ =~ /^\./ || $hidden_hash->{$_}) { next; }

		# ĥȽ
		my $file_ex='';
		if ($filename =~ /\.([^\.]+)$/) {
			$file_ex = $1;
			$file_ex =~ tr/A-Z/a-z/;
		}
		my $is_image=0;
		if ( $allow_ex_img_hash->{$file_ex}) { $is_image=1; }

		# ͥ뤬̵к
		my $thumb_error = $self->make_thumbnail($dirfull.$filename, $dirfull.$thumbname, $file_ex);

		# 
		my $thumbpath = $dir.$thumbname;
		if ($thumb_error){
			# ĥҤ˹碌ƥ
			$thumbpath = $self->{album_icons}.$self->{etc_icons}->{'.'};
			if(exists( $self->{etc_icons}->{$file_ex})){
				$thumbpath = $self->{album_icons}.$self->{etc_icons}->{$file_ex}
			}
		}

		# եμ
		my ($filesize, $date) = (stat($dirfull.$filename))[7, 9];
		$date = $ROBJ->tm_printf("%Y/%m/%d %H:%M:%S", $date);

		# 
		$h{f} = $filename;
		$h{s} = $filesize;
		$h{e} = $file_ex;
		# 
		my ($tag, $tag_orig);
		if (! $is_image){
			$tag = $self->{upload_tag_etc};
			$tag =~ s/%(\w)/$h{$1}/g;
			$tag_orig = $tag;
		}else{
			$tag_orig = $self->{upload_tag};	# ɸλ
			$tag_orig =~ s/%(\w)/$h{$1}/g;
			if ($thumb_error) {
				$tag = $tag_orig;
			}else{
				$tag = $self->{upload_tag_thumbnail};
				$tag =~ s/%(\w)/$h{$1}/g;
			}
		}

		# ܸե̾ޤޤƤȤΤ˥󥳡ɤƤ
		my $filepath  = $dir.$filename;
		$ROBJ->tag_escape ($filename);
		$ROBJ->form_encode($filepath, $thumbpath);

		push(@filelist, 
			{"index" => $idx, "name" => $filename, 
			 "path" => $filepath, "thumbnail" => $thumbpath, 
			 "tag" => $tag, "tag_orig" => $tag_orig, 
			 "filesize" => $filesize, "date" => $date, 
			 "is_image" => $is_image }
		);
		$idx++;
	}

	return \@filelist;	# 
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# ꤵ줿 diary_id ǴĶѿˤ
#------------------------------------------------------------------------------
# diary_id ֤ǤΤ߸Ƥ֤ȡ
sub initalize() {
	my $self = shift;
	my $diary_id = shift;
	my $ROBJ = $self->{ROBJ};

	if ($diary_id eq '') { $diary_id = $self->{diary_id} }
	$diary_id =~ s/\W//g;
	if ($diary_id eq '') { $ROBJ->message("Internal Error"); return -1; }

	my $dir = $self->{image_dir} . $diary_id . '/';
	if (! -e $ROBJ->get_filepath("$dir$self->{trashbox_dir}")) {
		$ROBJ->mkdir($self->{image_dir});
		$ROBJ->mkdir($dir);
		$ROBJ->mkdir($dir . $self->{trashbox_dir});	# Ȣ
	}

	# ѿ
	$self->{myself}   = $ROBJ->{Myself2} . $diary_id;
	$self->{myself2}  = $self->{myself} . '/';
	$self->{diary_id} = $diary_id;
	$self->{user_dir} = $dir;
	$self->{user_dir_path} = $ROBJ->get_filepath($dir);
	# Хθ̾ʥǥ쥯ȥ
	my $info_file = "$self->{user_dir}$self->{album_info_file}";
	$self->{user_info_file} = $info_file;
	{
		my $skelton_file = $ROBJ->check_skelton( $self->{folderlist_skelton} );
		my $skelton_tm   = $ROBJ->get_file_lastmodified( $skelton_file );
		my $info_tm      = $ROBJ->get_file_lastmodified( $info_file    );
		if ($skelton_tm > $info_tm) { $self->update_folderlist(); }		# 
	}
	$self->{user_info} = $ROBJ->fread_hash_no_error( $info_file ) || {};
	# ȥե
	$self->set_currentfolder();

	# ĥҤΥϥå岽
	$self->{allow_ex_img_hash} = $ROBJ->array2hash( $self->{allow_ex_img} );
	$self->{allow_ex_etc_hash} = $ROBJ->array2hash( $self->{allow_ex_etc} );
	return 0;
}

#------------------------------------------------------------------------------
# ͥʲ/¾̡
#------------------------------------------------------------------------------
# ˤϼ¥ѥͿ뤳ȡ
sub make_thumbnail {
	my $self = shift;
	my $orig_file  = shift;		# ¥ѥǤ뤳!!
	my $thumb_file = shift;		# ¥ѥǤ뤳!!
	my $file_ex    = shift;
	my $thumbnail_size = shift;	# ά
	if (-r $thumb_file) { return 0; }	# ¸ߤ = Success
	if ($self->load_image_magick()) { return -1; }	# 

	# ĥҼФ
	if (!defined $file_ex && $orig_file =~ /\.([^\.]+)$/) {
		$file_ex = $1;
		$file_ex =~ tr/A-Z/a-z/;
	}

	# ڤʬ
	# make_thumbnail_*() is exists in "Uploader_auto.pm".
	if( $self->{allow_ex_img_hash}->{$file_ex} ){
		return $self->make_thumbnail_image($orig_file, $thumb_file, $file_ex, $thumbnail_size);
	} else {
		return $self->make_thumbnail_etc  ($orig_file, $thumb_file, $file_ex, $thumbnail_size);
	}
}

#------------------------------------------------------------------------------
# ȥեμ
#------------------------------------------------------------------------------
sub set_currentfolder {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $pinfo = $ROBJ->{Pinfo};

	my $alias = $self->{alias};
	my $path  = $self->{user_dir_path};
	my $thumb_dir = $self->{thumbnail_dir};
	my $subdir;
	my $subdir_name;
	my $depth=0;
	foreach(@$pinfo) {
		if ($_ eq '') { last; }
		my $dir = "$_/";
		# ꥢ̵Ƭ . 
		if ($alias->{$dir} eq '' && $_ =~ /^\./) { last; }
		# ǥ쥯ȥ꤬ɤ߽Ф뤫
		if (!-r "$path$subdir$dir") { last; }
		$subdir      .= $dir;
		$subdir_name .= $alias->{$dir} || $dir;
		$depth++;
	}
	# ѿʤѤ make_currentfolder ѹ뤳ȡ
	$self->{currentfolder_name}  = $subdir_name;
	$self->{currentfolder_depth} = $depth;
	$self->{currentfolder} = $subdir;	# Ǹɾ  
}

#------------------------------------------------------------------------------
# Image::MagickΥ
#------------------------------------------------------------------------------
sub load_image_magick {
	my $self = shift;
	if (! $self->{make_thumbnail}) { return -1; }
	if (exists $self->{try_image_magick}) { return $self->{try_image_magick}; }
	eval { require 'Image/Magick.pm'; };
	return ($self->{try_image_magick} = ($@) ? 1 : 0); # 0=Success 1=Error
}

1;	# ޤʤ
