# 2007/02/16
#==============================================================================
# unload_package_pp_patched dynamic patch.
# [EUC-JP] Satsuki::Autoloder ؤб
#==============================================================================
# Reference : perldoc perlref
#
package patches::ModPerl::Util;
#use strict "refs";
use strict "vars";
use strict "subs";
my $DEBUG = 0;

$ModPerl::Util::DEFAULT_UNLOAD_METHOD ||= "patches::ModPerl::Util::unload_package";
#==============================================================================
sub unload_package {
	my ($package) = @_;
	my $names = \%{ $package . '::' };

	# Package for Satsuki::Autoload?
	my $autofile;
	if (! %$names){
		if ($package !~ /^(.*?)_auto\d?$/) { return; }
		$package  = $1;
		$names    = \%{ $package . '::' };
		$autofile = 1;
	}
	# Package file name
	my $package_file = $package;
	$package_file =~ s/::/\//g;
	if (!exists $INC{"$package_file.pm"}) {
		$DEBUG && warn "[not-exists] $package\n";
		# return ;
	}
	$DEBUG && warn "[package] $package\n";

	while (my ($k,$v) = each(%$names)) {
		if ($k =~ /::$/) { next; }
		if (*{$v}{IO}) {
			if (fileno $v) { close $v; }
		}
		# if (defined &$v) { undef &$v; }
		undef $$v;
		undef @$v;
		undef %$v;
		delete ${ $package . '::' }{$k};
	}

	# Delete package loaded information for require
	delete $INC{"$package_file.pm"};
	$DEBUG && warn "[delete from \%INC] $package_file.pm\n";
	my $auto = $package_file . '_auto';	# for Satsuki::AutoLoader
	while(my($k,$v) = each(%INC)) {
		if (index($k, $auto) == 0) {
			$DEBUG && warn "[delete from \%INC] $k\n";
			delete $INC{$k};
		}
	}

	# reload for Autoloader basefile
	# if ($autofile) { require $package . '.pm'; }
}


1;
__END__
